function setService (service,from,no) {

	if (!service) service = { from:from, no:no }
	service.fromClass = 'Other';
	service.domain = service.from;
	service.url = '';
	service.extraRequired = false;
	service.passRequired = false;
	service.cookiesRequired = false;
	service.oneByOne = false;
	service.ignoreText = false;

	switch(service.from) {
		case 'www.adobe.com':
			service.fromClass = 'Adobe';
			service.url = 'https://store1.adobe.com/cfusion/store/html/index.cfm';
			service.extraRequired = true;
			service.passRequired = true;
			service.cookiesRequired = true;
			break;
		case 'www.apple.com':
		case 'www.apple.com/zip':
		case 'www.apple.com/japan':
		case 'www.apple.com/japanzip':
		case 'www.apple.com/hk':
			service.fromClass = 'Apple';
			switch (service.from) {
				case 'www.apple.com':
				case 'www.apple.com/zip':
					service.from = 'www.apple.com';
					service.url = 'https://store.apple.com/us/order/list';
					break;
				case 'www.apple.com/japan':
				case 'www.apple.com/japanzip':
					service.from = 'www.apple.com/japan';
					service.url = 'https://store.apple.com/jp/order/list';
					break;
				case 'www.apple.com/hk':
					service.url = 'https://store.apple.com/hk-zh/order/list';
					break;
			}
			service.extraRequired = true;
			break;
		case 'www.aramex.com':
			service.fromClass = 'Aramex';
			service.url = 'http://www.aramex.com/express/track.aspx';
			service.cookiesRequired = true;
			break;
		case 'auspost.com.au':
			service.fromClass = 'AusPost';
			service.url = 'http://auspost.com.au/track/track.html';
			service.cookiesRequired = true;
			break;
		case 'em.canadapost.ca':
			service.fromClass = 'CanadaPost';
			service.url = 'http://www.canadapost.ca/cpotools/apps/track/personal/findByTrackNumber';
			break;
		case 'www.city-link.co.uk':
			service.fromClass = 'CityLink';
			service.url = 'http://www.city-link.co.uk/';
			break;
		case 'www.dhl.com':
		case 'track.dhl-usa.com':
			service.from = 'www.dhl.com';
			service.fromClass = 'DHL';
			service.url = 'http://www.dhl.com/en/express/tracking.html';
			break;
		case 'www.dhlglobalmail.com':
			service.fromClass = 'DHL';
			service.url = 'http://webtrack.dhlglobalmail.com/';
			break;
		case 'nolp.dhl.de':
		case 'nolp.dhl.de/int':
			service.from = 'nolp.dhl.de';
			service.fromClass = 'DHL';
			service.url = 'http://www.dhl.de/';
			break;
		case 'www.dhl.co.uk':
			service.fromClass = 'DHL';
			service.url = 'http://track.dhl.co.uk/tracking/';
			break;
		case 'www.dpd.com':
			service.fromClass = 'DPD';
			service.url = 'http://www.dpd.net/index.php?id=43727&language_id=1';
			break;
		case 'www.fedex.com':
		case 'spportal.fedex.com':
			service.from = 'www.fedex.com';
			service.fromClass = 'FedEx';
			service.url = 'https://www.fedex.com/Tracking?action=track&language=english&cntry_code=us';
			break;
		case 'www.gls-germany.com':
			service.fromClass = 'GLS';
			service.url = 'http://www.gls-group.eu/';
			break;
		case 'checkout.google.com':
			service.fromClass = 'Google';
			service.url = 'https://checkout.google.com/';
			service.extraRequired = true;
			service.passRequired = true;
			service.cookiesRequired = true;
			break;
		case 'www.hlg.de':
			service.fromClass = 'HLG';
			service.url = 'https://www.myhermes.de/wps/portal/PRIPS_DEU/SENDUNGSSTATUS';
			service.oneByOne = true;
			break;
		case 'www.hongkongpost.com':
			service.fromClass = 'HongkongPost';
			service.url = 'http://app3.hongkongpost.com/CGI/mt/enquiry.jsp';
			break;
		case 'www.japanpost.jp/ems':
		case 'www.japanpost.jp/m10':
		case 'www.japanpost.jp/reg':
		case 'www.japanpost.jp/yupack':
			service.fromClass = 'JapanPost';
			var lang = (translate('Japan Post') == '日本郵便') ? 'jp' : 'en';
			switch (service.from) {
				case 'www.japanpost.jp/reg':
					var kind = 'S001';
					break;
				case 'www.japanpost.jp/yupack':
					var kind = 'S002';
					break;
				case 'www.japanpost.jp/m10':
					var kind = 'S003';
					break;
				case 'www.japanpost.jp/ems':
					var kind = 'S004';
					break;
			}
			service.url = 'http://tracking.post.japanpost.jp/service/numberSearch.do?locale='+lang+'&searchKind='+kind;
			break;
		case 'www.laposte.fr':
			service.fromClass = 'LaPoste';
			service.url = 'http://www.colissimo.fr/portail_colissimo/suivre.do';
			break;
		case 'www.ontrac.com':
			service.fromClass = 'OnTrac';
			service.url = 'https://www.ontrac.com/tracking.asp';
			break;
		case 'www.parcelforce.com':
			service.fromClass = 'Parcelforce';
			service.url = 'http://www2.parcelforce.com/track-trace';
			break;
		case 'www.post.at':
			service.fromClass = 'Post-at';
			service.url = 'https://nachschau.post.at/Default.aspx?lang='+translate('xx');
			break;
		case 'www.postdanmark.dk':
			service.fromClass = 'PostDanmark';
			service.url = 'http://www.postdanmark.dk/contentfull.dk?lang='+translate('xx');
			break;
		case 'www.poste.it/posta1':
		case 'www.poste.it/pacco1':
		case 'www.poste.it/maxi':
		case 'www.poste.it':
		case 'www.poste.it/pacco':
		case 'www.poste.it/ems':
			service.fromClass = 'Poste-it';
			service.url = 'http://www.poste.it/online/dovequando/';
			break;
		case 'www.posten.no':
			service.fromClass = 'Posten-no';
			service.url = 'http://sporing.posten.no/';
			break;
		case 'www.posten.se':
			service.fromClass = 'Posten-se';
			service.url = 'http://www.posten.se/';
			break;
		case 'www.postnl.nl':
		case 'www.tntpost.nl':
			service.fromClass = 'PostNL';
			service.url = 'https://tracktrace.postnlpakketten.nl/search/searchbasic.aspx';
			service.cookiesRequired = true;
			service.oneByOne = true;
			service.ignoreText = true;
			break;
		case 'www.purolator.com':
			service.fromClass = 'Purolator';
			service.url = 'http://www.purolator.com/track.html';
			break;
		case 'www.royalmail.com':
			service.fromClass = 'RoyalMail';
			service.url = 'http://www2.royalmail.com/track-trace';
			break;
		case 'www.sagawa-exp.co.jp':
			service.fromClass = 'Sagawa';
			service.url = 'http://k2k.sagawa-exp.co.jp/';
			break;
		case 'www.post.ch':
			service.fromClass = 'SwissPost';
			service.url = 'http://www.post.ch/';
			break;
		case 'www.tnt.com':
		case 'www.tnt.com/ref':
			service.fromClass = 'TNT';
			service.url = 'http://www.tnt.com/webtracker/tracker.do?navigation=1&respLang=en&respCountry=US';
			break;
		case 'www.ups.com':
		case 'wwwapps.ups.com':
			service.from = 'www.ups.com';
			service.fromClass = 'UPS';
			service.url = 'http://wwwapps.ups.com/WebTracking/processInputRequest?loc=en_US';
			break;
		case 'www.ups-mi.net':
			service.fromClass = 'UPS';
			service.url = 'http://www.ups-mi.net/packageID/';
			break;
		case 'www.usps.com':
			service.fromClass = 'USPS';
			service.url = 'https://tools.usps.com/go/TrackConfirmAction';
			break;
		case 'www.kuronekoyamato.co.jp':
			service.fromClass = 'Yamato';
			service.url = 'http://toi.kuronekoyamato.co.jp/cgi-bin/tneko';
			break;
		case 'www.amazon.com':
		case 'www.amazon.ca':
		case 'www.amazon.co.uk':
		case 'www.amazon.co.jp':
		case 'www.amazon.de':
		case 'www.amazon.at':
		case 'www.amazon.es':
		case 'www.amazon.fr':
		case 'www.amazon.it':
			if (service.domain == 'www.amazon.at') service.domain = 'www.amazon.de';
			service.fromClass = 'Amazon';
			service.url = 'https://'+service.domain+'/gp/css/homepage.html';
			service.extraRequired = true;
			service.passRequired = true;
			service.cookiesRequired = true;
			break;
		case 'other':
			service.url = service.extra;
			break;
		default:
			service = false;
			break;
	}
	return service;

}

function setServiceByNumber (no,allowed) {
	var result = false;
	var guessArray = guessFrom(no,false);
	if (guessArray) {
		var from = guessArray[0];
		if (allowed.indexOf(from) != -1) result = setService(false,from,no);
	}
	return result;
}

function setServiceByString (string,substring,no) {
	var result = false;
	var from = false;
	if (string) string = string.toLowerCase();
	// if (substring) substring = substring.toLowerCase();
	switch (string) {
		case 'fedex':	from = 'www.fedex.com';		break;
		case 'ontrac':	from = 'www.ontrac.com';	break; // just guessing
		case 'ups':		from = 'www.ups.com';		break;
		case 'usps':	from = 'www.usps.com';
			if (substring && substring.toLowerCase() == 'usps_sp_nat_std') from = 'www.fedex.com';
			break;
	}
	if (from) result = setService(false,from,no);
	return result;	
}

function updateStatus () {
	if (this.passRequired && (!this.password || this.password == ' ')) {
		this.count = 0;
		this.notFound();
		this.updateItems();
	} else {
		if (!iPhone) this.startLoad();
		this.resetRequests(true);
		this.success = 2;
		this.showMessage(translateFormat('Contacting %@…',this.fromTrans));
		if (this.items.length > 0) this.previousItems = this.items;
		this.startUpdate(this,false);
	}
}

function startUpdate (service,childNo) {
	switch(service.from) {

		case 'www.adobe.com':
	
			service.url = 'https://store1.adobe.com/cfusion/store/html/index.cfm?store=OLS-US&event=displayOrderDetail&ordernumber='+
				encodeURIComponent(service.no);	
			var postData = 'event=login&up_login=yes&has_pwd=true&rememberMe=true&up_username='+encodeURIComponent(service.extra)+'&up_password='+encodeURIComponent(service.password)+'&submit_button=Continue&returnURL=%2Fcfusion%2Fstore%2Fhtml%2Findex.cfm%3Fstore%3DOLS-US%26event%3DdisplayOrderDetail%26ordernumber%3D'+encodeURIComponent(service.no)+'%26nr%3D0';
	
			this.loadCookiePage(service.url,sessionAdobe,postData,false);
			break;
	
		case 'www.apple.com':
		case 'www.apple.com/zip':
	
			service.url = 'https://store.apple.com/us/order/guest/'+encodeURIComponent(service.no)+'/'+doublePlusEncode(service.extra);
			this.loadPage(service.url,getApple,false,false);
			break;
	
		case 'www.apple.com/japan':
		case 'www.apple.com/japanzip':
	
			service.url = 'https://store.apple.com/jp/order/guest/'+encodeURIComponent(service.no)+'/'+doublePlusEncode(service.extra);
			this.loadPage(service.url,getApple,false,false);
			break;
	
		case 'www.apple.com/hk':
			service.url = 'https://store.apple.com/hk-zh/order/guest/'+encodeURIComponent(service.no)+'/'+doublePlusEncode(service.extra);
			this.loadPage(service.url,getApple,false,false);
			break;
	
		case 'www.aramex.com':
	
			service.url = 'http://www.aramex.com/express/track_results_multiple.aspx?ShipmentNumber='+encodeURIComponent(service.no)+'&TrackType=EXP,DOM,FRT';	
			var args = setArgs('Aramex',childNo);
			this.loadCookiePage(service.url,getTracker,false,args);
			break;
	
		case 'auspost.com.au':
	
			var url = 'http://auspost.com.au/track/track.html';
			var postData = 'trackIds='+encodeURIComponent(service.no);
			service.url = url+'?'+postData;
			var args = setArgs('AusPost',childNo);
			this.loadCookiePage(url,getTracker,postData,args);
			break;
	
		case 'em.canadapost.ca':
	
			var args = setArgs('CanadaPost',childNo);
			args.lang = (translate('xx') == 'fr') ? 'fr' : 'en';
			service.url = 'http://www.canadapost.ca/cpotools/apps/track/personal/findByTrackNumber?trackingNumber='+
				encodeURIComponent(service.no)+'&LOCALE='+args.lang;
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.city-link.co.uk':
	
			service.url = 'http://www.city-link.co.uk/dynamic/track.php?parcel_ref_num='+encodeURIComponent(service.no)+'&postcode='+encodeURIComponent(service.extra);
			var args = setArgs('CityLink',childNo);
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.dhl.com':
		case 'track.dhl-usa.com':
	
			var args = setArgs('DHL',childNo);
			url = service.url = 'http://www.dhl.com/content/g0/en/express/tracking.shtml?brand=DHL&AWB='+
				encodeURIComponent(service.no.replace(/ /g,''));
			if (childNo !== false) {
				this.loadPage(url,getTracker,false,args);
			} else this.loadPage(url,getMultiple,false,args);
			break;
	
		case 'www.dhlglobalmail.com':
	
			var args = setArgs('DHL GlobalMail',childNo);
			url = service.url = 'http://webtrack.dhlglobalmail.com/?trackingnumber='+encodeURIComponent(service.no);
			this.loadPage(url,getTracker,false,args);
			break;
	
		case 'nolp.dhl.de':
		case 'nolp.dhl.de/int':
	
			var extra = (this.skipExtra) ? '' : service.extra;
			var args = setArgs('DHL (Germany)',childNo);
			args.lang = (translate('xx') == 'de') ? 'de' : 'en';
			args.extra = extra;
			url = service.url = 'http://nolp.dhl.de/nextt-online-public/set_identcodes.do?lang='+
				args.lang+'&idc='+encodeURIComponent(service.no)+'&zip='+encodeURIComponent(extra);
			this.loadPage(url,getMultiple,false,args);
			break;
	
		case 'www.dhl.co.uk':
	
			var args = setArgs('DHL UK',childNo);
			url = service.url = 'http://track.dhl.co.uk/tracking/wrd/run/wt_xhistory_pw.execute?PCL_INST=1&CNTRY=GB&PCL_NO='+encodeURIComponent(service.no);
			this.loadPage(url,getTracker,false,args);
			break;
	
		case 'www.dpd.com':
	
			var args = setArgs('DPD',childNo);
			args.lang = (translate('Germany') == 'Deutschland') ? 'de' : 'uk';
			service.url = 'https://extranet.dpd.de/cgi-bin/delistrack?typ=1&lang='+args.lang+
				'&pknr='+encodeURIComponent(service.no)+'&submit=Search';
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.fedex.com':

			service.url = 'https://www.fedex.com/Tracking?action=track&language=english&cntry_code=us&initial=x&tracknumbers='+encodeURIComponent(service.no);
			if (childNo !== false) {
				var args = setArgs('FedEx',childNo);
				this.loadPage(service.url,getTracker,false,args);
			} else this.loadPage(service.url,getFedEx,false,false);
			break;
	
		case 'www.gls-germany.com':
	
			var args = setArgs('GLS',childNo);
			switch(translate('Germany')) {
				case 'Deutschland':	args.lang = 'DE03/DE';	break;
				case 'Tyskland':	args.lang = 'DK01/DA';	break;
				case 'Allemagne':	args.lang = 'FR01/FR';	break;
				default:			args.lang = 'NL99/EN';	break;
			}
			service.url = 'http://www.gls-group.eu/276-I-PORTAL-WEB/content/GLS/'+args.lang+
				'/5004.htm?txtAction=71000&txtRefNo='+encodeURIComponent(service.no);
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'checkout.google.com':
	
			service.url = 'https://checkout.google.com/view/receipt?t='+encodeURIComponent(service.no);
			var url = 'https://checkout.google.com/m/confirm?action=LOGOUT_USER&skip=true&continueUrl=https://checkout.google.com/m/main&cancelUrl=https://checkout.google.com/m/main'; 
			this.loadCookiePage(url,getGoogle,false,false);
			break;
	
		case 'www.hlg.de':
	
			url = 'https://www.myhermes.de/wps/portal/PRIPS_DEU/SENDUNGSSTATUS';
			service.url = (iPhone) ? url : 'http://tracking.hlg.de/Tracking.jsp?TrackID='+encodeURIComponent(service.no.replace(/[^0-9]/g,''));
			this.loadPage(url,getHermes,false,false);
			break;
	
		case 'www.hongkongpost.com':
	
			var args = setArgs('HongkongPost',childNo);
			service.url = 'http://app3.hongkongpost.com/CGI/mt/genresult.jsp?tracknbr='+encodeURIComponent(service.no);
			// Chinese: http://app3.hongkongpost.com/CGI/mt/c_genresult.jsp?tracknbr=
			this.loadPage(service.url,getHongkong,false,args);
			break;
	
		case 'www.japanpost.jp/ems':
		case 'www.japanpost.jp/m10':
		case 'www.japanpost.jp/reg':
		case 'www.japanpost.jp/yupack':
	
			var args = setArgs('JapanPost',childNo);
			args.lang = (translate('Japan Post') == '日本郵便') ? 'jp' : 'en';
			switch (service.from) {
				case 'www.japanpost.jp/reg':	var kind = 'S001';	break;
				case 'www.japanpost.jp/yupack':	var kind = 'S002';	break;
				case 'www.japanpost.jp/m10':	var kind = 'S003';	break;
				case 'www.japanpost.jp/ems':	var kind = 'S004';	break;
			}
			service.url = 'http://tracking.post.japanpost.jp/service/singleSearch.do?searchKind='+kind+'&locale='+args.lang+
				'&SVID=020&reqCodeNo1='+encodeURIComponent(service.no);
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.laposte.fr':
	
			var args = setArgs('LaPoste',childNo);
			var no = service.no.replace(/ /g,'');
			service.url = 'http://www.colissimo.fr/portail_colissimo/suivre.do?parcelnumber='+encodeURIComponent(no);
			var url = 'http://www.laposte.fr/widgetcourrier/php/suiviCourrierJSONproxy.php?code='+encodeURIComponent(no);
			this.loadPage(url,getJSON,false,args);
			break;
	
		case 'www.ontrac.com':
	
			var args = setArgs('OnTrac',childNo);
			service.url = 'https://www.ontrac.com/trackingres.asp?tracking_number='+encodeURIComponent(service.no);
			this.loadPage(service.url,getOnTrac,false,args);
			break;
	
		case 'www.parcelforce.com':
	
			service.url = 'http://www2.parcelforce.com/track-trace?trackNumber='+encodeURIComponent(service.no);
			this.loadPage(service.url,getParcelforce,false,false);
			break;
	
		case 'www.post.at':
	
			var args = setArgs('Post.at',childNo);
			service.url = 'https://nachschau.post.at/SendungsSuche.aspx?lang='+translate('xx')+'&pnum1='+encodeURIComponent(service.no);
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.postdanmark.dk':
	
			var args = setArgs('PostDanmark',childNo);
			args.lang =  (translate('xx') == 'da') ? 'IND' : 'INE';
			service.url = 'http://www.postdanmark.dk/tracktrace/TrackTrace.do?i_stregkode='+encodeURIComponent(service.no)+
				'&i_lang='+args.lang+'&sourceurl=http://www.postdanmark.dk/tracktrace/';
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.poste.it/posta1':
		case 'www.poste.it/pacco1':
		case 'www.poste.it/maxi':
		case 'www.poste.it':
		case 'www.poste.it/pacco':
		case 'www.poste.it/ems':
	
			var args = setArgs('Poste-it',childNo);
			var kind = '';
			switch (service.from) {
				case 'www.poste.it/posta1':	kind = 'POSTA1';	break;
				case 'www.poste.it/pacco1':	kind = 'PACCO1';	break;
				case 'www.poste.it/maxi':	kind = 'POSTA';		break;
				case 'www.poste.it':		kind = '';			break;
				case 'www.poste.it/pacco':	kind = 'PACCO';		break;
				case 'www.poste.it/ems':	kind = 'EMS';		break;
			}
			if (kind) {
				service.url = 'http://javapc.poste.it/tracking/trackingPacchi?Action=ActionCore&Method=Tracking&PRODOTTO='+
					kind+'&ID_LDV='+encodeURIComponent(service.no);
			} else service.url = 'http://javapc.poste.it/tracking/trackingPacchi?Action=ActionTracking&Method=Tracking&ldv='+
				encodeURIComponent(service.no);
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.posten.no':
	
			var args = setArgs('Posten-no',childNo);
			args.lang =  (translate('xx') == 'no') ? 'no' : 'en';
			service.url = 'http://sporing.posten.no/sporing.html?layout=normal&lang='+args.lang+'&q='+encodeURIComponent(service.no);
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.posten.se':
	
			var args = setArgs('Posten-se',childNo);
			args.lang = (translate('xx') == 'sv') ? 'SE' : 'GB';
			if (service.no.match(/^[a-z]{2}/i)) {
				service.url = 'http://www.posten.se/tracktrace/TrackConsignments_do.jsp?trackntraceAction=saveSearch&lang='+
					args.lang+'&consignmentId='+encodeURIComponent(service.no);
				args.type = 1;
			} else {
				service.url = 'http://server.logistik.posten.se/servlet/PacTrack?lang='+args.lang+
					'&xslURL=/xsl/pactrack/standard.xsl&kolliid='+encodeURIComponent(service.no);
				args.type = 0;
			}
			this.loadPage(service.url,getMultiple,false,args);
			break;
	
		case 'www.postnl.nl':
		case 'www.tntpost.nl':
	
			var args = setArgs('PostNL',childNo);
			service.url = 'https://tracktrace.postnlpakketten.nl/search/searchbasic.aspx?B='+encodeURIComponent(service.no);
			service.url += (service.extra) ? '&P='+encodeURIComponent(service.extra) : '&I=True';
			this.loadPage(service.url,getPostNL,false,args);
			break;
	
		case 'www.purolator.com':
	
			var args = setArgs('Purolator',childNo);
			args.lang = (translate('xx') == 'fr') ? 'F' : 'E';
			service.url = 'https://eshiponline.purolator.com/SHIPONLINE/Public/Track/TrackingDetails.aspx?pin='+encodeURIComponent(service.no)+'&lang='+args.lang;
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.royalmail.com':
	
			service.url = 'http://www2.royalmail.com/track-trace?track=track&trackNumber='+encodeURIComponent(service.no);
			var args = setArgs('RoyalMail',childNo);
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.sagawa-exp.co.jp':
	
			service.url = 'http://k2k.sagawa-exp.co.jp/p/web/okurijosearch.do?okurijoNo='+encodeURIComponent(service.no);
			var args = setArgs('Sagawa',childNo);
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.post.ch':
	
			service.url = 'https://www.post.ch/EasyTrack/submitParcelData.do?formattedParcelCodes='+encodeURIComponent(service.no)+';&p_language='+translate('xx');
			var args = setArgs('SwissPost',childNo);
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.tnt.com':
		case 'www.tnt.com/ref':
	
			var mode = (service.from == 'www.tnt.com/ref') ? 'REF' : 'CON';
			service.url = 'http://www.tnt.com/webtracker/tracking.do?respLang=en&respCountry=US&searchType='+
				encodeURIComponent(mode)+'&cons='+encodeURIComponent(service.no);
			this.loadPage(service.url,getTNT,false,false);
			break;
	
		case 'www.ups.com':
	
			service.url = 'http://wwwapps.ups.com/WebTracking/processInputRequest?sort_by=status&tracknums_displayed=1&TypeOfInquiryNumber=T&loc=en_US&track.x=0&track.y=0&InquiryNumber1='+encodeURIComponent(service.no);	
			var args = setArgs('UPS',childNo);
			if (childNo !== false) {
				this.loadPage(service.url,getTracker,false,args);
			} else this.loadPage(service.url,getMultiple,false,args);
			break;
	
		case 'www.ups-mi.net':
	
			service.url = 'http://www.ups-mi.net/packageID/packageid.aspx?pid='+encodeURIComponent(service.no);
			var args = setArgs('UPS Mail Innovations',childNo);
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.usps.com':
	
			service.url = 'https://tools.usps.com/go/TrackConfirmAction.action?tLabels='+encodeURIComponent(service.no);	
			var args = setArgs('USPS',childNo);
			this.loadPage(service.url,getTracker,false,args);
			break;
	
		case 'www.kuronekoyamato.co.jp':
	
			url = 'http://toi.kuronekoyamato.co.jp/cgi-bin/tneko';
			postData = 'number00=1&number01='+encodeURIComponent(service.no);
			service.url = 'http://otodoke.kuronekoyamato.co.jp/otodoke/servlet/jp.co.kuronekoyamato.otodoke.jikan.browser.S_CRTMENQ0000?id='+
				encodeURIComponent(service.no.replace(/-/g,''));
			var args = setArgs('Yamato',childNo);
			this.loadPage(url,getTracker,postData,args);
			break;
	
		case 'www.amazon.com':
		case 'www.amazon.ca':
		case 'www.amazon.co.uk':
		case 'www.amazon.co.jp':
		case 'www.amazon.de':
		case 'www.amazon.at':
		case 'www.amazon.es':
		case 'www.amazon.fr':
		case 'www.amazon.it':
	
			service.url = 'https://'+service.domain+'/gp/css/summary/edit.html?ie=UTF8&orderID='+encodeURIComponent(service.no);
			var url = 'http://'+service.domain+'/gp/flex/sign-out.html/ref=ya__lo?ie=UTF8&path=%2Fgp%2Fcss%2Fhomepage.html&useRedirectOnSuccess=1&action=sign-out';
			this.loadCookiePage(url,sessionAmazon,false,false);
			break;
	
		case 'other':
	
			service.url = service.extra;
			if (service.url) {
				if (!service.url.match(/^https?:\/\//i)) service.url = 'http://'+service.url;
				this.loadPage(service.url,getOther,false,false);
			} else {
				if (!iPhone) updateOther(this);
				this.updateItems();
			}
			break;
	
		default:
	
			if (this == service) {
				this.count = 0;
				this.items = [];
				this.displayed = 0;
			}
			this.updateItems();
			break;
	
	}
}

function sessionAdobe () {
	var delivery = this.delivery;
	delivery.loadCookiePage(delivery.url,getAdobe,false,false);
	delivery.reqComplete++;
}

function getAdobe () {

	var delivery = this.delivery;
	var sections = false;
	var items = false;
	var result = false;
	var thisResult = false;
	var status = false;
	var trackingUrl = false;
	var x = 0;
	var y = 0;
	var z = 0;

	if (this.responseText) {

		output = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = output;

		// Get each section of the order
		sections = output.match(/<td colspan="5"> ?<strong> ?Package(.*?)(<tbody ?class="?pckg-ovw"?>|<\/table>)/gi);

		for (y in sections) {

			var item = resetItem();

			// Get the name and status of this section
			result = sections[y].match(/Package [0-9]+:<\/strong> ?(<span[^>]*>)?([^\*<]*)/i);

			if (result) {

				if (result[2]) status = result[2];
				if (status.match(/^shipped/i)) {
	
					// Get the ship date for shipped items
					result = status.match(/shipped on (.*)/i);
					if (result && result[1]) item.shipSaved = result[1];
					status = 'Shipped';

				} else if (status.match(/^pre-order/i)) {

					// Get the ship date for pre-orders
					result = status.match(/pre-order estimated availability date (.*)/i);
					if (result && result[1]) item.shipSaved = result[1];

				} else if (status.match(/^expected arrival/i)) {

					// Get the ship date for pre-orders
					result = status.match(/expected arrival date (.*)/i);
					if (result && result[1]) item.deliverSaved = result[1];

				}
				item.status = status;

				// Get the tracking number for shipped items
				result = sections[y].match(/Tracking Number:<\/strong> ?(<a href="?https?:\/\/([^\/]*)[^>]*>)? ?([^<]*)/i);

				if (result && result[3]) {
					var trackingFrom = (result[2]) ? trim(result[2]) : false;
					var trackingNo = trim(result[3]);
					var service = setService(false,trackingFrom,trackingNo);
					if (!service) service = setServiceByNumber(trackingNo,
						['www.dhl.com','www.dhlglobalmail.com','www.fedex.com','www.ups.com','www.usps.com']);
					if (service) delivery.startUpdate(service,y);
				}

				// Get each item in the section
				items = sections[y].match(/<tr[^>]*> ?<td[^>]*> ?<strong>(<span[^>]*>[^<]*<\/span>)?([^<]*)/gi);
				var firstItem = true;
				for (z in items) {

					// Get the name of the item
					result = items[z].match(/<strong>(<span[^>]*>[^<]*<\/span>)?([^<]*)/i);
					if (result && result[2]) {
						if (firstItem) {
							firstItem = false;
							item.title = (delivery.name) ? htmlEntities(delivery.name)+": "+result[2] : result[2];
						} else item.title += ", "+result[2];
					}
		
				}

				if (x == 0) delivery.items = [];
				delivery.items[x] = item;
				x++;

			}

		}

		delivery.count = delivery.items.length;
		if (!delivery.items[0]) delivery.count = 0;

	} else delivery.count = -1;

	if (delivery.count <= 0) {

		// Check for an error message. Doesn't seem to work, but it should...?
		result = output.match(/<span class="required">([^<]*)/i);
		if (result && result[1]) {
			delivery.notFound(result[1]);
		} else delivery.notFound();

	}
	delivery.reqComplete++;
	delivery.updateItems();

	return;

}

function sessionAmazon () {

	var delivery = this.delivery;
	if (this.responseText) {

		delivery.showMessage(translate('Getting delivery status…'));
		var output = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = output;

		if (output && (result = output.match(/<form[^>]*name=.?signIn.?[^>]*action="([^"]*)[^>]*>(.*?)<\/form>/i))) {

			var url = result[1];
			if (url.charAt(0) == '/') url = 'https://'+delivery.domain+url;

			var postData = 'openid.return_to=https%3A%2F%2F'+delivery.domain+'%2Fgp%2Fcss%2Fsummary%2Fedit.html%3Fie%3DUTF8%26orderID%3D'+encodeURIComponent(delivery.no)+'&openid.pape.max_auth_age=ape%3AOTAw&create=0&email='+encodeURIComponent(delivery.extra)+'&password='+encodeURIComponent(delivery.password);
			var inputs = result[2].match(/<input.*?>/gi);
			for (y in inputs) {
				if (result = inputs[y].match(/name="(.*?)".*?value="(.*?)"/i)) {
					var name = result[1];
					if (name != 'create' && name != 'openid.return_to' && name != 'openid.pape.max_auth_age' && 
						name != 'email' && name != 'password') postData += '&'+name+'='+encodeURIComponent(result[2]);
				}
			}
			delivery.loadCookiePage(url,getAmazon,postData,false);

		} else delivery.loadCookiePage(delivery.url,getAmazon,false,false);

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getAmazon () {

	var delivery = this.delivery;
	var sections = false;
	var items = false;
	var result = false;
	var thisResult = false;
	var status = '';
	var trackingUrl = false;
	var x = 0;
	var y = 0;
	var yy = 0;
	var z = 0;

	if (this.responseText) {

		output = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = output;

		// Get each section of the order
		sections = output.match(/<a name="?(un)?shipped-items(-[0-9]*)?"?>(.*?)<\/table> ?<br \/>/gi);
		if (!sections) sections = output.match(/<a name="?(un)?shipped-items(-[0-9]*)?"?>(.*)/gi);

		for (y in sections) {

			var item = resetItem();

			// Get the name and status of this section
			result = sections[y].match(/<b class="?sans"?>([^:]*): ?([^<]*)/i);
			if (result) {

				item.title = '';

				if (result[2]) {
					status = result[2];
					if (status.match(/(Not Yet Shipped|Not Yet Dispatched|Noch nicht versandt|À expédier|Non ancora spedito)/i)) status = '';
				}

				if (status.match(/^shipped/i)) {
	
					// Get the ship date for shipped items
					result = status.match(/shipped on (.*)/i);
					if (result && result[1]) item.shipSaved = result[1];
					status = 'Shipped';
	
				} else {

					// Get ship date for the japanese store, possibly others
					result = status.match(/([0-9]{4}\/[0-9]{1,2}\/[0-9]{1,2})/i);
					if (result && result[1]) item.shipSaved = result[1];

					// Get ship date for the german store, possibly others
					result = status.match(/([0-9]{1,2}[^a-z]{1,2}[a-z]*.?[0-9]{4})/i);
					if (result && result[1]) item.shipSaved = result[1];

				}
				item.status = status;

				// Get the tracking number for shipped items
				result = sections[y].match(/<a href="(https:\/\/[^\/]*)?(\/gp\/css\/shiptrack\/[^"]*)">/i);
				if (result && result[2]) {
					if (result[1]) {
						trackingUrl = result[1]+result[2];
					} else trackingUrl = 'https://'+delivery.domain+result[2];

					var data = getData(trackingUrl);
					var service = false;
					if (data['carrierId'] && data['trackingNumber']) service = 
						setServiceByString(data['carrierId'],data['shipMethod'],data['trackingNumber']);
					if (service) {
						delivery.startUpdate(service,x);
					} else {
						var args = setArgs('AmazonTracker',x);
						delivery.loadCookiePage(trackingUrl,getTracker,false,args);
					}
				}

				// Check if this shipment is split up
				subSections = sections[y].match(/(.*?)(<hr size="-1" noshade="noshade" color="#CCCC99" \/>|$)/gi);

				for (yy in subSections) {
					if (subSections[yy]) {

						if (yy > 0) var item = resetItem();

						// Get the shipping and delivery estimate for this section
						// First check for it with the sub arrow, then without
						var result = subSections[yy].match(/<td(?: valign="top")?>.?(?:<font[^>]*><b>)?.?<b>([^<]*)<\/b>([^<]+)<br \/>[^<]*<img src="?[^"]*arrow_subordinate(?:\.[^\.]*)?\.gif"?[^>]*\/>.?<b>[^<]*<\/b>([^<]*)(?!<\/td>)/i);						
						if (result && result[2]) {
							item.shipSaved = splitDate(result[2]);
							if (result[3]) item.deliverSaved = splitDate(result[3]);
						} else {

							result = subSections[yy].match(/<td(?: valign="top")?>.?(?:<font[^>]*><b>)?.?<b>([^<]*)<\/b>([^<]*)(?:<br \/>.?<b>[^<]*<\/b>([^<]*))?(?!<\/td>)/i);

							// When two pre-order shipments are grouped into one, the date gets lost for the first. This should catch it.
							subResult = subSections[yy].match(/<tr valign="top"> .?<td valign="top"> .?<b>([^<]*)<\/b>([^<]*)/i);
							if (subResult && trim(subResult[2])) result = subResult;

							if (result && result[2]) {
								if (result[1].match(/(Shipping estimate|Dispatch estimate|発送予定日|Voraussichtliches Versanddatum|Date d'envoi estimée|Date d&#39;envoi estim&eacute;e)/i)) {
									item.shipSaved = splitDate(result[2]);
									if (result[3]) item.deliverSaved = splitDate(result[3]);
								} else item.deliverSaved = splitDate(result[2]);
							}
						}
			
						// Get each item in the section
						items = subSections[yy].match(/<td colspan="1" valign="top">(.*?)<br \/>/gi);
						var firstItem = true;
						for (z in items) {
							// Get the name of the item
							result = items[z].match(/>([^>]*)(<\/a>|<br \/>)/i);
							if (result && result[1]) {
								if (firstItem) {
									firstItem = false;
									item.title = (delivery.name)?htmlEntities(delivery.name)+": "+result[1]:result[1];
								} else item.title += ", "+result[1];
							}
						}

						if (x == 0) delivery.items = [];
						delivery.items[x] = item;
						x++;

					}
				}

			}

		}

		delivery.count = x;
		if (!delivery.items[0] || delivery.items[0].title == translate('Unknown Item')) delivery.count = 0;

	}

	if (delivery.count == 0) {
		if (delivery.tries < 2) {
			delivery.tries++;
		} else {
			delivery.tries = 0;

			// Check for an error message. message_error only needed for new login method?
			result = output.match(/(?:<div id="message_error"[^>]*>|<div class="message error"[^>]*>).*?<h6>[^<]*<\/h6> ?<p>(.*?)<\/p> ?<\/div>/i);
			if (!result) result = output.match(/<br \/><font color="#990000">([^<]*)/i); // only used for old login method
			if (result && result[1]) {
				// Strip extra text from old login errors
				result = (result[0].match(/<font color="#990000">/)) ? result[1].replace(/(\. |。).*/i,'$1') : result[1];
				delivery.notFound(result);
			} else {
				if (output.match(/<body> ?<div style="width: 90%; margin-left: 5%"> ?<h2>/)) delivery.count = -1;
				delivery.notFound();
			}
		}
	} else delivery.tries = 0;

	if (delivery.tries == 0) {
		delivery.reqComplete++;
		delivery.updateItems();
	} else {
		this.sessionAmazon = sessionAmazon;
		this.sessionAmazon();
	}

	return;

}

function getApple () {

	var delivery = this.delivery;
	var result = false;
	var thisResult = false;
	var cancelledItems = false;
	var x = 0;

	if (this.status == 200 && this.responseText) {

		output = stripWhiteSpace(this.responseText);
		// Cached HTML gives a JavaScript error
		// if (iPhone) delivery.html = output;

		// Get each section of the order
		var sections = output.match(/<li class="delivery-group">(.*?)<\/ul> ?<\/div> ?<\/div> ?<\/div> ?<\/li>/gi);

		for (var y in sections) {

			var sectionShipped = false;
			var sectionDelivered = false;
			var status = false;
			var trackingUrl = false;
			var item = resetItem();

			// Get the status of this section, otherwise assume it's the same as the previous item
			result = sections[y].match(/<h4[^>]*> ?<span[^>]*>([^<]*)/i);
			if (result && result[1]) status = trim(result[1]);

			// Skip replaced or cancelled items
			// Not sure if "Replaced with New Product" or "Returns Completed" are still used
			if (!status.match(/^(Cancelled|Replaced with New Product|Returns Completed)$/i)) {

				if (status.match(/^(Shipped|出荷完了|已出貨)$/i)) {

					// Get the ship date for shipped items
					result = sections[y].match(/<span class="h5"> ?(?:日付：|日期為：)?([^<]*)/i);
					if (result && result[1]) {
						sectionShipped = reorderInternationalDate(result[1]);
						trackingUrl = false;
					}

					// Get the tracking number for shipped items
					result = sections[y].match(/<a target="_blank" href="([^"]*)" class="(link|button account)">/i);
					if (!result) result = sections[y].match(/<li><a target="_blank" href="([^"]*)">/i);
					if (result && result[1]) {
						trackingUrl = result[1].replace(/&amp;/g,'&');
						if (trackingUrl.charAt(0) == '/') trackingUrl = 'https://store.apple.com'+trackingUrl;
					}
	
				}

				// Get each item in the section
				var items = sections[y].match(/(<li class="delivery-group">|<div class="media-block product-item">)(.*?)<\/div> ?<\/li>/gi);
				for (var z in items) {

					item.status = status;
					item.detailsurl = trackingUrl;

					// Get the name of the item
					result = items[z].match(/<h4 class="strong name">([^<]*)/i);
					if (result && result[1]) item.title = result[1];

					if (sectionShipped) item.shipSaved = sectionShipped;
					if (sectionDelivered) item.deliverSaved = sectionDelivered;
	
					thisResult = items[z].match(/(?:Estimated Delivery|Delivers on|Delivers by|Delivers|お届け予定日：|運送日期):? ?([^<]*)/);
					if (thisResult && thisResult[1]) {
						var deliverString = thisResult[1].replace(/via [A-Z.\s]+/i,'');
						item.deliverSaved = reorderInternationalDate(splitDate(deliverString));
					}

					thisResult = items[z].match(/(?:Estimated Shipping|Ships by|Estimated Ship|Ships|出荷日：|已上市):? ?([^<]*)/);
					if (thisResult && thisResult[1]) {
						// Fix ugly stuff like Ships: Ships by October 12th
						var shipString = splitDate(thisResult[1].replace(/(?:Estimated Shipping|Ships by|Estimated Ship|Ships|出荷日：|已上市):?/,''));
						thisResult = shipString.match(/(?:Estimated Delivery|Delivers on|Delivers by|Delivers|お届け予定日：|運送日期):? ?([^<]*)/);
						if (thisResult && thisResult[1]) {
							if (!item.deliverSaved) item.deliverSaved = thisResult[1];
							shipString = shipString.replace(thisResult[0],'');
						}
						if (trim(shipString)) item.shipSaved = reorderInternationalDate(shipString);
					}

					if (z == 0) {
						if (!sectionShipped) sectionShipped = item.shipSaved;
						if (!sectionDelivered) sectionDelivered = item.deliverSaved;
					}

					var lastItem = false;
					if (x == 0) {
						delivery.items = [];
					} else lastItem = delivery.items[x-1];

					if (lastItem && 
						item.status == lastItem.status && 
						item.shipSaved == lastItem.shipSaved && 
						item.deliverSaved == lastItem.deliverSaved &&
						item.detailsurl == lastItem.detailsurl) {

						lastItem.title += ', '+item.title;

					} else {

						delivery.items[x] = item;	
						if (trackingUrl) {
	
							var args = setArgs(false,x);
							result = trackingUrl.match(/carrierURL=https?%3A%2F%2F([^%]*)/i);
							if (!result) result = trackingUrl.match(/https?:\/\/([^\/]*)/i);
	
							if (result && result[1]) {
								// Not supported: servicos.rapidaocometa.com.br
								if (result[1] == 'www.fedex.com') {
									args.site = 'FedEx';
									trackingUrl = trackingUrl.replace(/^http:/,'https:');
									delivery.loadPage(trackingUrl,getTracker,false,args);
								} else if (result[1] == 'www.ups.com' || result[1] == 'wwwapps.ups.com') {
									args.site = 'UPS';
									trackingUrl = trackingUrl.replace(/loc%3D[a-z]{2}_[A-Z]{2}/,'loc=en_US');
									delivery.loadPage(trackingUrl,getTracker,false,args);
								} else if (result[1] == 'applestore.bridge-point.com') {
									args.site = 'BridgePoint';
									delivery.loadPage(trackingUrl,getTracker,false,args);
								} else if (result[1] == 'apple.mytracking.net') {
									args.site = 'MyTracking';
									delivery.loadPage(trackingUrl,getTracker,false,args);
								} else if (result[1] == 'www.tnt.com') {
									args.site = 'TNT';
									delivery.loadPage(trackingUrl,getTracker,false,args);
								} else if (result[1] == 'www.purolator.com') {
									args.site = 'Purolator';
									delivery.loadPage(trackingUrl,getTracker,false,args);
								} else if (result[1] == 'toidirect.kuronekoyamato.co.jp') {
									args.site = 'Yamato';
									delivery.loadPage(trackingUrl,getTracker,false,args);
								} else if (result[1] == 'mrt2.ap.dhl.com') {
									var data = getData(trackingUrl);
									var service = false;
									if (data['AWB']) service = setService (service,'www.dhl.com',data['AWB']);
									if (service) delivery.startUpdate(service,x);
								}
							}
	
						}
	
						item = resetItem();
						x++;

					}

				}

			} else cancelledItems = true;

		}

		delivery.count = delivery.items.length;
		if (!delivery.items[0] || delivery.items[0].title == translate('Unknown Item')) delivery.count = 0;
		if (delivery.name) {
			var entityName = htmlEntities(delivery.name);
			for (var y in delivery.items) delivery.items[y].title = 
				entityName+": "+delivery.items[y].title;
		}

		if (x == 0) {
			if (cancelledItems) {
				delivery.count = 1;
				delivery.items[0] = resetItem();
				delivery.items[0].title = translate('No Items Found');
				delivery.items[0].shipText = translate('Your order contains only items that'); 
				delivery.items[0].shipExtra = delivery.items[0].shipText;
				delivery.items[0].deliverText = translate('have been cancelled or replaced.');
				delivery.items[0].deliverExtra = delivery.items[0].deliverText;
			} else {
				delivery.count = (this.responseText && (output = stripWhiteSpace(this.responseText)) && output.match(/(We'll be back soon|Something went wrong with your request. Please try again later.|Apple's Online and phone Order Status services are temporarily unavailable due to a scheduled upgrade to our systems|We are currently updating our systems|error in session title)/i)) ? -1 : 0;
				delivery.notFound();
			}
		}

	} else {
		delivery.count = (this.responseText && (output = stripWhiteSpace(this.responseText)) && output.match(/(We'll be back soon|Something went wrong with your request. Please try again later.|Apple's Online and phone Order Status services are temporarily unavailable due to a scheduled upgrade to our systems|We are currently updating our systems|error in session title)/i)) ? -1 : 0;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getGoogle () {

	var delivery = this.delivery;
	
	if (this.responseText) {

		output = stripWhiteSpace(this.responseText);

		if (result = output.match(/(?:The document has moved <A HREF="([^"]*)">here<\/A>|Click <a href="([^"]*)">here<\/a> if not redirected)/i)) {

			if (!result[1]) result[1] = result[2];
			var url = result[1].replace(/&amp;/g,'&');
			if (url.charAt(0) == '/') url = 'https://checkout.google.com'+url;
			delivery.loadCookiePage(url,getGoogle,false,false);

		} else if (result = output.match(/<meta[^>]*http-equiv="refresh"[^>]*content="[^"]*url=&#39;(.*?)&#39;"[^>]*>/i)) {

			var url = result[1];
			delivery.loadCookiePage(url,getGoogle,false,false);

		} else if (delivery.tries <= 3 && (result = output.match(/<a href="(https?:\/\/www.google.com\/accounts\/ServiceLogin[^"]*)"[^>]*>/i))) {

			delivery.tries++;
			var url = 'https://www.google.com/accounts/ServiceLogin?service=sierra&nui=5&ltmpl=mobilec&rm=hide&skipvpage=true&btmpl=mobile';
			delivery.loadCookiePage(url,getGoogle,false,false);

		} else if (delivery.tries <= 3 && (result = output.match(/<form.*?id="gaia_loginform".*?action= ?"([^"]*)"/i))) {

			delivery.tries++;
			var url = result[1].replace(/&amp;/g,'&');
			if (url.charAt(0) == '/') {
				url = 'https://checkout.google.com'+url;
			} else if (url.charAt(0) != 'h') {
				url = 'https://checkout.google.com/accounts/'+url;
			}	

			result = output.match(/<input type="hidden".*?name="GALX".*?value="([^"]*)"/i);
			if (result) var GALX = result[1];

			postData = 'service=sierra&continue=https%3A%2F%2Fcheckout.google.com%2Fm%2Fview%2Freceipt%3Ft%3D'+encodeURIComponent(delivery.no)+
				'%26upgrade%3Dtrue&nui=5&skipvpage=true&rm=hide&ltmpl=mobilec&btmpl=mobile&Email='+
				encodeURIComponent(delivery.extra)+'&Passwd='+encodeURIComponent(delivery.password)+'&GALX='+GALX;

			delivery.loadCookiePage(url,getGoogle,postData,false);

		} else if (delivery.tries <= 3 && (result = output.match(/<h3>\s*Purchase history\s*<\/h3>/i))) {

			delivery.tries++;
			var url = 'https://checkout.google.com/m/view/receipt?t='+encodeURIComponent(delivery.no);
			delivery.loadCookiePage(url,getGoogle,false,false);

		} else {

			delivery.tries++;
			if (iPhone) delivery.html = output;

			var sections = false;
			var result = false;
			var lastResult = false;
			var status = false;
			var details = {};
			var x = 0;
			var y = 0;

			var statusRegEx = /<ul class="progress"><li><b>([^<]*)<\/b> <span class="nb">(.*?)<\/span><\/li>/i
			var itemRegEx = /<tr><td class="item">(.*?)<\/tr>/gi

			// Get the main order status and date
			result = output.match(statusRegEx);
			if (result && result[1]) {
				details.date = result[1];
				details.status = status = result[2];
				details.location = '';
			}

			// Get each section of the order
			sections = output.match(itemRegEx);
			for (y in sections) {

				var item = resetItem();
				item.details = details;

				result = sections[y].match(/<td class="item">(.*?)<\/td>/i);
				if (result && result[1] && !result[1].match(/^(Shipping|Tax):/i)) {

					item.title = (delivery.name)?htmlEntities(delivery.name)+": "+result[1]:result[1];
					if (x == 0) delivery.items = [];

					// Get the tracking number for shipped items
					result = item.details.status.match(/<a href="([^"]*)">Track/i);
					if (result && result[1]) {
						trackingUrl = removeHtmlEntities(result[1]);
						var args = setArgs(false,x);
						result = trackingUrl.match(/https?:\/\/([^\/]*)/i);
						if (result && result[1]) {
							if (result[1] == 'wwwapps.ups.com') {
								args.site = 'UPS';
								delivery.loadPage(trackingUrl,getTracker,false,args);
							} else if (result[1] == 'www.fedex.com') {
								args.site = 'FedEx';
								delivery.loadPage(trackingUrl,getTracker,false,args);
							}
						}
					}

					delivery.items[x] = item;
					x++;
				}
	
			}
	
			delivery.count = delivery.items.length;
			if (!delivery.items[0] || delivery.items[0].title == translate('Unknown Item')) delivery.count = 0;
			if (delivery.count == 0) {

				// Check for an error message
				result = output.match(/<div class="errormsg"[^>]*>(.*?)\[<a/i);
				if (result && result[1]) {
					delivery.notFound(result[1]);
				} else delivery.notFound();
				
			}

		}

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getHermes () {

	var delivery = this.delivery;
	delivery.tries++;
	if (this.responseText) {

		output = stripWhiteSpace(this.responseText);
		if (delivery.tries == 1 && (result = output.match(/<a[^>]*href="([^"]*)"[^>]*> ?Sendungsstatus ?<\/a>/i))) {

			var url = 'https://www.myhermes.de'+result[1];
			delivery.loadPage(url,getHermes,false,false);

		} else if (delivery.tries <= 3 && (result = output.match(/<form name=".*_AuftragSucheForm" method="post" action="([^#"]*)/i))) {

			if (errorResult = output.match(/<span class="fehlermeldung">(.*?)<\/span>/i)) {
				delivery.tries = 0;
				delivery.count = 0;
				delivery.notFound(stripHTML(errorResult[1]));
			} else {
				var url = result[1];
				if (url.charAt(0) == '/') url = 'https://www.myhermes.de'+url;
				url += '?auftragsNummer='+delivery.no.replace(/\./g,'');
				delivery.loadPage(url,getHermes,false,false);
			}

		} else {

			delivery.tries = 0;
			this.args = setArgs('HLG',false);
			delivery.reqCount++;
			this.getTracker();

		}

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getHongkong () {

	var delivery = this.delivery;
	output = stripWhiteSpace(this.responseText);
	var result = output.match(/<!-- #[a-z]* --> ?<tr> ?<td> ?<a href="([^"]*)">/i);
	if (result && result[1]) {

		delivery.url = result[1].replace(/&amp;/g,'&');
		var args = setArgs('HongkongPost',false);
		args.type = 1;
		delivery.loadPage(delivery.url,getTracker,false,args);

	} else {

		this.args = setArgs('HongkongPost',false);
		this.args.type = 0;
		delivery.reqCount++;
		this.getTracker();

	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getTNT () {

	var delivery = this.delivery;
	var sections = false;
	var items = false;
	var result = false;
	var details;
	var x = 0;
	var y = 0;
	var item = resetItem();

	if (this.status == 200 && this.responseText) {

		output = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = output;

		// Get each section of the page
		sections = output.match(/<a xmlns="" name="[^"]*">(.*?)<\/table> ?<\/td> ?<\/tr> ?<\/table>/gi);

		for (y in sections) {

			result = sections[y].match(/(?:Consignment|Reference) ?<\/td> ?<td[^>]*> ?<b>([^<]*)/i);
			if (result) {

				if (delivery.name) {
					if (sections.length > 1 && result[1]) {
						item.title = htmlEntities(delivery.name)+': '+trim(result[1]);
					} else item.title = htmlEntities(delivery.name);
				} else if (trim(result[1])) {
					item.title = trim(result[1]);
				} else item.title = htmlEntities(delivery.no);

				// Get the details
				result = sections[y].match(/<tr vAlign="top"><td noWrap="true">([0-9]+ [a-z]+ [0-9]+)[^<]*<\/td><td>([^<]*)<\/td><td>([^<]*)<\/td><td>([^<]*)/i);
				if (result && result[1]) {
					item.details.date = result[1];
					item.details.location = result[3];
					item.details.status = result[4];
				}

				result = sections[y].match(/<tr valign="top"> ?<td[^>]*>[^<]*<\/td> ?<td>[^<]*<\/td> ?<td>[^<]*<\/td> ?<td>([a-z0-9\s]*)/i);
				if (result && result[1].match(/^(Delivered|Shipment Delivered)/i)) {
					item.status = 'Complete';
					item.deliverSaved = stripHTML(item.details.date);
				} else {
		
					// Get the ship date  
					result = sections[y].match(/Pick up date ?<\/td> ?<td[^>]*> ?<b>([a-z0-9\s]*)/i);
					if (result && result[1]) item.shipSaved = result[1];

					// Get the delivery date  
					result = sections[y].match(/Delivery Date ?<\/td> ?<td[^>]*> ?<b>(?:[0-9]{1,2}\:[0-9]{1,2}, )?([a-z0-9\s]*)/i);
					if (result && result[1]) item.deliverSaved = result[1];

				}

				if (x == 0) delivery.items = [];
				delivery.items[x] = item;
				item = resetItem();
				x++;

			}

		}

		if (x == 0) {
			// Check if it's a not found page or a connection error
			if (output.match(/<td colspan="3"> ?Not Found ?<\/td>/i)) {
				delivery.count = 0;
			} else if (!delivery.count) {
				delivery.count = -1;
			}
			delivery.notFound();
		} else delivery.count = delivery.items.length;

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getPostNL () {

	var delivery = this.delivery;

	if (!this.responseText) this.responseText = '';
	if (result = this.responseText.match(/Object moved to <a href="([^"]*)">here<\/a>/i)) {

		var url = unescape(result[1]);
		if (url.charAt(0) == '/') url = 'https://tracktrace.postnlpakketten.nl'+url;
		var args = setArgs('PostNL',false);
		delivery.loadCookiePage(url,getTracker,false,args);

	} else {

		this.args = setArgs('PostNL',false);
		this.args.type = 0;
		delivery.reqCount++;
		this.getTracker();

	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getFedEx () {

	var delivery = this.delivery;
	var sections = false;
	var result = false;
	var x = 0;
	var y = 0;
	var item = resetItem();

	if (this.status == 200 && this.responseText) {

		output = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = output;

		result = output.match(/<DIV id="associatedShipLink"> ?<A HREF="(.*?)">/i);
		if (result && result[1]) {

			// If this has multiple packages, look up the others.

			var url = result[1];
			if (url.charAt(0) == '/') url = 'https://www.fedex.com'+url;
			delivery.loadPage(url,getFedEx,false,false);

		} else if (sections = output.match(/<A href=\\"(\/Tracking\/Detail.*?)\\">([^<]*)/gi)) {

			// If this has multiple packages, continue looking up the others.

			for (y in sections) {

				result = sections[y].match(/<A href=\\"(\/Tracking\/Detail.*?)\\">([^<]*)/i);
				if (result && result[1]) {
	
					if (delivery.name) {
						if (sections.length > 1 && result[2]) {
							item.title = htmlEntities(delivery.name)+': '+result[2];
						} else item.title = htmlEntities(delivery.name);
					} else if (result[2]) {
						item.title = result[2];
					} else item.title = htmlEntities(delivery.no);
	
					var url = result[1];
					if (url.charAt(0) == '/') url = 'https://www.fedex.com'+url;

					var args = setArgs('FedEx',y);
					delivery.loadPage(url,getTracker,false,args);
	
					if (x == 0) delivery.items = [];
					delivery.items[x] = item;
					item = resetItem();
					x++;
	
				}
			}
			delivery.count = delivery.items.length;
			if (delivery.count == 0) delivery.notFound();

		} else if (sections = output.match(/'<input type=\\"radio\\" value=\\"(.*?)\\" name=\\"dup_number_[0-9]*\\">/gi)) {

			// If this has multiple packages, continue looking up the others.

			for (y in sections) {

				result = sections[y].match(/'<input type=\\"radio\\" value=\\"(.*?)\\" name=\\"dup_number_[0-9]*\\">/i);
				if (result && result[1]) {
	
					if (delivery.name) {
						item.title = htmlEntities(delivery.name);
					} else item.title = htmlEntities(delivery.no);
	
					var url = 'https://www.fedex.com/Tracking?action=track&language=english&cntry_code=us&initial=x&tracknumbers='+
						delivery.no+'&dup_number_0='+result[1];

					var args = setArgs('FedEx',y);
					delivery.loadPage(url,getTracker,false,args);
	
					if (x == 0) delivery.items = [];
					delivery.items[x] = item;
					item = resetItem();
					x++;
	
				}
			}
			delivery.count = delivery.items.length;
			if (delivery.count == 0) delivery.notFound();

		} else {

			this.args = setArgs('FedEx',false);
			delivery.reqCount++;
			this.getTracker();
		
		}

	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getOnTrac () {

	var delivery = this.delivery;
	if (this.responseText) {

		output = stripWhiteSpace(this.responseText);
		if ((result = output.match(/<a href="([^"]*)">DETAILS<\/a>/i))) {

			var url = result[1];
			if (!url.match(/^https?:\/\//i)) url = 'https://www.ontrac.com/'+url;
			delivery.url = url;
			delivery.loadPage(delivery.url,getTracker,false,this.args);

		} else {
			delivery.reqCount++;
			this.getTracker();
		}

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getParcelforce () {

	var delivery = this.delivery;
	if (this.status == 200 && this.responseText) {

		output = stripWhiteSpace(this.responseText);
		result = output.match(/<a href="([^"]+)" class="tracking-details-secondary">/i);
		if (result && result[1]) {

			var url = result[1].replace(/&amp;/g,'&');
			if (url.charAt(0) == '/') url = 'http://www2.parcelforce.com'+url;
			var args = setArgs('Parcelforce',false);
			args.type = 1;
			delivery.loadPage(url,getTracker,false,args);

		} else {

			this.args = setArgs('Parcelforce',false);
			this.args.type = 0;
			delivery.reqCount++;
			this.getTracker();

		}

	} else {
		if (!delivery.count) delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getJSON () {

	var delivery = this.delivery;
	var result = false;
	var site = this.args.site;
	var type = this.args.type;
	var childNo = this.args.childNo;
	var isChild = this.args.isChild;

	if ((this.status == 200 || this.status == 0) && trim(this.responseText)) {

		var deliveredString = /Delivered/i;
		var success = true;
		var foundStatus = false;
		var status;
		var details = {};
		var shipped; // ship date, not used yet
		var delivered; // delivery date, not used yet
		var errorText;

		if (!isChild) {
			var item = resetItem();
			item.title = (delivery.name) ? htmlEntities(delivery.name) : htmlEntities(delivery.no);
			delivery.items = [];
			delivery.items[childNo] = item;
		}

		try {
			var output = JSON.parse(this.responseText);
		} catch(err) {
			var output = {};
			success = false;
		}

		if (site == 'LaPoste') {
			success = output.status;
			if (output.link) delivery.url = output.link;
			details.date = output.date;
			details.status = output.message;
			// details.location not included?
			deliveredString = /(Votre colis est livré|Livraison effectuée)/i;
			if (!success) errorText = output.message;
		}

		if (!status) status = details.status;
		if (status && status.match(deliveredString)) status = 'Complete';
		if (status == 'Complete' && !delivered) delivered = details.date;
		if (details.location == undefined) details.location = '';

		if (!success) {
			delivery.tries = 0;
			delivery.count = 0;
			delivery.notFound(errorText);
		} else delivery.count = 1;

		if (delivery.items[childNo]) {
			if (status) delivery.items[childNo].status = status;
			if (details) delivery.items[childNo].details = details;
			if (shipped) delivery.items[childNo].shipSaved = shipped;
			if (delivered) delivery.items[childNo].deliverSaved = delivered;
		}

	} else {
		delivery.count = -1;
		delivery.notFound();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getMultiple () {

	var delivery = this.delivery;
	var sections = false;
	var site = this.args.site;
	var packageRegEx;
	var labelRegEx;

	if ((this.status == 200 || this.status == 0) && this.responseText) {

		output = stripWhiteSpace(this.responseText);
		if (iPhone) delivery.html = output;

		if (site == 'DHL') {
			packageRegEx = /<div id="resolveDuplicate[0-9]"[^>]*>(.*?)<a[^>]*> ?Hide Details ?<\/a> ?<\/div>/gi
		} else if (site == 'DHL (Germany)') {
			packageRegEx = /<tr[^>]*> ?<th class="explorer_spezial">(.*?)<a class="dlLink"[^>]*>[^<]*<\/a> ?<\/td> ?<\/tr>/gi;
			labelRegEx = /<th[^>]*> ?(?:Packstücknummer|Package number) ([^<]*)/i;
		} else if (site == 'Posten-se') {
			packageRegEx = /<table width="450" class="tablehead">(.*?)<\/table> ?<br> ?<div class="logo">/gi;
			labelRegEx = /Parcel id ?<\/font> ?<\/td> ?<td[^>]*>([^<]*)/i;
		} else if (site == 'UPS') {
			packageRegEx = /<!-- Begin Section Module --> ?<div class="secLvl[^"]*"> ?<fieldset> ?<form[^>]*>(.*?)<\/fieldset> ?<\/div> ?<!-- End Section Module -->/gi;
			labelRegEx = /<input[^>]*name="trackNums"[^>]*value="([^"]*)"[^>]*>/i;
		}

		if (packageRegEx && (sections = output.match(packageRegEx))) {
			for (var y in sections) {

				var item = resetItem();
				if (y == 0) delivery.items = [];

				var label = false;
				if (labelRegEx) {
					var result = sections[y].match(labelRegEx);
					if (result) label = trim(result[1]);
				}
				if (delivery.name) {
					if (sections.length > 1 && label) {
						item.title = htmlEntities(delivery.name)+': '+label;
					} else item.title = htmlEntities(delivery.name);
				} else if (label) {
					item.title = label;
				} else item.title = htmlEntities(delivery.no);

				delivery.items[y] = item;

				var args = setArgs(this.args.site,y);
				delivery.loadSection(sections[y],args);

			}
			delivery.count = delivery.items.length;
		} else {
			delivery.reqCount++;
			this.getTracker();
		}

	} else {
		delivery.reqCount++;
		this.getTracker();
	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getTracker () {

	var delivery = this.delivery;
	var result = false;
	var site = this.args.site;
	var type = this.args.type;
	var childNo = this.args.childNo;
	var isChild = this.args.isChild;

	if ((this.status == 200 || this.status == 0) && this.responseText) {

		var statusRegEx;
		var statusNo = 1;
		var detailSection;
		var detailRegEx;
		var detailDateNo;
		var detailLocationNo;
		var detailLocationNoExtra = -1;
		var detailStatusNo;
		var detailStatusNoExtra = -1;
		var detailLocRegEx;
		var shipDateRegEx;
		var deliverDateRegEx;
		var deliverLocRegEx;
		var updatedRegEx; // used if there's a second, preferred delivery date
		var deliveredRegEx;
		var deliveredTodayString;
		var deliveredString = /Delivered/i;
		var errorRegEx;
		var connectRegEx;
		var foundStatus = false;
		var status;
		var details;
		var shipped;
		var delivered;
		var errorText;
		var useCache = true;
		var removeExtraOnError = false;

		output = stripWhiteSpace(this.responseText);

		if (!isChild) {
			if (useCache && iPhone) delivery.html = cleanHTML(output,delivery.from);
			var item = resetItem();
			item.title = (delivery.name) ? htmlEntities(delivery.name) : htmlEntities(delivery.no);
			delivery.items = [];
			delivery.items[childNo] = item;
		}

		if (site == 'AmazonTracker') {

			statusRegEx = /<strong ?(?:class="alertgreen")>([^<]*)/i;
			detailRegEx = /<tr> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>(.*?)<\/td> ?<\/tr>/i;
			detailDateNo = 1;
			detailLocationNo = 3;
			detailStatusNo = 4;
			shipDateRegEx = /(?:Shipment Date|発送日|Versanddatum|Fecha de envío|Date d'expédition|Data di spedizione)(?:&nbsp;|&#160;)? ?(?::|：) ?<\/b><\/td> ?<td[^>]*>([^<]*)/i;
			deliverDateRegEx = /(?:Estimated Arrival|配送予定|Entrega estimada|Date de livraison estim&eacute;e|Arrivo previsto)(?:&nbsp;|&#160;)? ?(?::|：) ?<\/b><\/td> ?<td[^>]*>([^<]*)/i;
			// deliverLocRegEx = /(?:Destination)(?:&nbsp;|&#160;)? ?(?::|：) ?<\/b><\/td> ?<td[^>]*>([^<]*)/i;
			deliveredString = /^(Delivered|配達を完了しました|Zugestellt|Entregado|Livré|Consegnato)/i; // Entregado is a guess

		} else if (site == 'Aramex') {

			statusRegEx = /(?:<td[^>]*> ?Current Status: ?<\/td> ?<td[^>]*> ?<b> ?<span[^>]*>|<tr> ?<td valign="top" nowrap> ?1<\/a>&nbsp; ?<\/td> ?<td valign="top">[^<]*<\/td> ?<td valign="top">)([^<]*)/i;
			detailRegEx = /<tr> ?<td[^>]*>([^<]*)<\/td> <td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i;
			detailDateNo = 2;
			detailLocationNo = 1;
			detailStatusNo = 3;
			// shipDateRegEx = /<td[^>]*>([^<]*)<\/td> ?<td[^>]*>Shipment received at operations facility/i;
			deliverDateRegEx = /<td[^>]*> ?Delivered on: ?<\/td> ?<td[^>]*>([^<]*)/i;
			deliveredString = /(Delivered|Shipment Collected by Consignee)/i;

		} else if (site == 'AusPost') {

			statusRegEx = /Status: ?<\/label> ?<span[^>]*>([^<]*)/i;
			detailRegEx = /<tr> ?<td[^>]*>([^<]*)<\/td> <td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<\/tr>/i;
			detailDateNo = 1;
			detailLocationNo = 3;
			detailStatusNo = 2;
			deliveredString = /(Delivered|Shipment Collected by Consignee)/i;
			connectRegEx = /<p> ?The service is unavailable at this time. Please try again later. ?<\/p>/i;

		} else if (site == 'BridgePoint') {

			statusRegEx = detailRegEx = /<TR> ?<TD CLASS=text2[^>]*>([^<]*)<\/TD> ?<TD[^>]*>([^<]*)<\/TD> ?<\/TR>/i;
			statusNo = 1;
			detailDateNo = 2;
			detailStatusNo = 1;
			shipDateRegEx = /(?:Shipped to|Adresse d’expédition|Versendet an|Verzonden naar|Sendt til|Destino|Spedito a|Expedido para|Skickat till)<\/TD> ?<TD[^>]*>[^<]*<BR>([^<]*)/i;
			deliverDateRegEx = /<TD CLASS=large[^>]*>[^<]*<\/TD> ?<TD[^>]*>([^<]*)/i;
			deliverLocRegEx = /(?:Shipped to|Adresse d’expédition|Versendet an|Verzonden naar|Sendt til|Destino|Spedito a|Expedido para|Skickat till)<\/TD> ?<TD[^>]*>([^<]*)/i;
			deliveredString = /^(Delivered|Livré|Geliefert|Geleverd|Utlevert|Entregado|Consegnato|Entregue|Levererat)/i;

		} else if (site == 'CanadaPost') {

			statusRegEx = detailRegEx = /<tr[^>]*> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i;
			statusNo = 4;
			detailDateNo = 1;
			detailLocationNo = 3;
			detailStatusNo = 4;
			deliverDateRegEx = /(?:Date de livraison selon les normes de service|Livraison prévue|Service Standard Delivery Date|Expected Delivery)[^<]*<\/strong>:? ?(?:<b>)?([^<]*)/i;
			updatedRegEx = /(?:Updated Delivery|Livraison mise à jour)[^<]*<\/strong>:? ?(?:<b>)?([^<]*)/i;
			deliveredString = /(Item successfully delivered|Article livré avec succès)/i;
			connectRegEx = /<h2 class="errorPage" id="service_unavailable"> ?We're Sorry ?<\/h2>/i;

		} else if (site == 'CityLink') {

			statusRegEx = detailRegEx = /<tbody> ?<tr[^>]*> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)/i;
			statusNo = 3;
			detailDateNo = 1;
			detailStatusNo = 3;
			deliverDateRegEx = /Planned Delivery Date<\/[^>]*> ?<[^>]*>(?:Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday)([^<]*)/i;
			deliveredRegEx = /Current Status ?<\/span> ?<div> ?<h2>([^<]*)/i;
			deliveredString = /Delivered/i;
			errorRegEx = /<h4>Refine your search<\/h4> ?<p>(.*?) below to refine your search: ?<\/p>/i;

		} else if (site == 'DHL') {

			statusRegEx = detailRegEx = /<tr> ?<th[^>]*>([A-Z]+, ([^<]*))?<\/th> ?<th[^>]*>[^<]*<\/th> ?<th[^>]*>[^<]*<\/th> ?<th[^>]*>[^<]*<\/th> ?<\/tr> ?<\/thead> ?<tbody> ?<tr> ?<td[^>]*>[^<]*<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i;
			statusNo = 3;
			detailDateNo = 2;
			detailLocationNo = 4;
			detailStatusNo = 3;

		} else if (site == 'DHL GlobalMail') {

			statusRegEx = detailRegEx = /<tbody> ?<tr[^>]*> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i;
			
			if (output.match(statusRegEx)) {
				statusNo = 4;
				detailDateNo = 1;
				detailLocationNo = 3;
				detailStatusNo = 4;
			} else { // For iPhone
				statusRegEx = detailRegEx = /<tr[^>]*> ?<td> ?<strong>([^<]*)<\/strong> ?<br \/> ?([0-9]{1,2}\/[0-9]{1,2}\/[0-9]{1,2}) [0-9]{1,2}:[0-9]{1,2} [A-Z]+ [A-Z]+ ?in ([^<]*)/i;
				statusNo = 1;
				detailDateNo = 2;
				detailLocationNo = 3;
				detailStatusNo = 1;
			}

		} else if (site == 'DHL (Germany)') {

			statusRegEx = /<td class="status">(.*?)<\/td>/i;
			detailRegEx = /<tr> ?(<!-- ?<td[^>]*> ?-->)? ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*> ?<div[^>]*>([^<]*)<\/div> ?<\/td> ?<td[^>]*> ?<div[^>]*>([^<]*)<\/div> ?<\/td> ?<\/tr> ?<\/tbody> ?<\/table>/i;
			detailDateNo = 2;
			detailLocationNo = 3;
			detailStatusNo = 4;
			deliveredRegEx = /<div class="[a-z]*progressbar"[^>]*> ?<span>([0-9]+%)<\/span>/i;
			deliveredString = /100%/i;
			errorRegEx = /(?:<div class="error"> ?<h3>[^<]*<\/h3> ?<p>|<ul id="errorlist"> ?<li>)([^<]*)/i;
			connectRegEx = /<h3>Das System ist zur Zeit sehr ausgelastet!/i;
			removeExtraOnError = true;

		} else if (site == 'DHL UK') {

			statusRegEx = detailRegEx = /<tr> ?<TD>([^<]*)<\/TD> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)/i;
			statusNo = 1;
			detailDateNo = 2;
			detailLocationNo = 5;
			detailStatusNo = 1;
			connectRegEx = /<h1>Service Unavailable<\/h1>/i;

		} else if (site == 'DPD') {

			detailRegEx = /<tr[^>]*> ?<td[^>]*>([^<]*)<br>[^<]*<\/td> ?<td[^>]*>[^<]*(?:<img[^>]*>[^<]*<a[^>]*><b>[^<]*<\/b><\/a>)?[^<]*<br>([^<]*)<\/td> ?<td[^>]*>[^<]*(?:<img[^>]*>[^<]*<a[^>]*><b>[^<]*<\/b><\/a>)?[^<]*<br>([^<]*)<\/td>/i;
			detailDateNo = 1;
			detailLocationNo = 2;
			detailStatusNo = 3;
			deliveredString = /^(Delivered|Zustellung)/i;

			var sections = output.match(/<tr[^>]*> ?<td[^>]*>([^<]*)<br>[^<]*<\/td> ?<td[^>]*>[^<]*(?:<img[^>]*>[^<]*<a[^>]*><b>[^<]*<\/b><\/a>)?[^<]*<br>([^<]*)<\/td> ?<td[^>]*>[^<]*(?:<img[^>]*>[^<]*<a[^>]*><b>[^<]*<\/b><\/a>)?[^<]*<br>([^<]*)<\/td>/gi);
			if (sections) detailSection = sections[sections.length-1];

		} else if (site == 'FedEx') {

			statusRegEx = /<DIV CLASS="detailshipmentstatus"> ?<DIV[^>]*>([^<]*)/i;
			detailRegEx = /{"scanStatus":"(.*?)"(,"scanComments":"(.*?)")?(,"scanLocation":"(.*?)")?(,"scanTime":"(.*?)")?(,"GMTOffset":"(.*?)")?,"showReturnToShipper":(.*?),"scanDate":"(.*?)"}/i;
			detailDateNo = 11;
			detailLocationNo = 5;
			detailStatusNo = 1;
			// detailStatusNoExtra = 2;
			shipDateRegEx = /"shipDate" ?: ?"(.*?)"/i;
			// estimatedDeliveryDate should also work? deliveryDateTime shows up after delivery
			deliverDateRegEx = /"(?:estimatedDateTime)" ?: ?"(.+?)"/i;
			errorRegEx = /<div id="dupTableMsg"[^>]*>([^<]*)/i;
			connectRegEx = /<title>System Currently Unavailable<\/title>/i;

		} else if (site == 'GLS') {

			statusRegEx = detailRegEx = /<tr class="resulthead">.*?<tr[^>]*> ?<td>([^<]*)<\/td> ?<td> ?(?:[a-z]{2} [0-9]{3} )?(?:, )?([^<]*)<\/td> ?<td>[^<]*<\/td> ?<td>([^<]*)/i;
			statusNo = 3;
			detailDateNo = 1;
			detailLocationNo = 2;
			detailStatusNo = 3;
			shipDateRegEx = /(?:Pick-Up Date|Abhol-Datum|Date enlèvement|Afhentningsdato): ?<\/td> ?<td class="value"> ?([^<]*)/i;
			deliverDateRegEx = /(?:Delivery Date|Zustell-Datum|Date livraison|Leveringsdato): ?<\/td> ?<td class="value"> ?([^<]*)/i;
			deliveredString = /^(Delivered|Zugestellt|LIVRE|Forsendelsen er leveret)/i;

		} else if (site == 'HLG') {

			statusRegEx = detailRegEx = /<tr> ?<td class="content">([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)/i;
			statusNo = 5;
			detailDateNo = 4;
			detailLocationNo = 1;
			detailStatusNo = 5;
			deliveredString = /^(The consignment has been delivered|Die Sendung wurde zugestellt)/i;
			connectRegEx = /(auf Grund von Wartungsarbeiten <br> steht Ihnen unser Sendungsinformationssystem <br> im Moment leider nicht zur Verf&uuml;gung\.|Mit dem praktischen Tarifrechner wissen Sie sofort, wie g&uuml;nstig Hermes ist)/i;

		} else if (site == 'HongkongPost') {

			if (type == 1) {

				statusRegEx = detailRegEx = /<tr> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<\/tr> ?<\/table> ?<!-- #[a-z]* -->/i
				statusNo = 3;
				detailDateNo = 1;
				detailStatusNo = 3;
				detailLocationNo = 2;

			} else {

				statusRegEx = detailRegEx = /<!-- #[a-z]* --> ?(<P[^>]*> ?<IMG[^>]*> ?<a[^>]*>[^<]*<\/a> ?<\/P> ?)?<p>(<span class="textNormalBlack">[^<]*<\/span>[^<]*<\/p>)?(.*?)<br \/>/i;
				statusNo = 3;
				detailStatusNo = 3;
				shipDateRegEx = /<!-- #[a-z]* --> ?<p>.*on ([0-9]{1,2}-[a-z]+-[0-9]{4})/i;

			}
			connectRegEx = /<p> ?The Track and Trace System is (temporarily out of service|now busy), please try later\./i;

		} else if (site == 'JapanPost') {

			detailRegEx = /<tr class="number_search_data"> ?<td nowrap rowspan="2">([^<]*)(<BR>([^<]*))?<\/td> ?<td rowspan="2">([^<]*)<\/td> ?<td rowspan="2">([^<]*)<\/td> ?<td>(.*?)<td rowspan="2">[^<]*<\/td> ?<\/tr> ?<tr[^>]*> ?<td[^>]*>([^<]*)/i;
			detailDateNo = 1;
			detailLocationNo = 6;
			detailLocationNoExtra = 7;
			detailStatusNo = 4;
			detailStatusNoExtra = 5;
			deliverDateRegEx = /(?:Scheduled delivery date:|配達予定日：) ?([^<]*)/i;
			deliveredString = /(Final delivery|お届け先にお届け済み|窓口でお渡し)/i;

			var sections = output.match(/<tr class="number_search_data"> ?<td nowrap rowspan="2">([^<]*)(<BR>([^<]*))?<\/td> ?<td rowspan="2">([^<]*)<\/td> ?<td rowspan="2">([^<]*)<\/td> ?<td>(.*?<td rowspan="2">[^<]*<\/td> ?<\/tr> ?<tr[^>]*> ?<td[^>]*>[^<]*)/gi);
			if (sections) detailSection = sections[sections.length-1];

		} else if (site == 'MyTracking') {

			statusRegEx = /<span id="CurrentStatus"[^>]*>([^<]*)/i;
			detailRegEx = /<tr class="grid grid-item"> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<\/tr>/i;
			detailDateNo = 1;
			detailLocationNo = 4;
			detailStatusNo = 3;
			shipDateRegEx = /<span id="Tenderdate"[^>]*>([^<]*)/i;
			deliverDateRegEx = /<span id="ETA"[^>]*>([^<]*)/i;

		} else if (site == 'OnTrac') {

			statusRegEx = /Delivery Status:<\/b> ?<\/TD> ?<TD[^>]*>([^<]*)/i;
			detailRegEx = /<tr> ?<td[^>]*> ?<p>([^<]*)<br \/><\/p> ?<\/td> ?<td[^>]*> ?<p>([^<]*)<br \/> ?<\/p> ?<\/td> ?<td[^>]*> ?<p>([^<]*)/i;
			detailDateNo = 2;
			detailLocationNo = 3;
			detailStatusNo = 1;
			shipDateRegEx = /Ship Date:<\/b> ?<\/TD> ?<TD[^>]*>([^<]*)/i;
			deliverDateRegEx = /(?:Estimated Delivery Time|Service Commitment Time):<\/b> ?<\/TD> ?<TD[^>]*>([^<]*)/i;
			updatedRegEx = /<b>Delivery Time:<\/b> ?<\/TD> ?<TD[^>]*>(?! ?n\/a)([^<]*)/i;

		} else if (site == 'Parcelforce') {

			if (type == 0) { // summary only

				statusRegEx = detailRegEx = /<h2> ?Results ?<\/h2> ?<p>((.*?)(on ([0-9\/-]+))?) ?\.?<\/p>/i;
				statusNo = 1;
				detailDateNo = 3;
				detailStatusNo = 1;
				deliveredString = /(was delivered|as being delivered)/i;

			} else if (type == 1) { // full details

				statusRegEx = /<dd class="parcel-status">(.*?)<\/dd>/i;
				detailRegEx = /<tr> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<\/tr>/i;
				detailDateNo = 1;
				detailLocationNo = 3;
				detailStatusNo = 4;

			}
			errorRegEx = /<div class="messages error">([^<]*)/i;

		} else if (site == 'Post.at') {

			statusRegEx = detailRegEx = /<tr[^>]*> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([0-9\/\.]+)( [0-9:]+ ?[A-Z]*)?<\/td> ?<td>([^<]*)<\/td> ?<\/tr> ?<\/table>/i;
		 	statusNo = 1;
			detailDateNo = 3;
			detailLocationNo = 2;
			detailStatusNo = 1;
			deliveredString = /(Item delivered to consignee|Sendung an Empf&#228;nger &#252;bergeben|Item delivered acc. to consignees instruction|Sendung laut Empf&#228;ngervereinbarung zugestellt|Item delivered to flat mate|Sendung an Mitbewohner\/in zugestellt)/i;
			connectRegEx = /<h4> ?Die Seite kann nicht angezeigt werden/i;

		} else if (site == 'PostDanmark') {

			// Location: ( [0-9]{3,} [A-Za-z ]{3,})?
			statusRegEx = detailRegEx = /<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<\/tr> ?<\/tbody>/i;
		 	statusNo = 3;
			detailDateNo = 1;
			detailStatusNo = 3;
			deliveredString = /(Delivered|Delivered to a|Udleveret|Udleveret til)/i;
			connectRegEx = /(The Track &amp; Trace-service does not work at the moment.<br>|Track &amp; Trace-servicen fungerer desv&aelig;rre ikke i &oslash;jeblikket.<br>)/i;

		} else if (site == 'Poste-it') {

			statusRegEx = detailRegEx = /<tr[^>]*> ?<td><font[^>]*>(<b>)?([^<]+)(<\/b>)?<\/font><\/td><td><font size=1>(<b>)?([^<]+)(<\/b>)?<\/font><\/td><td><font[^>]*>(<b>)?([^<]+)(<\/b>)?<\/font><\/td> ?<\/tr>/i;

			if (output.match(statusRegEx)) {
				statusNo = 5;
				detailDateNo = 2;
				detailLocationNo = 8;
				detailStatusNo = 5;
			} else {
				statusRegEx = detailRegEx = /<tr[^>]*> ?<td><font size=1>(<b>)?([^<]+)(<\/b>)?<\/font><\/td> ?<td><font[^>]*>(<b>)?([^<]+)(<\/b>)?<\/font><\/td> ?<td><font[^>]*>(<b>)?([^<]+)(<\/b>)?<\/font><\/td> ?<td><font[^>]*>(<b>)?([^<]+)(<\/b>)?<\/font><\/td> ?<\/tr>/i;
				statusNo = 8;
				detailDateNo = 2;
				detailLocationNo = 11;
				detailStatusNo = 8;
			}
			deliveredString = /consegnat[oai]/i;
			connectRegEx = /^\s*<BR>/i;

		} else if (site == 'Posten-no') {

			statusRegEx = /<div class="sporing-sendingandkolli-latestevent-text"> ?<strong>(.*?)<\/strong>/i;
			statusRegEx = detailRegEx = /<tbody> ?<tr> ?<td> ?<div class="sporing-sendingandkolli-latestevent-text">(.*?)<\/div>(.*?)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<\/tr>/i;
			detailDateNo = 3;
			detailLocationNo = 4;
			detailStatusNo = 1;
			deliverDateRegEx = /<span id="sporing-sendingandkolli--latestevent-deliverydate"> ?<strong>([^<]*)/i;
			deliveredString = /(Package has been delivered|Sendingen er utlevert)/i;
			connectRegEx = /<div class="sporing-error-text"> ?(The service is too busy at the moment.|An error has occurred.|Tjenesten er ikke tilgjengelig for øyeblikket.|En feil har oppstått.)/i;

		} else if (site == 'Posten-se') {

			if (type == 0) { // most tracking numbers

				statusRegEx = detailRegEx = /<tr class="trListA"> ?<td valign="top" class="tdListA"> ?([^<]*)<\/td> <td[^>]*> ?([^<]*)<\/td> <td[^>]*> ?([^<]*)<\/td> <td[^>]*> ?([^<]*)<\/td> <\/tr>/i;
				statusNo = 4;
				detailDateNo = 1;
				detailLocationNo = 3;
				detailStatusNo = 4;
				if (this.args.lang == 'SE') {
					shipDateRegEx = /<td[^>]*> ?Avs&auml;nt ?<\/td> ?<td[^>]*> ?([^<]*)<\/td>/i;
					deliverDateRegEx = /<td[^>]*> ?Utl&auml;mnat ?<\/td> ?<td[^>]*> ?([^<]*)<\/td>/i;
					deliveredString = /^(Mottagaren har h&auml;mtat f&ouml;rs&auml;ndelsen)/i;
				} else {
					shipDateRegEx = /<td[^>]*> ?Shipment date ?<\/td> ?<td[^>]*> ?([^<]*)<\/td>/i;
					deliverDateRegEx = /<td[^>]*> ?Delivery date ?<\/td> ?<td[^>]*> ?([^<]*)<\/td>/i;
					deliveredString = /(Delivered from post office|Recipient has collected item)/i;
				}

			} else { // tracking numbers that start with two letters

				statusRegEx = detailRegEx = /<td class="firstcol important even">([^<]*)<\/td><td[^>]*>(?:([^,]*),)?([^<]*)<\/td>/i;
				statusNo = 3;
				detailDateNo = 1;
				detailLocationNo = 2;
				detailStatusNo = 3;
				deliverDateRegEx = /<h3>(?:Ber&auml;knad leverans|Estimated time of delivery):<\/h3>(?:Tidigast|At the earliest) ([0-9]+ [a-z]+)/i;
				deliveredString = /(överlämnad till mottagaren|Mottagaren har hämtat försändelsen$|Recipient has collected item$|Försändelsen har lämnats till mottagaren$|Försändelsen är överlämnad till mottagaren\.$|The item has been consigned to the recipient\.$)/;

			}

		} else if (site == 'PostNL') {

			statusRegEx = /<span id="ctl00_DefaultContent_fvShipment_lblStatusData">([^<]*)/i;
			detailRegEx = /<div id="[^"]*" class="columncontainerHighlight"> ?<span[^>]*>([^<:]*):?<\/span> ?<div[^>]*> ?<span[^>]*>([^<]*)<\/span> ?<span[^>]*>([^<]*)/i;
			detailDateNo = 1;
			detailLocationNo = 3;
			detailStatusNo = 2;
			deliveredString = /^(Zending afgeleverd|Parcel delivered|Shipment delivered|Sendung an der Zieladresse zugestellt|Sendung zugestellt|Sendung ausgeliefert|Sendung in Postfach eingelegt|Envoi remis|Envoi déposé dans Boîte Postale)/i;

		} else if (site == 'Purolator') {

			statusRegEx = detailRegEx = /<tr> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<\/tr>/i;
			statusNo = 3;
			detailDateNo = 1;
			detailStatusNo = 3;
			detailLocRegEx = / (?:via|par le dépôt) ([A-Z,\- ]+)/i;
			deliveredString = /^(Delivered|Livré)/;
			errorRegEx = /<div id="helpPhone" class="ErrorMessage">([^<]*)/i;
			connectRegEx = /The following errors were encountered while processing your request:/i;

		} else if (site == 'RoyalMail') {

			statusRegEx = detailRegEx = /<div id="tnt-results"> ?<h2[^>]*>([^<]*)<\/h2> ?<p>([^<]*)<\/p> ?(<p>([^<]*))?/i;
			statusNo = 1;
			detailDateNo = 3;
			detailStatusNo = 2;
			detailStatusNoExtra = 5;
			shipDateRegEx = /Your item, posted on ([0-9\/]+)/i;
			deliverDateRegEx = /(?:We have received your item and expect to deliver it (?:before the guaranteed time)?|was delivered from our [a-z\s]*|as being delivered from [a-z\s]*) on ([^.]*)/i;
			deliveredString = /Delivered/i;
			connectRegEx = /<p>This service is currently unavailable\.\s*Please try again later\.<\/p>/i;

		} else if (site == 'Sagawa') {

			output = decodeDecimalEntities(output);

			statusRegEx = detailRegEx = /詳細表示 ?<\/TD> ?<TD[^>]*> ?(?:⇒&nbsp;)?([0-9]+年[0-9]+月[0-9]+日)? ?([0-9]+:[0-9]+)? ?([^↑<]*)/i;
			statusNo = 3;
			detailDateNo = 1;
			detailStatusNo = 3;
			shipDateRegEx = /出荷日 ?<\/TD> ?<TD[^>]*> ?([0-9]+年[0-9]+月[0-9]+日)/i;
			deliveredString = /(配達は終了致しました。|配達終了)/i;

		} else if (site == 'SwissPost') {

			statusRegEx = detailRegEx = /<tr[^>]*> ?<td[^>]*>(<span[^>]*>[^<]*<\/span>)?([^>]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>(<span[^>]*>[^<]*<\/span>)?([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ? ?<\/tr> ?<\/(tbody|table)>/i;
			statusNo = 5;
			detailDateNo = 2;
			detailLocationNo = 6;
			detailLocationNoExtra = 7;
			detailStatusNo = 5;
			deliveredString = /(delivered|Zugestellt|Distribué|Distribuito|Recapitato)/i;

		} else if (site == 'TNT') {

			statusRegEx = detailRegEx = /<tr vAlign="top"><td noWrap="true">([^<]*)<\/td><td>([^<]*)<\/td><td>([^<]*)<\/td><td>([^<]*)/i;
			statusNo = 4;
			detailDateNo = 1;
			detailLocationNo = 3;
			detailStatusNo = 4;
			shipDateRegEx = /(?:Pick up date|提貨日期) ?<\/td> ?<td[^>]*> ?<b>([a-z0-9\s]*)/i;
			deliverDateRegEx = /(?:Delivery Date|送貨日期) ?<\/td> ?<td[^>]*> ?<b>(?:[0-9]+\:[0-9]+, )?([^<]*)/i;
			deliveredString = /^(Delivered|Shipment Delivered)/i;
			connectRegEx = /TNT web services are temporarily unavailable/i;

			if (isChild) {
				var sections = output.match(/<a[^>]*><br[^>]*><\/a><table[^>]*>(.*?)<\/table><\/td><\/tr><\/table>/gi);
				if (sections) output = sections[sections.length-1];
			}

		} else if (site == 'USPS') {

			statusRegEx = detailRegEx = /<td class="status"> ?<div class="td-status"> ?<p>([^<]*)<\/p> ?<\/div> ?<\/td> ?<td class="date-time"> ?<div class="td-date-time"> ?<p class="date-time sortable">([^<]*)<\/p> ?<\/div> ?<\/td> ?<td class="location"> ?<div class="td-location"> ?<p class="location sortable">([^<]*)<\/p> ?<\/div> ?<\/td>/i;
			deliverDateRegEx = /Expected Delivery By: ?<\/b> ?<br>([^<]*)/i;
			errorRegEx = /<p id="error-track" class="error invalid bold hide">(.*?)<\/p>/i;
			connectRegEx = /Sorry, the tracking system is having technical difficulties. Please try your search again later./i;

			if (output.match(statusRegEx)) {

				statusNo = 1;
				detailDateNo = 2;
				detailLocationNo = 3;
				detailStatusNo = 1;

			} else if (!output.match(errorRegEx)) {

				statusRegEx = /<span id="status">([^<]*)/i;
				detailRegEx = /<span id="summary">([^<]*)/i;
				statusNo = 1;
				detailStatusNo = 1;

			}

		} else if (site == 'UPS') {

			statusRegEx = /<h4> ?<span> ?<a[^>]*>([^<]*)/i;
			detailRegEx = /<tr[^>]*class="(?:odd|sec-row-od)"> ?<td[^>]*>([^<]*)<\/td> ?<td[^>]*>([^<]*)<\/td> ?(?:<td[^>]*>([^<]*)<\/td> ?)?<td[^<]*>([^<]*)/i;
			detailDateNo = 2;
			detailLocationNo = 1;
			detailStatusNo = 4;
			shipDateRegEx = /Shipped&#047;Billed On: ?<\/label> ?<\/dt> ?<dd[^>]*>([^<]*)/i;
			deliverDateRegEx = /(?:Scheduled Delivery|Schedule Delivery|Scheduled Delivery Updated To|Schedule Delivery Updated To|Scheduled For Early Delivery On|Delivered On|Next Delivery Attempt|Estimated Delivery): ?<\/label> ?<\/dt> ?<dd> ?(?:[a-z]*, ?&nbsp; ?)?([0-9\/]+)/i;
			deliverLocRegEx = /To: ?<\/label> ?<\/dt> ?<dd> ?<strong>([^<]*)/i;
			deliveredTodayString = /^(On Vehicle for Delivery Today)$/i;
			deliveredString = /^(Delivered|Delivered by Local Post Office)$/i;
			// (<p class="error">&gt;&gt;&gt;&nbsp;Not all tracking information is available at this time\. Please try again later\.<br><\/p>|Tracking information is not available at this time. Please try again later\.)
			connectRegEx = /<!-- SearchBodyStart --> ?<!-- SearchBodyEnd -->/i;

		} else if (site == 'UPS Mail Innovations') {

			statusRegEx = detailRegEx = /<\/tr> ?<tr> ?<td class="LeftD_Bottom[^"]*"[^>]*>(.*?)<\/td> ?<td class="LeftL_Bottom[^"]*"[^>]*>(.*?)<\/td> ?<td class="LeftL_Bottom[^"]*"[^>]*>(.*?)<\/td> ?<\/tr>/i;
			statusNo = 2;
			detailDateNo = 1;
			detailLocationNo = 3;
			detailStatusNo = 2;
			shipDateRegEx = /<tr> ?<td[^>]*>[^<]*<\/td> ?<td[^>]*>(Mail Retrieved From Shipper|Package received for processing)/i;
			deliverDateRegEx = /<span id="[a-z0-9_]*ProjDelDate">([^<]*)/i;

		} else if (site == 'Yamato') {

			statusRegEx = /<a name="AA00"\/>.*?<td class="font14">([^<]*)/i;
			detailRegEx = /<tr[^>]*> ?<td[^>]*> ?<img[^>]*> ?<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>([^<]*)<\/td> ?<td>(?:<a[^>]*>)?([^<]*)(?:<\/a>)?<\/td> ?<td>([^<]*)<\/td> ?<\/tr> ?<\/table>/i;
			detailDateNo = 2;
			detailLocationNo = 4;
			detailStatusNo = 1;
			deliverDateRegEx = /(?:お届け予定日時<\/th> ?<\/tr> ?<tr> ?<td[^>]*>[^<]*<br> ?<\/td> ?<td[^>]*>|<tr> ?<td>[^<]*<\/td> ?<td>[^<]*(?:<br>)?<\/td> ?<td>[^<]*(?:<br>)?<\/td> ?<td>(?:<a[^>]*>)?[^<]*(?:<\/a>)?<\/td> ?<td>[^<]*<\/td> ?<td>)([0-9]{1,2}\/[0-9]{1,2})/i;
			deliveredString = /^(配達完了|投函完了)/i;

		}

		// Get the ship date
		if (shipDateRegEx) {
			result = output.match(shipDateRegEx);
			if (result && result[1]) shipped = result[1];
			if (shipped == '--') shipped = false;
		}

		// Get the delivery date  
		result = output.match(deliverDateRegEx);
		if (updatedRegEx) {
			thisResult = output.match(updatedRegEx);
			if (thisResult) result = thisResult;
		}
		if (result && result[1]) {
			delivered = result[1];
			// Remove time estimates from FedEx orders if necessary
			if (site == 'FedEx') delivered = delivered.replace(/(by [0-9]{1,2}:[0-9]{2} (AM|PM))/i,'');
			if (delivered == '--') delivered = false;
		}

		// Get the status
		if (statusRegEx && (result = output.match(statusRegEx))) {
			if (result[statusNo]) {
				foundStatus = true;
				status = result[statusNo];
			} else if (site == 'Purolator' && result[2]) {
				foundStatus = true;
				status = result[2];
			}			
			status = clearEmptyString(stripHTML(status));
		}

		// Get the details
		result = (detailSection) ? detailSection.match(detailRegEx) : output.match(detailRegEx);
		if (result) {

			details = {};
			details.date = result[detailDateNo];

			var detailResult = result[detailStatusNo];
			if (site == 'Posten-no') detailResult = detailResult.replace(/\&lt;/g,'<');
			details.status = clearEmptyString(stripHTML(detailResult));

			if (detailStatusNoExtra >= 0 && result[detailStatusNoExtra]) details.status += ' '+result[detailStatusNoExtra];
			if (detailLocationNo) {
				details.location = result[detailLocationNo];
				if (detailLocationNoExtra >= 0 && result[detailLocationNoExtra]) details.location += ' '+result[detailLocationNoExtra];
			} else if (detailLocRegEx && (locationResult = details.status.match(detailLocRegEx))) {
				details.location = locationResult[1];
			}
			details.location = clearEmptyString(details.location); // also takes care of undefined

		}

		if (!status && details) status = details.status;
		if (deliveredRegEx) {
			thisResult = output.match(deliveredRegEx);			
			if (thisResult && thisResult[1] && thisResult[1].match(deliveredString)) status = 'Complete';
		} else if (status && status.match(deliveredString)) {
			status = 'Complete';
		}
		if (deliveredTodayString && status && status.match(deliveredTodayString)) {
			var date = new Date();
			delivered = (date.getMonth()+1)+'/'+(date.getDate())+'/'+(date.getFullYear());
		}

		if (details) {
			if (status == 'Complete') {
				if (!delivered) delivered = details.date;
				if (deliverLocRegEx) {
					result = output.match(deliverLocRegEx);
					if (result && result[1]) details.location = result[1];
				}
			}
			if (site == 'HongkongPost' && type == 0) {
				details.date = shipped;
				shipped = false;		
			} else if (site == 'Parcelforce') {
				if (status && !details.status) details.status = status;
			}
		}

		if (isChild) {
			if (connectRegEx && output.match(connectRegEx)) {
				if (delivery.previousItems) delivery.items = delivery.previousItems;
				status = details = shipped = delivered = false;
				delivery.notFound();
			}
		} else {
			if (!foundStatus && !shipped && !delivered && !details) {
				if (removeExtraOnError && this.args.extra) {
					delivery.skipExtra = true;
					delivery.startUpdate(delivery,false);
				} else if (connectRegEx && output.match(connectRegEx)) {
					if (!delivery.count) {
						delivery.count = -1;
					} else delivery.items = delivery.previousItems;
					delivery.notFound();
				} else if (site == 'PostNL' && delivery.tries < 1) {
					delivery.tries++;
					delivery.loadCookiePage(delivery.url,getTracker,false,this.args);
				} else {
					delivery.tries = 0;
					delivery.count = 0;
					if (errorRegEx) {
						result = output.match(errorRegEx);
						if (result) errorText = result[1];
					}
					delivery.notFound(errorText);
				}
			} else delivery.count = 1;
		}

		if (delivery.items[childNo]) {
			if (status) delivery.items[childNo].status = status;
			if (details) delivery.items[childNo].details = details;
			if (shipped) delivery.items[childNo].shipSaved = shipped;
			if (delivered) delivery.items[childNo].deliverSaved = delivered;
		}

	} else if (isChild) {

		if (delivery.previousItems) delivery.items = delivery.previousItems;
		delivery.notFound();

	} else {

		var connectRegEx = '';
		switch (site) {
			case 'UPS':
				connectRegEx = /Tracking information is not available at this time\. Please try again later\./i;
				break;
			case 'Posten-no':
				connectRegEx = /<h1>Feilmelding: Feil i underliggende system<\/h1>/i;
				break;
		}
		if (connectRegEx && this.responseText) {
			output = stripWhiteSpace(this.responseText);
			if (output.match(connectRegEx)) {
				if (!delivery.count) delivery.count = -1;
			} else delivery.count = 0;
		} else if (!delivery.count) {
			delivery.count = -1;
		}
		delivery.notFound();

	}

	delivery.reqComplete++;
	delivery.updateItems();
	return;

}

function getFromName (from,translateName,dropDown) {

	switch(from) {

		case 'www.adobe.com':
			var name = 'Adobe';
			if (dropDown) name += ' – '+translate('US and Canada');
			break;
		case 'www.apple.com':
		case 'www.apple.com/zip':
			var name = 'Apple';
			break;
		case 'www.apple.com/japan':
		case 'www.apple.com/japanzip':
			var name = 'Apple';
			if (dropDown) name += ' – '+translate('Japan');
			break;
		case 'www.apple.com/hk':
			var name = 'Apple';
			if (dropDown) name += ' – '+translate('Hong Kong');
			break;
		case 'www.aramex.com':
			var name = 'Aramex';
			break;
		case 'auspost.com.au':
			var name = 'Australia Post';
			break;
		case 'em.canadapost.ca':
			var name = (translateName) ? translate('Canada Post') : 'Canada Post';
			break;
		case 'www.city-link.co.uk':
			var name = 'City Link';
			break;			
		case 'www.dhl.com':
		case 'track.dhl-usa.com':
			var name = 'DHL';
			if (dropDown) name += ' – Express';
			break;
		case 'www.dhlglobalmail.com':
			var name = 'DHL';
			if (dropDown) name += ' – '+translate('US')+' GlobalMail';
			break;
		case 'nolp.dhl.de':
		case 'nolp.dhl.de/int':
			var name = 'DHL';
			if (dropDown) name += ' – '+translate('Germany');
			break;
		case 'www.dhl.co.uk':
			var name = 'DHL';
			if (dropDown) name += ' – '+translate('UK Domestic');
			break;
		case 'www.dpd.com':
			var name = 'DPD';
			if (dropDown) name += ' – '+translate('Germany');
			break;
		case 'www.fedex.com':
		case 'spportal.fedex.com':
			var name = 'FedEx';
			break;
		case 'www.gls-germany.com':
			var name = 'GLS';
			break;
		case 'checkout.google.com':
			var name = 'Google Checkout';
			break;
		case 'www.hlg.de':
			var name = 'Hermes Logistik Gruppe';
			if (dropDown) name += ' – '+translate('Germany');
			break;
		case 'www.hongkongpost.com':
			var name = 'Hongkong Post';
			break;
		case 'www.japanpost.jp/ems':
			var name = (translateName) ? translate('Japan Post') : 'Japan Post';
			if (dropDown) name += ' – EMS';
			break;
		case 'www.japanpost.jp/m10':
			var name = (translateName) ? translate('Japan Post') : 'Japan Post';
			if (dropDown) name += ' – '+translate('Morning 10 Overnight Mail');
			break;
		case 'www.japanpost.jp/reg':
			var name = (translateName) ? translate('Japan Post') : 'Japan Post';
			if (dropDown) name += ' – '+translate('Registered Mail');
			break;
		case 'www.japanpost.jp/yupack':
			var name = (translateName) ? translate('Japan Post'):'Japan Post';
			if (dropDown) name += ' – '+translate('Yu-Pack');
			break;
		case 'www.laposte.fr':
			var name = 'La Poste';
			if (dropDown) name += ' – '+translate('France');
			break;
		case 'www.ontrac.com':
			var name = 'OnTrac';
			break;
		case 'www.parcelforce.com':
			var name = 'Parcelforce';
			break;
		case 'www.post.at':
			var name = (translateName)?'Post':'Post.at';
			if (dropDown) name += ' – '+translate('Austria');
			break;
		case 'www.postdanmark.dk':
			var name = 'Post Danmark';
			break;
		case 'www.poste.it/posta1':
			var name = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) name += ' – Postacelere1 Plus';
			break;
		case 'www.poste.it/pacco1':
			var name = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) name += ' – Paccocelere1 Plus';
			break;
		case 'www.poste.it/maxi':
			var name = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) name += ' – Paccocelere Maxi';
			break;
		case 'www.poste.it':
			var name = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) name += ' – Paccocelere3';
			break;
		case 'www.poste.it/pacco':
			var name = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) name += ' – Paccocelere Internationale';
			break;
		case 'www.poste.it/ems':
			var name = (translateName)?'Poste Italiane':'Poste.it';
			if (dropDown) name += ' – EMS';
			break;
		case 'www.posten.no':
			var name = (translateName)?'Posten':'Posten.no';
			if (dropDown) name += ' – '+translate('Norway');
			break;
		case 'www.posten.se':
			var name = (translateName)?'Posten':'Posten.se';
			if (dropDown) name += ' – '+translate('Sweden');
			break;
		case 'www.postnl.nl':
		case 'www.tntpost.nl':
			var name = 'PostNL';
			break;
		case 'www.purolator.com':
			var name = 'Purolator';
			break;
		case 'www.royalmail.com':
			var name = 'Royal Mail';
			break;
		case 'www.sagawa-exp.co.jp':
			var name = (translateName) ? translate('Sagawa Express'):'Sagawa';
			break;
		case 'www.post.ch':
			var name = (translateName) ? translate('Swiss Post'):'Swiss Post';
			break;
		case 'www.tnt.com':
			var name = 'TNT';
			if (dropDown) name += ' – '+translate('by consignment number');
			break;
		case 'www.tnt.com/ref':
			var name = 'TNT';
			if (dropDown) name += ' – '+translate('by reference number');
			break;
		case 'www.ups.com':
			var name = 'UPS';
			break;
		case 'www.ups-mi.net':
			var name = 'UPS Mail Innovations';
			break;
		case 'www.usps.com':
			var name = 'US Postal Service';
			break;
		case 'www.kuronekoyamato.co.jp':
			var name = (translateName) ? translate('Yamato Transport'):'Yamato Transport';
			break;
		case 'www.amazon.com':
		case 'www.amazon.ca':
		case 'www.amazon.co.uk':
		case 'www.amazon.co.jp':
		case 'www.amazon.de':
		case 'www.amazon.at':
		case 'www.amazon.es':
		case 'www.amazon.fr':
		case 'www.amazon.it':
			var name = 'A'+from.substring(5);
			break;
		case 'other':
			var name = (translateName) ? translate('Other'):'Other';
			break;
		default:
			var name = from;
			break;

	}
	return name;

}

function cleanDate (input) {

	var output;
	var results = [];
	var end = false;

	if (input) {

		var year = new Date().getFullYear();

		input = input.toString();
		// Get rid of the time if necessary
		input = input.replace(/([0-9]{2}:[0-9]{2}:[0-9]{2}|[0-9]{1,2}:[0-9]{2} ?(A\.?M\.?|P\.?M\.?|Uhr|Hours|h)?)/i,'');
		while (input.indexOf('&nbsp;') != -1) input = input.replace('&nbsp;',' ');
		input = trim(input);
		output = input;

		// Add the year if it's missing, needed for Apple store shipping estimates, Google status updates
		if (output.match(/^[a-z]* [0-9]{1,2}$/i)) output = output+' '+year;

		// Fix international dates
		output = output.replace(/([0-9]{4})-([0-9]{2})-([0-9]{2})/i,'$2/$3/$1');

		if (this.fromName == 'Amazon.de' || this.fromName == 'Amazon.at') {
			output = cleanGermanDate(output);
		} else if (this.fromName == 'Amazon.es') {
			output = cleanSpanishDate(output);
		} else if (this.fromName == 'Amazon.fr') {
			output = cleanFrenchDate(output);
		} else if (this.fromName == 'Amazon.it') {
			output = cleanItalianDate(output);
		} else if (this.fromName == 'Apple') {
			output = output.replace(/^(?:by )?([a-z]+) ([0-9]{1,2})[a-z]{2}$/i,'$1 $2,'+year);
			output = output.replace(/^([0-9]{1,2}) ([a-z]+)$/i,'$2 $1,'+year);
			output = output.replace(/^([0-9]{1,2})\/([0-9]{1,2})$/i,'$1/$2/'+year);
			if (this.from == 'www.apple.com/hk') output = output.replace(/^([0-9]+)年([0-9]+)月([0-9]+)日$/i,'$2/$3/$1');
		} else if (this.fromClass == 'CityLink') {
			output = flexibleInternationalDate(output);
			output = output.replace(/([0-9]{1,2})[a-z]+ ([a-z]+)/i,'$2 $1, '+year);
		} else if (this.from == 'nolp.dhl.de') {
			output = output.replace(/^([a-z]+\.,)/i,'');
			output = flexibleInternationalDate(output);
		} else if (this.fromClass == 'GLS' || this.fromClass == 'HLG' || this.from == 'auspost.com.au' || 
			this.from == 'www.dhl.co.uk' || this.fromName == 'PostNL' || this.from == 'www.laposte.fr') {
			output = flexibleInternationalDate(output);
		} else if (this.fromClass == 'RoyalMail' || this.fromClass == 'Parcelforce' || this.from == 'www.posten.no') {
			// Could be DD/MM/YY (RoyalMail, Parcelforce), DD.MM.YYYY (Posten), or YYYY-MM-DD. The latter was fixed above.
			if (input == output) output = flexibleInternationalDate(output);
		} else if (this.fromClass == 'Posten-se') {
			result = output.match(/([0-9]{1,2}) ([a-z]*)/i);
			if (result) output = getSwedishMonth(result[2])+'/'+result[1]+'/'+year;
		} else if (this.fromClass == 'JapanPost' && translate('Japan Post') == '日本郵便') {
			output = output.replace(/([0-9]{1,2})月([0-9]{1,2})日/i,'$1/$2')+'/'+year;
		} else if (this.fromClass == 'Sagawa') {
			output = output.replace(/([0-9]+)年([0-9]+)月([0-9]+)日/i,'$2/$3/$1');
		} else if (this.from == 'www.post.at') {
			// Only reorder if periods are used
			output = output.replace(/([0-9]{2})\.([0-9]{2})\.([0-9]{2,4})/i,'$2/$1/$3');
		} else if (this.fromClass == 'PostDanmark') {
			output = cleanDanishDate(output);
		} else if (this.fromClass == 'Poste-it') {
			output = output.replace(/([0-9]{2})\-([0-9]{2})\-([0-9]{4})/i,'$2/$1/$3');
		} else if (this.fromClass == 'SwissPost') {
			output = output.replace(/([0-9]{2})\.([0-9]{2})\.([0-9]{4})/i,'$2/$1/$3');
		} else if (this.fromClass == 'Yamato') {
			output += '/'+year;
		}

		if (output) {
			end = new Date(output);
			if (new String(end.getDate()) == 'NaN') end = false;
		}

	}
	results[0] = output;
	results[1] = end;
	return results;

}

function reorderInternationalDate (input) {
	return (input) ? input.replace(/([0-9]{2})\/([0-9]{2})\/([0-9]{4})/i,'$2/$1/$3') : '';
}

function flexibleInternationalDate (input) {
	// Might be safe to replace reorderInternationalDate with this?
	return (input) ? input.replace(/([0-9]{2})(?:\/|-|\.)([0-9]{2})(?:\/|-|\.)([0-9]{2,4})/i,'$2/$1/$3') : '';
}

function cleanLocation (string) {
	if (string) {
		string = trim(string);
		string = string.replace(/ (Hub|Depot|Distribution|Distributionsbasis|Paketzentrum|Centre Colis|Base de distribution)$/i,'');
		switch (this.from) {
			case 'auspost.com.au':
				string = string.replace(/ (LPO|BUSINESS HUB),/i,'');
				break;
			case 'www.dhl.com':
				string = string.replace(/ (HUB|GATEWAY),/i,'');
				break;
			case 'www.dhl.co.uk':
				string = string.replace(/ (SERVICE CENTRE|HOME DELIVERY)$/i,'');
				break;
			case 'nolp.dhl.de':
				string = string.replace(/^HUB /i,'');
				break;
			case 'www.fedex.com':
				string = string.replace(/^FEDEX SMARTPOST /i,'');
				break;
			case 'www.parcelforce.com':
				string = string.replace(/^Delivery Agent - /i,'');
				break;
			case 'www.post.ch':
				string = string.replace(/ (Zustellung|Filiale di distribuzione)$/i,'');
				string = string.replace(/^[0-9]+ /,'');
				break;
			case 'www.posten.no':
				string = string.replace(/^[0-9]+ /,'');
				break;
			case 'www.posten.se':
				string = string.replace(/^(Posten ?Företag|Posten)\b ?/,'');
				break;
			case 'www.usps.com':
				string = string.replace(/ \(USPS\)$/i,'');
				break;
		}
	}
	return string;
}

function cleanHTML (string,from) {
	if (string) {
		switch (from) {
			case 'em.canadapost.ca':
				// Remove the viewport tag that prevents zooming
				string = string.replace(/<meta[^>]*name="viewport"[^>]*>/i,'');
				// Remove the mobile/standard overlay
				string = string.replace(/<div id="overlay"> ?<div>(.*?)<\/div> ?<\/div>/i,'');
				break;
		}
	}
	return string;
}

function guessFrom (no,correctNo) {

	// Could get better results by supplying a list of companies, ordered by most used.
	// Then if we're not sure, we can guess the first one in the list.
	// Alternatively, we could just use the favorites list.

	var from = false;
	var newNo = false;
	no = no.replace(/ /g,'');

	if (no.match(/^1Z[0-9A-Z]{16}$/i)) {
		from = ['www.ups.com'];
	} else if (matches = no.match(/^([A-Z]{2})[0-9]{9}([A-Z]{2})$/i)) {
		var country = matches[2].toUpperCase();
		switch (country) {
			case 'AT': from = ['www.post.at']; break;
			case 'AU': from = ['auspost.com.au']; break;
			case 'CA': from = ['em.canadapost.ca']; break;
			case 'CH': from = ['www.post.ch']; break;
			case 'DK': from = ['www.postdanmark.dk']; break;
			case 'FR': from = ['www.laposte.fr']; break;
			case 'GB': from = ['www.royalmail.com','www.parcelforce.com']; break;
			case 'HK': from = ['www.hongkongpost.com']; break;
			case 'IT': from = ['www.poste.it','www.poste.it/maxi']; break; // Probably maxi if it starts with LC|LM|LP|LX
			case 'JP': from = ['www.japanpost.jp/ems']; break;
			case 'NL': from = ['www.postnl.nl']; break;
			case 'NO': from = ['www.posten.no']; break;
			case 'SE': from = ['www.posten.se']; break;
			case 'US': from = ['www.usps.com']; break;
		}
	} else if (no.match(/^96(11|12|13)[0-9]{18}$/)) { // 22 digits, last digit is a check
		from = ['www.fedex.com'];
	} else if (no.match(/^(420[0-9]{5})?9[0-9]{21}$/)) {
		// 22-30 digits, usually 9x0x
		// (420xxxxx)?9102xxxxxxxxxxxxxxxxxx is usually www.dhlglobalmail.com or www.ups-mi.net?
		from = ['www.usps.com','www.dhlglobalmail.com','www.ups-mi.net'];
	} else if (no.match(/^0034043[0-9]{13}$/)) { // 20 digits
		from = ['nolp.dhl.de'];
	} else if (no.match(/^J?JD[0-9]{2}\.?[0-9]{2}\.?[0-9]{3}\.?[0-9]{3}\.?[0-9]{3}\.?([0-9]{3,10})?$/i)) {
		from = ['nolp.dhl.de','www.dhl.co.uk','www.dhl.com'];
	} else if (no.match(/^0[1-3][0-9]{18}$/)) { // 20 digits
		from = ['www.usps.com'];
	} else if (no.match(/^70[0-9]{18}$/)) { // 20 digits, Certified Mail
		from = ['www.usps.com'];
	} else if (no.match(/^[0-9]{15}$/)) { // 15 digits
		from = ['www.fedex.com','checkout.google.com','www.hlg.de','www.dpd.com'];
	} else if (no.match(/^[0-9]{12}$/)) { // 12 digits, including UPS InfoNotice
		from = ['nolp.dhl.de','www.kuronekoyamato.co.jp','www.sagawa-exp.co.jp','www.hlg.de',
			'www.japanpost.jp/yupack','www.japanpost.jp/reg','www.japanpost.jp/m10','www.gls-germany.com'];
		if (checkFedEx12(no)) {
			from.unshift('www.fedex.com');
		} else from.push('www.ups.com');
	} else if (no.match(/^DT[0-9]{12}$/)) { // DT followed by 12 digits, FedEx delivery notice number
		from = ['www.fedex.com'];
	} else if (no.match(/^(00)?37[0-9]{16}$/)) { // 18 or 20 digits
		from = ['www.posten.no','www.posten.se','www.postdanmark.dk'];
		if (no.match(/^[0-9]{18}$/)) from.push('www.dhl.com'); // 18 digits, odds are low
	} else if (no.match(/^(98|99)\.?[0-9]{2}\.?[0-9]{6}\.?[0-9]{8}$/)) { // 18 digits possibly with periods
		from = ['www.post.ch'];
		if (no.match(/^[0-9]{18}$/)) from.push('www.dhl.com'); // 18 digits, odds are low
	} else if (no.match(/^[0-9]{18}$/)) { // 18 digits
		from = ['www.dhl.com'];
	} else if (no.match(/^([0-9]{10}|[0-9]{18})$/)) { // 10 digits
		// www.tnt.com/ref always starts with 8? apple always starts with 71?
		from = ['www.dhl.com','www.aramex.com','www.tnt.com/ref','www.apple.com','www.apple.com/zip',
			'www.apple.com/japan','www.apple.com/japanzip','www.apple.com/hk'];
	} else if (no.match(/^P[0-9]{12}$/i)) { // P plus 12 digits
		from = ['nolp.dhl.de'];
	} else if (no.match(/^[0-9]{3}-[0-9]{7}-[0-9]{7}$/)) {
		from = ['www.amazon.com','www.amazon.co.jp','www.amazon.de','www.amazon.co.uk','www.amazon.fr',
			'www.amazon.ca','www.amazon.it','www.amazon.es','www.amazon.at'];
	} else if (no.match(/^WR?[0-9]{8,9}$/i)) {
		from = ['www.apple.com','www.apple.com/zip','www.apple.com/japan','www.apple.com/japanzip',
			'www.apple.com/hk'];
	} else if (no.match(/^7[0-9]{16}$/)) { // 17 digits
		from = ['www.posten.no'];
	} else if (no.match(/^[0-9]{4}-[0-9]{4}-[0-9]{4}$/)) { // 12 digits with dashes
		from = ['www.kuronekoyamato.co.jp','www.sagawa-exp.co.jp','www.japanpost.jp/yupack',
			'www.japanpost.jp/reg','www.japanpost.jp/m10'];
	} else if (no.match(/^[0-9]{3}-[0-9]{2}-[0-9]{5}-[0-9]{1}$/)) { // 11 digits with dashes
		from = ['www.japanpost.jp/yupack','www.japanpost.jp/reg'];
	} else if (no.match(/^[0-9]{11}$/)) { // 11 digits
		from = ['www.gls-germany.com','www.japanpost.jp/yupack','www.japanpost.jp/reg'];
	} else if (no.match(/^[0-9]{14}[A-Z]$/i)) { // 14 digits plus letter
		from = ['www.dpd.com'];
	} else if (no.match(/^[0-9]{14}$/)) { // 14 digits
		from = ['www.dpd.com','www.hlg.de','www.posten.se'];
	} else if (no.match(/^000[0-9]{4}0530800815[0-9]{4}101[0-9]{3}[A-Z0-9]$/i)) {
		from = ['www.dpd.com'];
	} else if (no.match(/^[0-9]{16}$/)) { // 16 digits
		from = ['em.canadapost.ca','www.hlg.de'];
	} else if (no.match(/^[0-9]{9}$/)) { // 9 digits, UPS freight PRO number
		from = ['www.tnt.com','www.ups.com'];
	} else if (no.match(/^[0-9]{2}.[0-9]{3}.[0-9].[0-9]{2}.[0-9]{5}.[0-9]$/)) { // 14 digits with periods
		from = ['www.hlg.de'];
	} else if (no.match(/^(C1099|C1100|D1001)[0-9]{10}$/i)) {
		from = ['www.ontrac.com'];
	} else if (no.match(/^3S[A-Z]{4}[0-9]{6,9}$/i)) {
		from = ['www.postnl.nl'];
	} else if (no.match(/^[0-9]{5}\.[0-9]{2}\.([0-9]{4}|[0-9]{6})$/)) { // 11 or 13 digits with periods
		from = ['www.gls-germany.com'];
	} else if (no.match(/^([A-Z]{3}[0-9]{5})$/i)) { // 8 characters, 3 letters and 5 digits
		from = ['www.city-link.co.uk','www.gls-germany.com'];
	} else if (no.match(/^(1[A-Z][0-9A-Z]{4}|[A-Z][0-9A-Z]{7})$/i)) {
		from = ['www.gls-germany.com'];
	} else if (no.match(/^(PB[A-Z]{2}[0-9]{7}001|TW[A-Z]{2}[0-9]{7}GB|[A-Z]{2}[0-9]{7})$/i)) {
		from = ['www.parcelforce.com'];
	} else if (no.match(/^[A-Z]{3}[0-1]00[0-9]{6}$/i)) {
		from = ['www.purolator.com'];
	} else if (no.match(/^[A-Z][A-Z0-9]{2}[0-9]{5}$/i)) {
		from = ['www.city-link.co.uk'];
	} else if (no.match(/^8[A-Z][0-9]{11}$/i)) { // 13 characters, second is a letter
		from = ['www.laposte.fr'];
	} else if (no.match(/^[0-9]{11}DK$/i)) {
		from = ['www.postdanmark.dk'];
	} else if (no.match(/^101[0-9]{19}$/i)) { // 22 digits
		from = ['www.post.at'];
	} else if (no.match(/^L[A-Z]{2}000[0-9]{4}([0-9]{6})?$/i)) { // 10 or 16 digits
		from = ['auspost.com.au'];
	} else if (no.match(/^AD[0-9]{9}[A-Z]{0,4}$/i)) {
		from = ['www.adobe.com'];
	} else if (no.match(/^[0-9]{32}$/) && checkFedEx12(no.substring(16,28))) { // 32 digits, 12 digits inside a barcode
		from = ['www.fedex.com'];
		newNo = no.substring(16,28);
	} else if (no.match(/^[0-9][A-Z]{3}[0-9]{24}$/)) { // 28 digits, 16 digits inside a barcode
		from = ['em.canadapost.ca'];
		newNo = no.substring(7,23);
	}

	if (correctNo) from.unshift(newNo);
	return from;

}

function checkFedEx12 (no) {
	// Expects a string
	var checkDigit = ((no[0]*3)+(no[1]*1)+
		(no[2]*7)+(no[3]*3)+(no[4]*1)+
		(no[5]*7)+(no[6]*3)+(no[7]*1)+
		(no[8]*7)+(no[9]*3)+(no[10]*1)) % 11;
	if (checkDigit == 10) checkDigit = 0;
	return (checkDigit == no[11]) ? true : false;
}