var appId = 'com.junecloud.widget.deliverystatus';
var installedVersion;
var readableVersion;
var syncVersion = 4.5;
var defsVersion = 62;
var iPhone = false;
var localeCode = 'US';
var timeZone = new Date().getTimezoneOffset();

var historyDays = 30; // days to keep old items in the history
var dismissDays = 30; // days to dismiss version checking
var lastVersion = 0; // last version installed
var currentVersion; // most recent version available
var downloadUrl = 'http://junecloud.com/software/mac/delivery-status.html';
var disableTooltips = false;

var deliveries = [];
var updateQueue;
var hadSuccess = false;
var updateStamp = 0;

var currentSide = 'front';
var currentView = 'deliveries';
var nextSide = '';
var nextView = '';

var editingDelivery;
var lastFrom;
var openQueue = [];
var closeQueue = [];
var extraEdited = false;

var clickSpeed = 500;
var lastClick;
var clickTimer;

var sortByDate = false;
var growlEnabled = false;
var pushEnabled = false;
var updateTimer = null;
var dashboardActive = true;
var scrollTimer;

var largePrint = false;

// create an object to handle sync and version check requests

var sync = {};
sync.sync = true;
sync.req = [];
sync.reqCount = 0;
sync.reqComplete = 0;
sync.loadPage = loadPage;
sync.client = '';
sync.code = '';
sync.password = false;
sync.updated = 0;
sync.force = true;
sync.success;
sync.retry = false;
sync.first = 0;
sync.updateAfter = true;
var syncQueue = [];

var defsPath = 'Scripts/Definitions.js';
var defsUpdate = 0;
var defsLocal = defsVersion;

var services = [
	'www.adobe.com',
	'www.amazon.com',
	'www.amazon.ca',
	'www.amazon.co.uk',
	'www.amazon.co.jp',
	'www.amazon.de',
	'www.amazon.at',
	'www.amazon.es',
	'www.amazon.fr',
	'www.amazon.it',
	'www.apple.com',
	'www.apple.com/japan',
	'www.apple.com/hk',
	'www.aramex.com',
	'auspost.com.au',
	'em.canadapost.ca',
	'www.city-link.co.uk',
	'www.dhl.com',
	'www.dhlglobalmail.com',
	'nolp.dhl.de',
	'www.dhl.co.uk',
	'www.dpd.com',
	'www.fedex.com',
	'www.gls-germany.com',
	'checkout.google.com',
	'www.hlg.de',
	'www.hongkongpost.com',
	'www.japanpost.jp/ems',
	'www.japanpost.jp/m10',
	'www.japanpost.jp/reg',
	'www.japanpost.jp/yupack',
	'www.laposte.fr',
	'www.ontrac.com',
	'www.parcelforce.com',
	'www.post.at',
	'www.postdanmark.dk',
	'www.poste.it/posta1',
	'www.poste.it/pacco1',
	'www.poste.it/maxi',
	'www.poste.it',
	'www.poste.it/pacco',
	'www.poste.it/ems',
	'www.posten.no',
	'www.posten.se',
	'www.postnl.nl',
	'www.purolator.com',
	'www.royalmail.com',
	'www.sagawa-exp.co.jp',
	'www.post.ch',
	'www.tnt.com',
	'www.tnt.com/ref',
	'www.ups.com',
	'www.ups-mi.net',
	'www.usps.com',
	'www.kuronekoyamato.co.jp',
	'other'];
var favorites = [];
var showAll = true;
var useCount = [];

function $ (id) {
	return document.getElementById(id);
}

function setup () {

	if (typeof DeliveryStatus == 'undefined') {
		document.body.className = 'unsupported';
		$('unsupported').innerHTML = translate('Delivery Status requires Mac OS X 10.5 or later.');
		return;
	}

	if (window.widget) {

		// load settings

		if (DeliveryStatus) localeCode = DeliveryStatus.getLocaleCode();

		lastVersion = (widget.preferenceForKey('lastversion')) ? 
			parseFloat(widget.preferenceForKey('lastversion')) : 0;

		sync.client = (widget.preferenceForKey(widget.identifier+'-syncclient')) ? 
			widget.preferenceForKey(widget.identifier+'-syncclient') : '';
		// if (sync.client) sync.code = getPassword('junecloud.com',appId);
		sync.email = (widget.preferenceForKey('syncemail')) ? 
			widget.preferenceForKey('syncemail') : '';
		if (sync.email) sync.password = (getPassword('junecloud.com',sync.email)) ? true : false;	
		sync.updated = (widget.preferenceForKey('syncupdated')) ? 
			parseInt(widget.preferenceForKey('syncupdated'),10) : 0;
		sync.offset = (widget.preferenceForKey('syncoffset')) ? 
			parseFloat(widget.preferenceForKey('syncoffset')) : 0;
		syncQueue = (widget.preferenceForKey('syncqueue') && typeof JSON.parse == 'function') ? 
			JSON.parse(widget.preferenceForKey('syncqueue')) : [];

		disableTooltips = (widget.preferenceForKey('disabletooltips') == '1') ? true : false;

		if (widget.preferenceForKey('favorites')) favorites = widget.preferenceForKey('favorites').split(';');
		showAll = (widget.preferenceForKey('showall') != null) ? widget.preferenceForKey('showall') : true;

		if (widget.preferenceForKey('usecount')) {
			var useTemp = widget.preferenceForKey('usecount').split(';');
			for (var i in useTemp) {
				if (useTemp[i]) {
					var service = useTemp[i].split(':');
					useCount[service[0]] = parseInt(service[1],10);
				}
			}
			sortUseCount();
		}

		// reset syncing when upgrading from a pre-5.0 version

		if (lastVersion < 5.0) {
			// if (DeliveryStatus) DeliveryStatus.deletePassword('junecloud.com',appId);
			sync.client = '';
			sync.code = '';
			sync.updated = 0;
		}

		checkNotifications();

		sortByDate = (widget.preferenceForKey('sortbydate') != null) ? widget.preferenceForKey('sortbydate') : true;
		largePrint = (widget.preferenceForKey('size') && widget.preferenceForKey('size') != 'small') ? true : false;
		$('size').checked = largePrint;

		// make sure the service definitions are up to date

		defsUpdate = (widget.preferenceForKey('defsupdate')) ? 
			parseFloat(widget.preferenceForKey('defsupdate')) : 0;
		if (widget.preferenceForKey('defspath')) {
			var tempPath = widget.preferenceForKey('defspath');
			if (DeliveryStatus && DeliveryStatus.fileExists(tempPath)) {
				if (widget.preferenceForKey('defs')) defsVersion = parseInt(widget.preferenceForKey('defs'),10);
				if (defsVersion <= defsLocal) {
					resetDefinitions();
				} else defsPath = tempPath;
			}	
		}
		loadDefinitions(defsPath,true);

	}

	// set up the resize handles

	$('resizer-front').addEventListener('mousedown',startResize,true);
	$('resizer-back').addEventListener('mousedown',startResize,true);

	// adjust AppleScrollArea to call didScroll(), since using onscroll doesn't work reliably

	AppleScrollArea.prototype.mousewheelScroll = function (event) {
		didScroll();
		var deltaScroll = event.wheelDelta / 120 * this.singlepressScrollPixels;
		this.verticalScrollTo(this.content.scrollTop - deltaScroll);
		event.stopPropagation();
		event.preventDefault();
	}

	// modify AppleScrollbar so it scrolls one delivery when the track is clicked

	AppleScrollbar.prototype._trackScrollOnePage = function (self) {
		var scrollPixels = this.scrollarea.singlepressScrollPixels * 14.8;
		if (self._track_mouse_temp < self._thumbStart)
			this.scrollarea.verticalScrollTo(this.scrollarea.content.scrollTop - scrollPixels);
		else if (self._track_mouse_temp > (self._thumbStart + self._thumbLength))
			this.scrollarea.verticalScrollTo(this.scrollarea.content.scrollTop + scrollPixels);
	}

	// set up the scroll bar

	var scrollBar = new AppleVerticalScrollbar($('scrollbar'));
	scrollBar.setSize(8);
	scrollBar.setTrackStart('Images/Scroll/spacer.png',6);
	scrollBar.setTrackMiddle('Images/Scroll/spacer.png');
	scrollBar.setTrackEnd('Images/Scroll/spacer.png',6);
	scrollBar.setThumbStart('Images/Scroll/thumb-top.png',6);
	scrollBar.setThumbMiddle('Images/Scroll/thumb-middle.png');
	scrollBar.setThumbEnd('Images/Scroll/thumb-bottom.png',6);

	scrollArea = new AppleScrollArea($('scroll'),scrollBar);
	scrollBar.setAutohide(true);
	scrollArea.singlepressScrollPixels = (webKitVersion() > 534) ? 20 : 5;
	//scrollArea.refresh();
	//scrollArea.focus();

	// set up the add and info buttons

	var addButton = newObject('a','add','add');
	addButton.title = translate('Add');
	addButton.addEventListener('click',addDelivery,true);
	var infoButton = newObject('a','info','info');
	infoButton.addEventListener('click',function(){ showInfo('general') },true);
	infoButton.title = translate('Settings');
	var buttons = [addButton,infoButton];
	new Buttons('front','info-buttons',buttons,false);

	// set up the tabs

	$('general-title').innerText = translate('General');
	$('sync-title').innerText = translate('Sync');
	$('donate-title').innerText = translate('Donate');
	$('signin-title').innerText = translate('Sign In');
	$('register-title').innerText = translate('Register');

	// set up the edit view

	$('editlabel').innerText = translate('Enter your tracking information');
	$('fromlabel').innerText = translate('Delivery From:');
	$('fav').title = translate('Click here to mark this service as a favorite.');
	$('passwordlabel').innerText = translate('Password:');
	$('namelabel').innerText = translate('Item Name:');
	$('name').placeholder = translate('Optional');
	$('historylabel').innerText = translate('Or choose an item from your history');
	$('helplink').title = translate('Help');

	// set up the date select menus

	$('dateField').className = localeCode;

	var yearSelect = newObject('select','year','year');
	var year = (new Date()).getFullYear();
	for (var i = 0; i <= 5; i++) {
		var text = (i == 0) ? '' : year+i-1;
		var no = text;
		if (text && localeCode == 'JP') text += '年';
		yearSelect.options[i] = new Option(text,no);
	}
	var monthSelect = newObject('select','month','month');
	monthSelect.options[0] = new Option('','');
	for (var i = 0; i < 12; i++) {
		var text = i;
		if (DeliveryStatus) {
			var month = i+1;
			if (month < 10) month = '0'+month;
			var dateString = year+'-'+month+'-01';
			text = DeliveryStatus.formatDate(dateString,translate('MMMM'),true);
		}
		monthSelect.options[i+1] = new Option(text,i);
	}
	var daySelect = newObject('select','day','day');
	for (var i = 0; i <= 31; i++) {
		var text = (i == 0) ? '' : i;
		var no = text;
		if (text && localeCode == 'JP') text += '日'; 
		daySelect.options[i] = new Option(text,no);
	}

	monthSelect = newSelectWrapper(monthSelect);
	daySelect = newSelectWrapper(daySelect);
	yearSelect = newSelectWrapper(yearSelect);

	if (localeCode == 'US') {
		$('dateselects').appendChild(monthSelect);
		$('dateselects').appendChild(daySelect);
		$('dateselects').appendChild(yearSelect);
	} else if (localeCode == 'JP') {
		$('dateselects').appendChild(yearSelect);
		$('dateselects').appendChild(monthSelect);
		$('dateselects').appendChild(daySelect);
	} else {
		$('dateselects').appendChild(daySelect);
		$('dateselects').appendChild(monthSelect);
		$('dateselects').appendChild(yearSelect);
	}

	// set up the info view

	$('sortlabel').innerHTML = translate('Sort by date');
	$('growllabel').innerHTML = translate('Display notifications with <a href="http://junecloud.com/get/growl" onclick="return openSite(this.href)">Growl</a>');
	$('pushlabel').innerHTML = translate('Send notifications to <a href="http://junecloud.com/software/iphone/delivery-status-touch.html" onclick="return openSite(this.href)">Delivery Status touch</a> (requires syncing)');
	$('sizelabel').innerHTML = translate('Use larger text');

	$('junecloud').title = translate('Copyright © 2006-2011 Junecloud LLC. Delivery Status is not affiliated with or endorsed by any of the supported shipping services.');

	$('syncemaillabel').innerText = translate('Email Address:');
	$('syncpasswordlabel').innerText = translate('Password:');
	$('syncconfirmlabel').innerText = translate('Confirm Password:');
	$('syncnamelabel').innerText = translate('Your Name:');
	$('syncname').placeholder = translate('Optional');
	$('synctermslabel').innerHTML = translate('I agree to the <a href="http://junecloud.com/sync/legal/terms.html" onclick="return openSite(this.href)">Terms of Service</a>');
	$('sync-info').innerText = translate('Sign in to your Junecloud account to sync with any Mac, iPhone, iPod touch, iPad, or web browser. Data will be synced securely through junecloud.com.');
	$('forgot').innerHTML = '<a href="https://junecloud.com/sync/?cmd=reset" onclick="return openSite(this.href)">'+translate('Forgot your password?')+'</a>';

	// create buttons

	var doneButton = new AppleGlassButton($('done-button'),translate('Done'),function(){saveSettings(true)});
	var cancelButton = new AppleGlassButton($('cancel-button'),translate('Cancel'),finishEditing);
	var signInButton = new AppleGlassButton($('signin-button'),translate('Sign In'),saveSync);
	var registerButton = new AppleGlassButton($('register-button'),translate('Register'),saveSync);
	var logOutButton = new AppleGlassButton($('logout-button'),translate('Log Out'),logOut);
	var donateButton = new AppleGlassButton($('donate-button'),translate('Donate'),openDonate);

	// display the front view

	$('loading').style.display = 'none';
	$('front').style.display = 'block';

	getCurrentVersion();

	if (window.widget) {
		widget.onhide = function () { dashboardActive = false; }
		widget.onshow = function () {
			if (!dashboardActive) { // prevent calling this on initial load
				dashboardActive = true;
				showScrollBar();
				var currentZone = new Date().getTimezoneOffset();
				if (timeZone != currentZone) {			
					timeZone = currentZone;
					updateDeliveries(true,false);
				} else {
					for (var i in deliveries) if (!deliveries[i].reqCount) displayItem(deliveries[i].id,deliveries[i].displayed,false);
					updateDeliveries((sync.first > 0),false);
				}
			}
		};
		widget.onremove = function () {
			widget.setPreferenceForKey(null,widget.identifier+'-syncclient');
		}
		widget.setPreferenceForKey(installedVersion,'lastversion');
	}

}

function showScrollBar () {
	clearTimeout(scrollTimer);
	$('scrollbar').className = 'visible';
	scrollTimer = setTimeout(function(){ $('scrollbar').className = ''; },300);
}

function didScroll () {
	showScrollBar();
}

function loadDeliveries () {

	// load the deliveries

	if (widget.preferenceForKey('deliveries')) {
		var deliveryIds = widget.preferenceForKey('deliveries').split(';');
		for (var i in deliveryIds) {
			if (deliveryIds[i]) {
				deliveries[i] = loadDelivery(deliveryIds[i],i);
				if (deliveries[i].unfrozen) {
					displayItem(deliveries[i].id,deliveries[i].displayed,false);
					var thisStamp = (deliveries[i].lastUpdate) ? deliveries[i].lastUpdate.getTime() : 0;
					if (thisStamp > updateStamp) updateStamp = thisStamp;
				}
				if (updateStamp) hadSuccess = true;
			}
		}
	}
	
	$('deliveries').style.height = (deliveries.length * 74) + 'px';
	showNoDeliveries();

	size = savedSize();
	setMinMax(currentView);
	setSize(size.width,size.height,true,false);
	setMaximized(size);
	setTimeout(showScrollBar,1000);

	updateQueue = new Queue();
	if (installedVersion > lastVersion) {
		updateDeliveries(true,false);
	} else startSync();

}

function loadDelivery (id,index) {

	/* the HTML generated below looks like this:

	<div class="delivery">
		<div class="highlight"></div>
		<div class="shadow"></div>
		<div class="icon">
			<img class="spinner"/>
			<div class="daycount"></div>
			<div class="daytext"></div>
		</div>
		<div class="text">
			<div class="item"></div>
			<div class="ship"></div>
			<div class="deliver"></div>
		</div>
		<div class="button" onclick="clickDelivery('id')"></div>
	</div> */

	var deliveryObj = newObject('div',id,'delivery');
	deliveryObj.appendChild(newObject('div',false,'highlight'));
	deliveryObj.appendChild(newObject('div',false,'shadow'));

	var iconObj = newObject('div',id+'-icon','icon');
	iconObj.appendChild(newObject('img',id+'-spinner','spinner'));
	iconObj.appendChild(newObject('div',id+'-daycount','daycount'));
	iconObj.appendChild(newObject('div',id+'-daytext','daytext'));
	deliveryObj.appendChild(iconObj);

	var textObj = newObject('div',id+'-text','text updating');
	textObj.appendChild(newObject('div',id+'-item','item'));
	textObj.appendChild(newObject('div',id+'-ship','ship'));
	textObj.appendChild(newObject('div',id+'-deliver','deliver'));
	deliveryObj.appendChild(textObj);
	
	var buttonObj = newObject('div',id+'-button','button');
	buttonObj.addEventListener('click',function(){ clickDelivery(id) },true);
	deliveryObj.appendChild(buttonObj);

	var settings = [];
	settings.uuid = id;
	if (window.widget) {
		settings.from = widget.preferenceForKey(id+'-store');
		settings.name = widget.preferenceForKey(id+'-itemname');
		settings.no = widget.preferenceForKey(id+'-orderno');
		settings.extra = widget.preferenceForKey(id+'-email');
		settings.date = widget.preferenceForKey(id+'-date');
		settings.html = widget.preferenceForKey(id+'-html');
		settings.htmldate = widget.preferenceForKey(id+'-htmldate');
		settings.displayed = widget.preferenceForKey(id+'-displayed');
	}

	if (index < 0) {
		deliveryObj.style.opacity = 0;
		deliveryObj.style.height = 0;
		var newDelivery = $('deliveries').insertBefore(deliveryObj,$('deliveries').childNodes[0]);
		openQueue.push(newDelivery);
	} else if ($(id)) {
		$('deliveries').replaceChild(deliveryObj,$(id));
	} else $('deliveries').appendChild(deliveryObj);

	var delivery;
	if (deliveries[index]) {
		delivery = deliveries[index];
		delivery.resetRequests(true);
		delivery.setDelivery(settings);
	} else {
		delivery = new Delivery(settings);
		if (window.widget && widget.preferenceForKey(id+'-saved')) {
			var jsonData = JSON.parse(widget.preferenceForKey(id+'-saved'));
			if (jsonData.items) {
				delivery.url = jsonData.url;
				delivery.count = jsonData.count;
				if (jsonData.lastupdate) delivery.lastUpdate = new Date(jsonData.lastupdate);
				if (jsonData.nextupdate) delivery.nextUpdate = jsonData.nextupdate;
				delivery.items = jsonData.items
				delivery.unfrozen = true;
			}
		}
	}

	deliveryObj.className = 'delivery '+delivery.fromClass;
	delivery.addButtons();

	return delivery;

}

function saveItems () {
	if (typeof JSON.stringify == 'function' && window.widget) {
		var lastUpdateTime = (this.lastUpdate) ? this.lastUpdate.getTime() : null;
		var jsonData = {
				url:		this.url,
				count:		this.count,
				lastupdate:	lastUpdateTime,
				nextupdate:	this.nextUpdate,
				items:		this.items
			};
		widget.setPreferenceForKey(JSON.stringify(jsonData),this.id+'-saved');
	}
}

function addButtons () {
	var editButton = newObject('a',this.id+'-edit','edit');
	editButton.title = translate('Edit');
	editButton.parent = this;
	editButton.addEventListener('click',this.editParent,true);
	var closeButton = newObject('a',this.id+'-close','close');
	closeButton.title = translate('Delete');
	closeButton.parent = this;
	closeButton.addEventListener('click',this.closeParent,true);
	var buttons = [editButton,closeButton];
	this.buttons = new Buttons(this.id,'edit-buttons',buttons,true);
}

function getIndex (id) {
	for (var i in deliveries) {
		if (deliveries[i].id == id) return i;
	}
	return -1;
}

function getUUID () {
	if (DeliveryStatus) {
		return DeliveryStatus.getUUID();
	} else return (new Date()).getTime();
}

function getPassword (from,extra) {
	var result;
	if (DeliveryStatus) result = DeliveryStatus.getPassword(from,extra);
	if (result == null) result = '';
	return result;
}

function newObject (element,id,classname) {
	var object = document.createElement(element);
	if (id) object.setAttribute('id',id);
	object.className = classname;
	if (element == 'a') object.href = '#';
	return object;
}

function newSelectWrapper (select) {

	select.onkeyup = function(){ setSelect(select.id,false); }
	select.onchange = function(){ setSelect(select.id,false); }
	
	// Show focus?
	// select.onfocus = function(){ $(select.id+'-popup').style.border = '1px solid red'; }
	// select.onblur = function(){ $(select.id+'-popup').style.border = 'none'; }
	
	var wrapperObj = newObject('div',select.id+'-popup','popup');
	wrapperObj.appendChild(newObject('div',select.id+'-text','text'));
	wrapperObj.appendChild(select);

	return wrapperObj;

}

function setSelect (id,value) {
	if (value !== false) $(id).value = value;
	$(id+'-text').innerText = $(id).options[$(id).selectedIndex].innerText;
}

function updateDeliveries (force,skipSync) {

	if (!skipSync) {

		if (force) {
			sync.force = true;
			for (var i in deliveries) deliveries[i].nextUpdate = 0;
			sync.updateAfter = true;
		}
		startSync();

	} else {

		clearTimeout(updateTimer);
		var resetSuccess = false;
		var rightNow = getUnixTime();
		if (force) updateQueue.reset();

		for (var i in deliveries) {
			if (force) {
				updateQueue.add(deliveries[i]);
			} else {
				if (rightNow >= deliveries[i].nextUpdate && deliveries[i].reqComplete >= deliveries[i].reqCount) {
					if (!resetSuccess) {
						hadSuccess = false;
						resetSuccess = true;
					}
					updateQueue.add(deliveries[i]);
				}
			}
		}
		if (updateQueue.count()) {
			updateQueue.update();
		} else showTime(false);
		if (growlEnabled || pushEnabled) updateTimer = setTimeout('updateDeliveries(false,false)',30*60000);

	}

}

function setHistoryTitle (id) {
	var index = getIndex(id);
	if (deliveries[index]) {
		var item = deliveries[index].items[0];
		if (item && window.widget) {
			widget.setPreferenceForKey(removeHtmlEntities(item.title),id+'-historytitle');
		}
	}
}

function updateOther (delivery) {

	var item = resetItem();
	if (delivery.name) {
		item.title = htmlEntities(delivery.name);
	} else if (delivery.no) {
		item.title = htmlEntities(delivery.no);
	}

	if (delivery.url) {
		item.shipText = translate('Click for more information');
		item.shipBold = true;
	} else {
		item.shipText = translate('Ship date unknown');
		item.shipBold = false;
	}

	delivery.html = cleanOtherHTML(delivery.html);
	if (delivery.html && delivery.html != delivery.oldhtml) {
		if (delivery.oldhtml) delivery.htmldate = (new Date()).getTime();
		saveHTML(delivery);
	}

	if (delivery.date) {
		var date = widget.preferenceForKey(delivery.id+'-date');
		if (date) delivery.date = stringToTimeStamp(date);
		var daysApart = getDaysApart(delivery.date);
		item.icon = (daysApart < 0) ? 'checkmark' : '';
		item.date = delivery.date.getTime();
		item.deliverText = item.deliverExtra = translate('Delivered by %@');
		item.deliverBold = item.deliverExtraBold = false;
		item.deliverDate = delivery.date.getTime();
	} else {
		item.icon = 'transit';
		item.date = '';
		item.deliverText = translate('Delivery date unknown');
		item.deliverBold = false;
		item.deliverDate = '';
	}
	delivery.items = [];
	delivery.items[0] = item;
	delivery.count = 1;

}

function setIcon (id,icon) {
	$(id+'-icon').className = (icon) ? 'icon '+icon : 'icon days';
}

function convertDate (date) {
	return (date) ? date.getTime() : 0;
}

function timeStampToString (date) {
	var dateObject = new Date(date);
	var string = dateObject.getFullYear()+'-';
	var month = dateObject.getMonth()+1;
	if (month < 10) month = '0'+month;
	string += month+'-';
	var day = dateObject.getDate();
	if (day < 10) day = '0'+day;
	string += day;
	return string; // yyyy-MM-dd
}

function displayDate (date,useRelative,useCaps) {
	var result = '';
	var daysApart = getDaysApart(date);	
	if (useRelative && daysApart == 0) {
		result = (useCaps) ? translate('Today') : translate('today');
	} else if (useRelative && daysApart == 1) {
		result = (useCaps) ? translate('Tomorrow') : translate('tomorrow');
	} else if (useRelative && daysApart == -1) {
		result = (useCaps) ? translate('Yesterday') : translate('yesterday');
	} else if (useRelative > 1 && daysApart > 1 && daysApart < 7) {	
		result = DeliveryStatus.formatDate(timeStampToString(date),'EEEE',useCaps);
	} else if (DeliveryStatus) {
		result = DeliveryStatus.formatDate(timeStampToString(date),'MMMM d',useCaps);
	}
	return result;
}

function displayItem (id,x,update) {

	var index = getIndex(id);
	var delivery = deliveries[index];
	if (delivery) {

		if (parseInt(x,10) + 1 > delivery.count) x = 0;
		if (update) {
			deliveries[index].displayed = x;
			if (window.widget) widget.setPreferenceForKey(x,id+'-displayed');
		}

		delivery.stopLoad();

		if (delivery.items[x]) {

			var item = delivery.items[x];
			var icon = item.icon;
			var daysClass = '';

			if (delivery.loading || (!icon && item.date == undefined)) {
				icon = 'loading';
			} else {
				var daycount = getDaysApart(item.date);
				if (daycount < 0 && !icon) icon = (delivery.from == 'other') ? 'checkmark' : 'error';	
				if (daycount > 999) {
					daycount = '999+';
					daysClass = 'many';
				} else if (daycount > 99) {
					daysClass = 'small';
				} else if (daycount < 20) {
					daysClass = 'compress';
				}
			}
			setIcon(id,icon);
			$(delivery.id+'-daycount').className = 'daycount '+daysClass;
			$(delivery.id+'-daycount').innerText = daycount;
			$(delivery.id+'-daytext').innerText = (daycount == 1) ? translate('day') : translate('days');

			var itemObj = $(delivery.id+'-item');
			if (delivery.count > 1) {
				var nextItem = x + 1;
				if (nextItem > delivery.count - 1) nextItem = 0;
				var displayNo = x + 1;
				if (displayNo > 9) displayNo = 'Plus';
				itemObj.innerHTML = '<img src="Images/Dot-'+displayNo+'.png" class="no" onclick="displayItem(\''+
					id+'\','+nextItem+',true)"><a href="javascript:displayItem(\''+id+'\','+nextItem+',true)">'+item.title+'</a>';
				itemObj.className = 'item number';
			} else {
				itemObj.innerHTML = item.title;
				itemObj.className = 'item';
			}

			if (delivery.from == 'other' && delivery.htmldate && DeliveryStatus) {
				var date = displayDate(delivery.htmldate,2,false);
				var time = DeliveryStatus.formatTime(delivery.htmldate/1000);
				item.shipText = translateFormat('Site updated %@ at %@',date,time);
				item.shipBold = true;
			}

			var title = delivery.fromTrans+'\n'+trim(removeHtmlEntities(item.title))+'\n';
			if (delivery.lastUpdate) title += updatedText(delivery.lastUpdate)+'\n';

			title += '\n'+formatLine(item.shipText,item.shipDate,1,false,true)+'\n';
			if (item.shipExtra && item.shipExtra != item.shipText) {
				var date = item.statusDate;
				title += formatLine(item.shipExtra,date,1,false,true)+'\n\n';
			}
			title += formatLine(item.deliverText,item.deliverDate,1,false,true);
			if (item.deliverExtra && item.deliverExtra != item.deliverText) {
				title += '\n'+formatLine(item.deliverExtra,item.deliverDate,1,false,true);
			}			
			setTitle(delivery.id,title);

			var shipDate = item.shipText;
			var deliveryDate = item.deliverText;

			if (getDonated() + 1 < installedVersion && deliveryDate == translate('Delivered!')) {
				if (shipDate == translate('Shipped!')) shipDate = deliveryDate;
				deliveryDate = '<a href="javascript:showInfo(\'donate\')">'+
					translate('Please consider a donation')+'</a>';
				item.clickable = true;
			}

			$(delivery.id+'-text').className = 'text';
			$(delivery.id+'-deliver').className = (item.clickable) ? 'deliver clickable' : 'deliver';
			$(delivery.id+'-ship').innerHTML = formatLine(shipDate,item.shipDate,2,item.shipBold,false);
			$(delivery.id+'-deliver').innerHTML = formatLine(deliveryDate,item.deliverDate,2,item.deliverBold,false);

		}

	}

}

function formatLine (text,date,relative,bold,clean) {
	var dateString = '';
	if (date) {
		dateString = displayDate(date,relative,true);
		if (!bold) dateString = '<b>'+dateString+'</b>';
	}
	text = text.replace('%@',dateString);
	if (bold) text = '<b>'+text+'</b>';
	if (clean) text = trim(removeHtmlEntities(stripHTML(text))).replace(/\s+/ig,' ');
	return text;
}

function setTitle (id,title) {
	if (!disableTooltips && title) {
		$(id+'-item').title = title;
		$(id+'-button').title = title;
	}
}

function showMessage (message) {
	$('message').innerHTML = message;
	if (this.id && $(this.id+'-text').className == 'text updating') $(this.id+'-ship').innerHTML = message;
}

function currentlyUpdating () {
	var updating = false;
	if (updateQueue.busy) {
		updating = true;
	} else {
		for (var i in deliveries) {
			if (!deliveries[i].updateComplete()) {
				updating = true;
				break;
			}
		}
	}
	return updating;
}

function finishUpdate () {
	if (!currentlyUpdating()) {
		if (sortByDate) sortDeliveriesByDate();
		showTime(true);
		checkVersion(7,false);
	}
}

function showTime (setToNow) {
	var message = '';
	if (hadSuccess) {
		if (DeliveryStatus && (setToNow || updateStamp)) {
			if (setToNow) updateStamp = (new Date()).getTime();
			message = updatedText(updateStamp);
		}
	} else if (deliveries.length > 0) {
		message = translate('Couldn’t connect');
	}
	showMessage(message);
}

function updatedText (timeStamp) {
	var dateString = displayDate(timeStamp,2,false);
	var timeString = DeliveryStatus.formatTime(timeStamp/1000);
	return translateFormat('Updated %@ at %@',dateString,timeString);
}

function openSite (url) {
	if (window.widget) {
		widget.openURL(url);
		return false;
	}
	return true;
}

function clickDelivery (id) {
	var i = getIndex(id);
	if (i >= 0) {
		clearTimeout(clickTimer);
		var rightNow = new Date();
		if (rightNow - lastClick < clickSpeed) {
			openDeliverySite(i,2);
		} else clickTimer = setTimeout(function(){ openDeliverySite(i,1) },clickSpeed);
		lastClick = rightNow;
	}
}

function openDeliverySite (i,clicks) {

	var x = (deliveries[i].displayed) ? deliveries[i].displayed : 0;
	var location = (clicks > 1 && deliveries[i].items[x]) ? 
		deliveries[i].cleanLocation(deliveries[i].items[x].details.location) : false;

	if (clicks > 1 && location) {
		// escaping the location causes problems with Japanese characters
		openSite('http://maps.google.com/maps?q='+location);
	} else if (deliveries[i].url) {
		openSite(deliveries[i].url);
	}

}


// sort deliveries


function sortDeliveriesByDate () {

	if (currentlyUpdating()) {
		setTimeout(sortDeliveriesByDate,500);
	} else {

		var sortedDeliveries = deliveries.slice(0);
		sortedDeliveries.sort(compareDeliveryDates);
	
		var orderChanged = false;
		for (var x in deliveries) {
			if (deliveries[x] != sortedDeliveries[x]) {
				orderChanged = true;
				break;
			}
		}
		if (orderChanged) {
			var deliveriesObject = document.getElementById('deliveries');
			var deliveryObjects = deliveriesObject.childNodes;
			var objectStorage = {};

			// Store the current delivery objects
			for (var x in deliveryObjects) {
				var id = deliveryObjects[x].id;
				if (id) objectStorage[id] = deliveryObjects[x];
			}
			// Remove them
			for (var x in deliveryObjects) {
				var id = deliveryObjects[x].id;
				if (id) deliveriesObject.removeChild(deliveryObjects[x]);
			}
			// Then re-add them in the new order
			for (var x in sortedDeliveries) {
				var id = sortedDeliveries[x].id;
				deliveriesObject.appendChild(objectStorage[id]);
			}

			deliveries = sortedDeliveries;
			saveDeliveries();
		}

	}

}

function compareDeliveryDates (a,b) {
	var result = comparisonValue(a) - comparisonValue(b);	
	if (!result) result = services.indexOf(a.from) - services.indexOf(b.from);
	if (!result && a.no != b.no) {
		var noArray = [a.no,b.no];
		noArray.sort();
		result = (a.no == noArray[0]) ? -1 : 1;
	}
	return result;
}

function comparisonValue (delivery) {
	var value = 99999999999;
	if (delivery.items) {
		var item = delivery.items[delivery.displayed];
		if (item) {
			var icon = item.icon;
			if (icon == 'error') {
				value = 99999999999;
			} else {
				value = item.deliverDate/1000;
				// if (value < 1 && item.shipDate) value = (item.shipDate/1000) + 3000000000;
				if (value < 1) value = 99999999998;
			}
		}
	}
	return value;
}


// open or close a delivery


function animateQueues () {
	if (openQueue.length > 0 || closeQueue.length > 0) {
		setTimeout(refreshDeliveriesView,0);
		var wait = (openQueue.length > closeQueue.length) ? 100 : 0;
		setTimeout(function(){
				for (var i in openQueue) startAnimation(openQueue[i],0,74,0,1,false,false);
				openQueue = [];
				for (var i in closeQueue) startAnimation(closeQueue[i],closeQueue[i].offsetHeight,0,1,0,finishClose,false);
				closeQueue = [];
			},wait);
	}
}

function startAnimation (object,startHeight,stopHeight,startFade,stopFade,stopAction,id) {

	var startingRect = new AppleRect(0,0,object.offsetWidth,startHeight);
	var finishingRect = new AppleRect(0,0,object.offsetWidth,stopHeight);	
	var rectAnimation = new AppleRectAnimation(startingRect,finishingRect,closeRectHandler);
	rectAnimation.object = object;

	var fadeAnimation = new AppleAnimation(startFade,stopFade,fadeHandler);
	fadeAnimation.object = object;

	var animator = new AppleAnimator(300,13);
	animator.addAnimation(rectAnimation);
	animator.addAnimation(fadeAnimation);
	animator.id = id;
	animator.object = object;
	if (stopAction) animator.oncomplete = stopAction;
	animator.start();

	showScrollBar();

}

function finishClose () {
	$('deliveries').removeChild(this.object);
}

function closeParent () {
	var object = $(this.parent.id);
	startAnimation(object,object.offsetHeight,0,1,0,deliveryClosed,this.parent.id);
}

function closeRectHandler (rectAnimation,currentRect,startingRect,finishingRect) {
	this.object.style.height = currentRect.bottom + 'px';
}

function fadeHandler (currentAnimator,current,start,finish) {
	this.object.style.opacity = current;
}

function deliveryClosed () {
	var index = getIndex(this.id);
	if (index >= 0) {
		deliveries.splice(index,1);
		saveDeliveries();
		$('deliveries').removeChild(this.object);
		refreshDeliveriesView();
		syncDelivery(this.id,'delete',getUnixTime()-sync.offset);
	}
}

function refreshDeliveriesView () {

	var oldDeliveries = $('deliveries').offsetHeight;
	$('deliveries').style.height = (deliveries.length * 74) + 'px';

	if (oldDeliveries != $('deliveries').offsetHeight) {
		setMinMax(currentView);
		
		if (size.height > max.height) {

			nextSide = 'front';
			nextView = 'deliveries';
			adjustSize();

		} else if (maximized && size.height < max.height) {

			nextSide = 'front';
			nextView = 'deliveries';

			var top = 0;
			var out = widget.system("/usr/bin/defaults read com.apple.dashboard layer-gadgets",null).outputString;
			var regex = new RegExp('id = '+widget.identifier+';(.*?)"pos-y" = ([0-9]+);','i');
			var result = stripWhiteSpace(out).match(regex);
			if (result && result[2]) top = parseInt(result[2],10);

			if (top + max.height + 66 < screen.height) {
				adjustSize(true);
			} else setSize(size.width,size.height,true,false);

		} else setSize(size.width,size.height,true,false);

	}
	showNoDeliveries();

}

function showNoDeliveries () {
	if (deliveries.length == 0) {
		$('no-deliveries').innerText = translate('You do not have any deliveries');
		$('no-deliveries').style.display = 'block';
	} else $('no-deliveries').style.display = 'none';
}


// display loading spinner


function startLoad () {

	setIcon(this.id,'loading');

	var self = this;
	this.loading = true;
	this.spinAngle = 0;

	switch(this.fromClass) {
		case 'DHL':
			$(self.id+'-spinner').src = 'Images/DHL/Spinner.png';
			break;
		case 'LaPoste':
			$(self.id+'-spinner').src = 'Images/LaPoste/Spinner.png';
			break;
		case 'UPS':
			$(self.id+'-spinner').src = 'Images/UPS/Spinner.png';
			break;
		case 'AusPost':
		case 'CanadaPost':
		case 'FedEx':
		case 'GLS':
		case 'HongkongPost':
		case 'JapanPost':
		case 'OnTrac':
		case 'PostNL':
			$(self.id+'-spinner').src = 'Images/Spinner-White.png';
			break;
		default:
			$(self.id+'-spinner').src = 'Images/Spinner.png';
			break;
	}

	self.spinTimer = setTimeout(function(){ continueLoad(self) },100);

}

function continueLoad (self) {
	$(self.id+'-spinner').style.webkitTransform = 'rotate('+self.spinAngle+'deg)';
	self.spinAngle += 30;
	self.spinTimer = setTimeout(function(){ continueLoad(self) },100);
}

function stopLoad () {
	clearTimeout(this.spinTimer);
	this.loading = false;
}


// display the info and settings


function showInfo (view) {
	$('syncemail').value = sync.email;
	if (sync.email) $('syncpassword').value = getPassword('junecloud.com',sync.email);
	$('sort').checked = sortByDate;
	checkNotifications();
	setDonated(true);
	$('version').innerText = 'Delivery Status '+readableVersion+' ('+defsVersion+')';
	switchToView('back',view);
}


// add, edit, and save deliveries


function addDelivery () {
	var settings = [];
	settings.from = lastFrom = (widget.preferenceForKey('store')) ? 
		widget.preferenceForKey('store') : 'www.amazon.com';

	editingDelivery = new Delivery(settings);
	updateEditForm(editingDelivery.from);
	fillEditForm(editingDelivery,true);
	switchToView('back','edit');
}

function editDelivery (delivery) {

	var settings = [];
	settings.uuid = delivery.id;
	if (window.widget) {
		settings.from = delivery.from;
		settings.name = delivery.name;
		settings.no = delivery.no;
		settings.extra = delivery.extra;
		settings.date = (delivery.date) ? timeStampToString(delivery.date) : '';
		settings.html = delivery.html;
		settings.htmldate = delivery.htmldate;
		settings.displayed = delivery.displayed;
	}

	editingDelivery = new Delivery(settings);
	editingDelivery.fromEdited = true;
	updateEditForm(editingDelivery.from);
	fillEditForm(editingDelivery,false);
	switchToView('back','edit');

}

function editParent () {
	editDelivery(this.parent);
}

function editPassword (id) {
	var i = getIndex(id);
	if (i >= 0) editDelivery(deliveries[i]);
	$('password').focus();
}

function fillEditForm (delivery,isNew) {

	showServices(delivery.from,showAll);

	$('from').value = delivery.from;
	$('name').value = delivery.name;
	$('no').value = delivery.no;

	if (!isNew) {
		$('extra').value = delivery.extra;
		$('password').value = ($('extra').value) ? getPassword($('from').value,$('extra').value) : '';

		if (delivery.date) {
			setSelect('month',delivery.date.getMonth());
			setSelect('day',delivery.date.getDate());
			setSelect('year',delivery.date.getFullYear());
		} else {
			setSelect('month','');
			setSelect('day','');
			setSelect('year','');
		}
	}

	$('history').selectedIndex = 0;
	populateHistory();

}

function showServices (from,all) {

	while ($('from').hasChildNodes()) $('from').removeChild($('from').firstChild);
	if (favorites.length > 0) {
		$('from').appendChild(newObject('optgroup','from-favs'));
		$('from-favs').label = translate('Favorites');
	}
	for (var x in favorites) {
		$('from').appendChild(new Option(getFromName(favorites[x],true,true),favorites[x]));
	}
	if (all) {
		if ($('from').hasChildNodes()) {
			$('from').appendChild(document.createElement('hr'));
			$('from').appendChild(newObject('optgroup','from-all'));
			$('from-all').label = translate('All Services');
		}
		for (var x in services) {
			$('from').appendChild(new Option(getFromName(services[x],true,true),services[x]));
		}
		$('from').appendChild(document.createElement('hr'));
		$('from').appendChild(new Option(translate('Show favorites only'),'favs'));
	} else {
		if (favorites.indexOf(from) == -1) {
			$('from').appendChild(document.createElement('hr'));
			$('from').appendChild(new Option(getFromName(from,true,true),from));
		}
		$('from').appendChild(document.createElement('hr'));
		$('from').appendChild(new Option(translate('Show all'),'all'));
	}

}

function sortUseCount () {

	var useSorter = [];
	for (var key in useCount) {
		useSorter.push(key);
	}

	useSorter.sort(function(a,b){
		// If the values are equal, favorites should come first
		if (useCount[b] == useCount[a]) {
			aFavorite = (favorites.indexOf(a) == -1) ? 0 : 1;
			bFavorite = (favorites.indexOf(b) == -1) ? 0 : 1;
			return (bFavorite - aFavorite);
		}
		// Otherwise higher values should come first
		return (useCount[b] - useCount[a]);
	});
	
	var useSorted = [];
	for (var i in useSorter) {
		useSorted[useSorter[i]] = useCount[useSorter[i]];
	}
	useCount = useSorted;

}

function updateUseCount (from) {
	useCount[from] = (useCount[from]) ? useCount[from] + 1 : 1;
	if (window.widget) {
		sortUseCount();
		var useTemp = '';
		for (var key in useCount) useTemp += key+':'+useCount[key]+';';
		widget.setPreferenceForKey(useTemp,'usecount');
	}
}

function selectGuessFrom (event,value) {

	// Don't continue if the "from" was previously set, or the return or enter key was pressed
	if (!editingDelivery.fromEdited && event.keyCode != 13 && event.keyCode != 3) {

		var guessArray = guessFrom(value,false);
		if (guessArray) {

			var newFrom = false;
			// If there's only one guess, just set it
			if (guessArray.length == 1) {
				newFrom = guessArray[0];
			} else if (guessArray.indexOf(lastFrom) != -1) {
				newFrom = lastFrom;
			} else {

				// If any favorites are in the list, only consider those
				var favGuessArray = [];
				for (var i in guessArray) {
					if (favorites.indexOf(guessArray[i]) != -1) favGuessArray.push(guessArray[i]);
				}
				if (favGuessArray.length) guessArray = favGuessArray;

				// Get the most used match
				if (!newFrom) {
					for (var key in useCount) {
						if (guessArray.indexOf(key) != -1) {
							newFrom = key;
							break;
						}
					}
				}
				if (!newFrom) newFrom = guessArray[0];

			}
			if (newFrom) {
				showServices(newFrom,showAll);
				$('from').value = newFrom;
				selectFrom(newFrom,false);
			}
	
		}

	}

}

function selectFrom (value,userSelected) {

	if (value == 'all') {

		showAll = true;
		if (window.widget) widget.setPreferenceForKey(true,'showall');
		showServices(editingDelivery.from,true);
		$('from').value = editingDelivery.from;

	} else if (value == 'favs') {

		showAll = false;
		if (window.widget) widget.setPreferenceForKey(false,'showall');
		showServices(editingDelivery.from,false);
		$('from').value = editingDelivery.from;
		
	} else {

		if (userSelected) editingDelivery.fromEdited = true;
		updateEditForm(value);

	}

}

function updateEditForm (from) {

	$('from-text').innerText = getFromName(from,true,true);
	$('delivery-info').innerText = '';

	editingDelivery.from = from;
	setService(editingDelivery,false,false);
	updateFavorite(from);

	if (!extraEdited || !$('extra').value) {
		$('extra').value = (widget.preferenceForKey(from+'-email')) ? 
			widget.preferenceForKey(from+'-email') : '';
		$('password').value = ($('extra').value) ? getPassword(from,$('extra').value) : '';	
		extraEdited = false;
	}

	editingDelivery.changedPassword = false;

	if (from == 'www.apple.com' || from == 'www.apple.com/zip' || from == 'www.apple.com/japan' || 
		from == 'www.apple.com/japanzip' || from == 'www.apple.com/hk') {

		showExtra(true,editingDelivery.passRequired,false);
		$('nolabel').innerText = translate('Order Number:');
		$('extralabel').innerText = translate('Email Address or Zip Code:');

	} else if (from == 'www.city-link.co.uk' || from == 'nolp.dhl.de' || from == 'www.postnl.nl') {

		showExtra(true,editingDelivery.passRequired,false);
		$('nolabel').innerText = translate('Tracking Number:');
		$('extralabel').innerText = translate('Shipping Zip Code:');

	} else if (from == 'www.poste.it') {

		showExtra(false,false,false);
		$('nolabel').innerText = translate('Tracking Number:');

	} else if (from == 'other') {

		showExtra(true,false,true);
		$('nolabel').innerText = translate('Tracking Number:');
		$('extralabel').innerText = translate('Web Site:');
		$('datelabel').innerText = translate('Delivery Date:');

	} else if (editingDelivery.extraRequired == false) {

		showExtra(false,false,false);
		if (from == 'www.tnt.com') {
			$('nolabel').innerText = translate('Consignment Number:');
		} else if (from == 'www.royalmail.com' || from == 'www.tnt.com/ref') {
			$('nolabel').innerText = translate('Reference Number:');
		} else $('nolabel').innerText = translate('Tracking Number:');

	} else {

		showExtra(true,editingDelivery.passRequired,false);
		$('extralabel').innerText = translate('Email Address:');
		$('nolabel').innerText = translate('Order Number:');

	}

	$('no').placeholder = (from == 'other') ? translate('Optional') : '';

}

function showExtra (extraVisible,passVisible,dateVisible) {
	$('extraField').style.display = (extraVisible) ? 'block' : 'none';
	$('passwordField').style.display = (passVisible) ? 'block' : 'none';
	$('dateField').style.display = (dateVisible) ? 'block' : 'none';
	if (!extraVisible) $('extra').value = '';
	if (!passVisible) $('password').value = '';
	$('extra').placeholder = (editingDelivery.extraRequired) ? '' : translate('Optional');
}

function editedExtra () {
	extraEdited = true;
	$('password').value = ($('extra').value) ? getPassword($('from').value,$('extra').value) : '';
}

function editedPassword () {
	editingDelivery.changedPassword = true;
}

function updateFavorite (from) {
	$('fav').className = (favorites.indexOf(from) != -1) ? 'favorite' : '';
}

function toggleFavorite () {

	var from = $('from').value;
	var index = favorites.indexOf(from);
	if (index == -1) {
		var newFavorites = [];
		favorites.push(from);
		for (var x in services) {
			if (favorites.indexOf(services[x]) != -1) newFavorites.push(services[x]);
		}
		favorites = newFavorites;
	} else favorites.splice(index,1);

	if (window.widget) widget.setPreferenceForKey(favorites.join(';'),'favorites');

	updateFavorite(from);
	showServices(from,showAll);
	sortUseCount();
	$('from').value = from;

}

function saveSettings (finish) {
	if (currentView == 'edit') {
		if (checkComplete(editingDelivery)) {
			// Important to call this first, so any size adjustments are made later
			if (finish) finishEditing();
			saveDelivery(editingDelivery);
		}
	} else {
		sortByDate = $('sort').checked;
		growlEnabled = $('growl').checked;
		pushEnabled = $('push').checked;
		largePrint = $('size').checked;
		if (window.widget) {
			widget.setPreferenceForKey($('sort').value,'sortbydate');
			widget.setPreferenceForKey($('growl').value,'usegrowl');
			widget.setPreferenceForKey($('push').value,'usepush');
			widget.setPreferenceForKey($('size').value,'size');
		}
		if (finish) finishEditing();
	}
}

function disableSort () {
	sortByDate = false;
	widget.setPreferenceForKey(null,'sortbydate');
}

function finishEditing () {
	switchToView('front','deliveries');
}

function checkComplete (delivery) {
	var result = false;
	var message = '';
	var missingFields = [];
	if ($('from').value != 'other') {
		if (!$('no').value) missingFields.push(getLabel('no'));
		if (delivery.extraRequired && !$('extra').value) missingFields.push(getLabel('extra'));
		if (delivery.passRequired && !$('password').value) missingFields.push(getLabel('password'));
	}
	switch (missingFields.length) {
		case 0:
			result = true;
			break;
		case 1:
			result = false;
			message = translateFormat("%@ is required.",
				missingFields[0]);
			break;
		case 2:
			result = false;
			message = translateFormat("%@ and %@ are required.",
				missingFields[0],missingFields[1]);
			break;
		default:
			result = false;
			message = translateFormat("%@, %@, and %@ are required.",
				missingFields[0],missingFields[1],missingFields[2]);
			break;
	}
	$('delivery-info').innerText = message;
	return result;
}

function getLabel (field) {
	var label = $(field+'label').innerText;
	return label.replace(/:$/i,'');
}

function saveDelivery (delivery) {

	if (!delivery.id) delivery.id = getUUID();
	if (window.widget) {

		var now = getUnixTime();
		$('no').value = trim($('no').value);
		$('extra').value = trim($('extra').value);

		widget.setPreferenceForKey($('name').value,delivery.id+'-itemname');
		widget.setPreferenceForKey($('from').value,delivery.id+'-store');
		widget.setPreferenceForKey($('from').value,'store');
		widget.setPreferenceForKey($('no').value,delivery.id+'-orderno');
		widget.setPreferenceForKey($('extra').value,delivery.id+'-email');
		widget.setPreferenceForKey($('extra').value,$('from').value+'-email');
		widget.setPreferenceForKey(now,delivery.id+'-modified');

		if ($('from').value == 'other' && $('month').value) {

			var date = new Date();
			if ($('year').value) date.setYear($('year').value);
			if ($('month').value) date.setMonth($('month').value);
			date.setDate(($('day').value) ? $('day').value : 1);

			month = date.getMonth() + 1;
			month = (month < 10) ? '0'+month : month;
			day = date.getDate();			
			day = (day < 10) ? '0'+day : day;
			year = date.getFullYear();
			date = year+'-'+month+'-'+day;

			widget.setPreferenceForKey(date,delivery.id+'-date');
			widget.setPreferenceForKey(null,delivery.id+'-html');
			widget.setPreferenceForKey(null,delivery.id+'-htmldate');
			
		} else widget.setPreferenceForKey(null,delivery.id+'-date');

		if (DeliveryStatus && $('password').value) {
			DeliveryStatus.setPassword($('from').value,$('extra').value,$('password').value);
			if (delivery.changedPassword) {
				var shouldUpdate = false;
				for (var i in deliveries) {	
					if (deliveries[i].id != delivery.id &&
						deliveries[i].from == $('from').value && 
						deliveries[i].extra == $('extra').value) {
						deliveries[i].password = $('password').value;
						deliveries[i].nextUpdate = 0;
						shouldUpdate = true;
					}
				}
				if (shouldUpdate) updateDeliveries(false,true);
			}
			$('password').value = '';
		}

		updateHistory(delivery.id);
		extraEdited = false;

	}

	delivery = prepareDelivery(delivery.id,false);
	updateQueue.add(delivery);
	updateQueue.updateIfIdle();
	syncDelivery(delivery.id,'add',0);

}

function saveHTML (delivery) {
	if (window.widget) {
		widget.setPreferenceForKey(delivery.html,delivery.id+'-html');
		widget.setPreferenceForKey(delivery.htmldate,delivery.id+'-htmldate');
	}
}

function prepareDelivery (id,deleteIt) {

	var delivery;
	var i = getIndex(id);

	if (deleteIt) {
		if (i >= 0) {
			deliveries.splice(i,1);
			closeQueue.push($(id));
		}	
	} else {
		if (i >= 0) {
			delivery = loadDelivery(id,i);			
		} else {
			delivery = loadDelivery(id,-1);
			deliveries.unshift(delivery);
			if (delivery.unfrozen) displayItem(delivery.id,delivery.displayed,false);
			updateUseCount(delivery.from);
		}
	}
	saveDeliveries();
	return delivery;

}

function saveDeliveries () {
	var list = [];
	for (var i in deliveries) list[i] = deliveries[i].id;
	list = list.join(';');
	widget.setPreferenceForKey(list,'deliveries');
}


// growl


function checkNotifications () {

	growlEnabled = (widget.preferenceForKey('usegrowl')) ? true : false;
	$('growl').checked = growlEnabled;
	var growlRunning = (DeliveryStatus && DeliveryStatus.getGrowl()) ? true : false;
	$('growlField').className = (growlRunning) ? '' : 'disabled';

	if (syncEnabled()) {
		pushEnabled = (widget.preferenceForKey('usepush')) ? true : false;
		$('push').checked = pushEnabled;
		$('push').disabled = false;
		$('pushField').className = '';
	} else {
		pushEnabled = false;
		$('push').checked = false;
		$('push').disabled = true;
		$('pushField').className = 'disabled';
	}

}

function activeUse () {
	// If Dashboard is open and the computer has been used in the past minute, it's active
	var result = false;
	if (dashboardActive) {
		var idleTime = (DeliveryStatus) ? DeliveryStatus.getIdleTime() : 0;
		if (idleTime < 60) result = true;
	}
	return result;
}

function growlEnabledAndRunning () {
	return (growlEnabled && DeliveryStatus && DeliveryStatus.getGrowl()) ? true : false;
}

function showNotifications (delivery) {

	var useGrowl = growlEnabledAndRunning();
	if (delivery.success > 0 && (useGrowl || pushEnabled)) {

		var yesterday =  (new Date()).getTime() - 86400000;
		var emptyStatus = [translate('Shipped!'),translate('Ship date unknown')];
		var hasError = (delivery.success < 2);
		var key = (hasError) ? delivery.id+'-error' : delivery.id+'-status';
		var newUpdates = [];
		var lastUpdates = (widget.preferenceForKey(key)) ? JSON.parse(widget.preferenceForKey(key)) : [];

		for (var x in delivery.items) {

			var item = delivery.items[x];

			// 1: status change
			// 2: delivered
			// 3: error
			// 4: new version

			var type = 1;
			if (hasError) {
				type = 3;
			} else if (item.status.match(/^complete$/i)) {
				type = 2;
			}

			var lastUpdate = lastUpdates[x];
			var lastArray = (lastUpdate) ? lastUpdate.split(';') : [];
			var lastStatus = (lastArray[1]) ? lastArray[1] : '';
			var lastDate = lastArray[2];
			var lastStatusDate = lastArray[3];
			var lastType = lastArray[4];

			var compareItem = item.title.replace(/[;]/g,'');
			var compareStatus = formatLine(item.shipText,item.shipDate,0,false,true).replace(/[:;,.]/g,'');
			if (delivery.from == 'other') compareStatus = delivery.htmldate;
			var compareDate = item.date;
			var compareStatusDate = item.statusDate;
			var compareType = type;

			var thisUpdate = [compareItem,compareStatus,compareDate,compareStatusDate,compareType].join(';');
			var realUpdate = thisUpdate; // Only needed for debugging

			var ratio = 0;
			var changed = false;

			// First check to see if this exact status was displayed for a different item before.
			// If it was we assume the items were just reordered, and don't show anything, just save the new status.

			if (lastUpdates.indexOf(thisUpdate) == -1) {

				// Ignore dates in the past and (essentially) empty status updates
				if (compareDate < yesterday && lastDate) compareDate = lastDate;
				// Once we start picking up the time, copy over the previous status if the date and time are exact
				// This would fix problems with DHL Express, PostNL, possibly others
				if (lastStatus && emptyStatus.indexOf(compareStatus) != -1) {
					compareStatus = lastStatus;
					compareStatusDate = lastStatusDate;
					compareType = lastType;
				}
				thisUpdate = [compareItem,compareStatus,compareDate,compareStatusDate,compareType].join(';');

				if (hasError) {

					var ratio = diffRatio(lastStatus,compareStatus);
					if (ratio < 0.72) changed = true; // Status changed significantly
					// if (changed) alert ('Error text changed ('+delivery.no+')');

				} else if (delivery.from == 'other') { // Other delivery

					if (compareStatus && compareStatus != lastStatus) changed = true;
					// if (changed) alert ('Other text changed ('+delivery.no+')');

				} else if (compareType == 2 && lastType != 2) { // Changed to delivered

					changed = true;
					// alert('Delivered status changed ('+delivery.no+')');

				} else if (compareDate && compareDate != lastDate) { // Ship or delivery date changed

					changed = true;
					// alert('Ship or delivery date changed ('+delivery.no+')');

				} else {
					var ratio = diffRatio(lastStatus,compareStatus);
					if (ratio < 1) {

						// Status changed significantly or the status date changed
						// Ignore 0.72 and above, display 0.72 and below, must display 0.62 and below
						if (!delivery.ignoreText && ratio < 0.72) {

							changed = true;
							// alert('Ratio is less than 0.72 ('+ratio+' for '+delivery.no+')');

						} else if (compareStatusDate && compareStatusDate != lastStatusDate) {

							changed = true;
							// alert('Status date changed ('+ratio+' for '+delivery.no+')');

						}

					}
				}

			} else {

				// if (lastUpdates.indexOf(thisUpdate) != x) alert('Item found in a different position ('+delivery.no+')');

			}

			if (changed) {

				// alert('Last updates: '+lastUpdates.join('\n'));
				// alert('This update: '+thisUpdate);

				var inuse = activeUse();
				// if (inuse) alert('In use?');

				var title = removeHtmlEntities(item.title);
				var status = formatLine(item.shipText,item.shipDate,2,false,true)+'\n'+
					formatLine(item.deliverText,item.deliverDate,2,false,true);

				if (useGrowl && !inuse) {
					DeliveryStatus.setGrowl(type,title,status,'Icon');
				}

				if (pushEnabled && type <= 2 && !inuse) {

					// The limit for data is around 161 bytes
					// Display only fits around 150, 35 per line

					if (title.length > 70) title = title.substring(0,70)+'…';
					var charsLeft = 150 - title.length;
					if (status.length > charsLeft) status = status.substring(0,charsLeft)+'…';
					pushNotification('push',title+'\n'+status,delivery.id);

				}

			} else {

				if (thisUpdate != lastUpdate) alert('No notification! '+delivery.no+' ratio: '+ratio+
					'\nold: '+lastUpdate+'\nnew: '+realUpdate);

			}

			newUpdates.push(thisUpdate);
	
		}

		widget.setPreferenceForKey(JSON.stringify(newUpdates),key);

	}

}

function diffRatio (oldText,newText) {
	var ratio = 0;
	if (oldText == newText) {
		ratio = 1;
	} else if (typeof oldText == 'string' && typeof newText == 'string') {
		var oldLines = difflib.stringAsLines(oldText.replace(/\s+/g,'\n'));
		var newLines = difflib.stringAsLines(newText.replace(/\s+/g,'\n'));
		var sm = new difflib.SequenceMatcher(oldLines,newLines);
		ratio = sm.quick_ratio();
	}
	return ratio;
}

function pushNotification (cmd,data,id) {

	var pushData = 'cmd='+cmd+'&type=widget&version='+syncVersion+
		'&client='+encodeURIComponent(sync.client)+
		'&email='+encodeURIComponent(sync.email)+
		'&'+passwordOrCode()+
		'&data='+encodeURIComponent(data);
	if (id) pushData += '&id='+encodeURIComponent(id);
	var args = {method:'pushNotification',cmd:cmd,data:data,id:id};	

	alert('Sending notification: '+data);
	sync.loadPage('https://junecloud.com/sync/deliveries/push.php',false,pushData,args);

}


// donations


function setDonated (getValue) {

	var value = false;
	if (getValue) {
		if (getDonated() + 1 >= installedVersion) value = true;
	} else {
		if ($('alreadydonated').checked) value = true;
	}
	if (value == true) {
		$('alreadydonated').checked = true;
		widget.setPreferenceForKey(installedVersion,'donated');
		$('donate-info').innerText = translate('Thank you for your donation! Your support allows us to keep making Delivery Status the best package tracking widget possible.');
	} else {
		$('alreadydonated').checked = false;
		widget.setPreferenceForKey(0,'donated');
		$('donate-info').innerText = translate('This widget is free, but it takes a lot of time to keep it working with so many different services. Please consider a small donation to help support Delivery Status!');
	}
	$('alreadydonatedlabel').innerText = translate('Check this box if you have donated.');

}

function getDonated () {
	var donatedVersion = 0;
	if (window.widget) donatedVersion = widget.preferenceForKey('donated');
	return donatedVersion;
}

function openDonate () {
	openSite('http://junecloud.com/software/donate/');
}


// history


function populateHistory () {

	if (window.widget) {

		// var prefsVersion = widget.preferenceForKey('prefsversion');
		// if (prefsVersion < 5.0) widget.setPreferenceForKey(5.0,'prefsversion');

		// check for hidden historydays setting

		historyDays = (widget.preferenceForKey('historydays') > 0) ? widget.preferenceForKey('historydays') : 30;

		// populate the item history

		var history = (widget.preferenceForKey('history')) ? widget.preferenceForKey('history') : '';
		var historyArray = history.split(';');
		var newHistoryArray = [];

		var optCount = 1;
		var optSelected = 0;
		var popup = $('history');
		while (popup.hasChildNodes()) {
			popup.removeChild(popup.firstChild);
		}
		popup.options[0] = new Option('');

		for (var i in historyArray) {
			var id = historyArray[i];
			if (widget.preferenceForKey(id+'-store')) {

				var updated = widget.preferenceForKey(id+'-modified');
				if (!updated) {
					updated = getUnixTime();
					widget.setPreferenceForKey(updated,id+'-modified');
				}
				if (updated + (86400 * historyDays) > getUnixTime() || optCount <= 25) {

					newHistoryArray.push(id);
					var from = widget.preferenceForKey(id+'-store');
					var item = widget.preferenceForKey(id+'-orderno');
					if (id == editingDelivery.id) optSelected = optCount;

					if (widget.preferenceForKey(id+'-historytitle')) {
						item = widget.preferenceForKey(id+'-historytitle');
					} else if (widget.preferenceForKey(id+'-itemname')) {
						item = widget.preferenceForKey(id+'-itemname');
					}

					from = getFromName(from,true,false);
					popup.options[optCount] = new Option(from+': '+item,id);
					optCount++;

				} else removeDelivery(id);

			} else removeDelivery(id);
		}
		if (popup.options.length > 1) {
			popup.options[optCount] = new Option(translate('Clear History'),'Clear History');
			var newElement = document.createElement('hr');
			popup.insertBefore(newElement,popup.options[optCount]);
		}
		popup.options[optSelected].selected = true;
		setSelect('history',false);
		history = newHistoryArray.join(';');
		widget.setPreferenceForKey(history,'history');

	}

}

function loadHistory (id) {
	if (id == 'Clear History') {

		$('history-text').innerText = '';
		var history = (widget.preferenceForKey('history')) ? widget.preferenceForKey('history') : '';
		var historyArray = history.split(';');
		var newHistory = [];
		for (var i in historyArray) {
			if (!removeDelivery(historyArray[i])) newHistory.push(historyArray[i]);
		}
		widget.setPreferenceForKey(newHistory.join(';'),'history');
		populateHistory();

	} else {

		setSelect('history',false);
		
		if (id) {
			if (!editingDelivery.id) {
				if (getIndex(id) >= 0) {
					editingDelivery.id = getUUID();
				} else editingDelivery.id = id;
			}
	
			var from = (widget.preferenceForKey(id+'-store')) ? 
				widget.preferenceForKey(id+'-store') : 'www.amazon.com';
	
			// Make sure the "from" menu includes the selected service
			if (!showAll) showServices(from,false);
	
			$('name').value = (widget.preferenceForKey(id+'-itemname')) ? 
				widget.preferenceForKey(id+'-itemname') : '';
			$('from').value = from;
			$('extra').value = (widget.preferenceForKey(id+'-email')) ? 
				widget.preferenceForKey(id+'-email') : '';
			$('no').value = (widget.preferenceForKey(id+'-orderno')) ? 
				widget.preferenceForKey(id+'-orderno') : '';
			if ($('extra').value) $('password').value = getPassword($('from').value,$('extra').value);
	
	
			var dateString = (widget.preferenceForKey(id+'-date')) ? 
				widget.preferenceForKey(id+'-date').toString().replace(/-/g,'/') : '';
	
			if (dateString) {
				var date = new Date(dateString);
				setSelect('month',date.getMonth());
				setSelect('day',date.getDate());
				setSelect('year',date.getFullYear());
			} else {
				setSelect('month','');
				setSelect('day','');
				setSelect('year','');
			}
	
			extraEdited = true;
			updateEditForm($('from').value);
		}

	}
}

function updateHistory (id) {
	if (window.widget && id) {

		var history = (widget.preferenceForKey('history')) ? widget.preferenceForKey('history') : '';
		var historyArray = history.split(';');

		var orderFound = false;
		for (var i in historyArray) {
			if (id == historyArray[i]) {
				orderFound = true;
				if (i > 0) {
					historyArray.splice(i,1);
					orderFound = false;
				}
				break;
			}
		}
		if (!orderFound) historyArray.unshift(id);
		history = historyArray.join(';');
		widget.setPreferenceForKey(history,'history');

	}
}

function removeDelivery (id) {
	var removed = false;
	if (id && getIndex(id) == -1) {
		widget.setPreferenceForKey(null,id+'-itemname');
		widget.setPreferenceForKey(null,id+'-store');
		widget.setPreferenceForKey(null,id+'-orderno');
		widget.setPreferenceForKey(null,id+'-email');
		widget.setPreferenceForKey(null,id+'-size');
		widget.setPreferenceForKey(null,id+'-displayed');
		widget.setPreferenceForKey(null,id+'-error');
		widget.setPreferenceForKey(null,id+'-status');
		widget.setPreferenceForKey(null,id+'-historytitle');
		widget.setPreferenceForKey(null,id+'-date');
		widget.setPreferenceForKey(null,id+'-html');
		widget.setPreferenceForKey(null,id+'-htmldate');
		widget.setPreferenceForKey(null,id+'-modified');
		widget.setPreferenceForKey(null,id+'-saved');

		// No longer used as of 5.5, remove this in the future
		widget.setPreferenceForKey(null,id+'-item');
		widget.setPreferenceForKey(null,id+'-items');

		removed = true;
	}
	return removed;
}


// version checking


function getCurrentVersion () {

	var request = new XMLHttpRequest();
	request.open('GET','Info.plist',false);
	request.send();

	var nodes = request.responseXML.getElementsByTagName('dict')[0].childNodes;
	var nodeLength = nodes.length;
	for (var i = 0; i < nodeLength; i++) {
		if (nodes[i].nodeType == 1 && nodes[i].tagName.toLowerCase() == 'key') {
			if (nodes[i].firstChild.data == 'CFBundleShortVersionString') {
				readableVersion = nodes[i+2].firstChild.data;
			} else if (nodes[i].firstChild.data == 'CFBundleVersion') {
				var result = nodes[i+2].firstChild.data;
				result = result.replace(/([0-9]+)\.([0-9]+)\.([0-9]+)/,'$1.$2$3');
				installedVersion = currentVersion = parseFloat(result);				
			}
		} 
	} 

}

function checkVersion (days,skipDismissed) {

	var lastVersionCheck = (widget.preferenceForKey('lastversioncheck')) ? 
		widget.preferenceForKey('lastversioncheck') : 0;
	var dismissedUpdate = (widget.preferenceForKey('dismissedupdate')) ? 
		widget.preferenceForKey('dismissedupdate') : 0;
	var currentTime = (new Date()).getTime();

	if (skipDismissed || !dismissedUpdate || dismissedUpdate + (86400000 * dismissDays) < currentTime) {
		if (lastVersionCheck + (86400000 * days) < currentTime) {
			checkVersionNow();
		} else {
			currentVersion = (widget.preferenceForKey('currentversion')) ? 
				parseFloat(widget.preferenceForKey('currentversion')) : installedVersion;
			if (currentVersion > installedVersion) showUpdateBadge();
		}
	}

}

function checkVersionNow () {
	sync.loadPage('https://junecloud.com/software/mac/version.php',getVersion,'id='+appId,false);
}

function getVersion () {

	var currentTime = (new Date()).getTime();
	widget.setPreferenceForKey(currentTime,'lastversioncheck');

	if (this.status == 200 && this.responseXML) {
		for (var child = this.responseXML.firstChild; child != null; child = child.nextSibling) {
			if (child.nodeName == 'versionstatus') {
				var itemlist = child;
				for (var item = itemlist.firstChild; item != null; item = item.nextSibling) {
					if (item.nodeName == 'version') {
						currentVersion = parseFloat(item.getAttribute('value'));
						widget.setPreferenceForKey(currentVersion,'currentversion');
					} else if (item.nodeName == 'download') {
						downloadUrl = item.getAttribute('value');
					}
				}
				break;
			}
		}
	}

	if (currentVersion > installedVersion) {
		showUpdateBadge();
		if (DeliveryStatus && growl) DeliveryStatus.setGrowl(4,'Delivery Status',
			translate('A new version of Delivery Status is available!'),'Icon');
	}

	this.reqComplete++;
	return;

}

function showUpdateBadge () {
	$('getupdate').href = downloadUrl;
	$('getupdate').title = translate('A new version of Delivery Status is available! Click here to download it.');
	$('updatebox').style.display = 'block';
}

function dismissUpdate () {
	widget.setPreferenceForKey((new Date()).getTime(),'dismissedupdate');
	$('updatebox').style.display = 'none';
}


// cookie request functions


function loadCookiePage (url,method,postData,args) {

	var reqNo = this.reqCount;
	this.reqCount++;

	var request = {};
	request.abort = function() { };
	request.checkForData = checkForData;
	request.getTracker = getTracker;
	request.delivery = this;
	request.runCount = 0;
	request.id = this.id;
	request.args = (args) ? args : [];
	request.oncomplete = method;
	if (!postData) postData = '';

	this.req[reqNo] = request;

	if (DeliveryStatus) {
		request.resultId = DeliveryStatus.loadWebPage(url,postData,navigator.userAgent);
		if (!request.resultId) request.runCount = 100; // Fail immediately if there's no resultId
		setTimeout(function(){ request.checkForData() },300);
	}

}

function checkForData () {

	var result;
	if (DeliveryStatus && this.resultId && this.id) 
		result = DeliveryStatus.getWebPageForId(this.resultId);

	// Get data or time out after 30 seconds (300ms x 100)
	if (!result && this.runCount >= 100) result = '503';
	if (result) {

		if (result.match(/^[0-9]+$/)) {
			this.responseText = '';
			this.status = parseInt(result,10);
			if (this.status = 503) this.oncomplete = connectFailed;
		} else {
			this.responseText = result;
			this.status = 200;
		}

		switch(this.oncomplete) {
			case connectFailed:
				this.delivery.connectFailed();
				break;
			case sessionAdobe:
				this.sessionAdobe = sessionAdobe;
				this.sessionAdobe();
				break;
			case getAdobe:
				this.getAdobe = getAdobe;
				this.getAdobe();
				break;
			case sessionAmazon:
				this.sessionAmazon = sessionAmazon;
				this.sessionAmazon(); 
				break;
			case getAmazon:
				this.sessionAmazon = sessionAmazon;
				this.getAmazon = getAmazon;
				this.getAmazon(); 
				break;
			case getGoogle:
				this.getGoogle = getGoogle;
				this.getGoogle();
				break;
			case getHermes:
				this.getHermes = getHermes;
				this.getHermes();
				break;
			case getTNT:
				this.getTNT = getTNT;
				this.getTNT();
				break;
			case getParcelforce:
				this.getParcelforce = getParcelforce;
				this.getParcelforce();
				break;
			case getTracker:
				this.getTracker();
				break;
		}

	} else {
		this.runCount++;
		var request = this;
		setTimeout(function(){ request.checkForData() },300);
	}

}


// syncing


function startSyncNow () {
	sync.force = true;
	startSync();
}

function changedSyncEmail () {
	if ($('cmd').value == 'login') $('syncpassword').value = 
		($('syncemail').value) ? getPassword('junecloud.com',$('syncemail').value) : '';
}

function setSync (cmd) {

	$('cmd').value = cmd;

	if (sync.success && sync.email) {
		$('login-info').innerText = translateFormat('You are currently signed in as %@',sync.email);
		selectTab('sync signedin');
	} else {
		if (cmd == 'register') {
			$('syncemail').value = '';
			$('syncpassword').value = '';
			$('syncconfirm').value = '';
			$('syncname').value = '';
			$('syncterms').checked = false;
			selectTab('sync register');
		} else selectTab('sync signin');
	}

}

function saveSync () {

	if (!$('syncemail').value) {
		$('sync-info').innerText = translate('Please enter your email address.');
	} else if (!$('syncpassword').value) {
		$('sync-info').innerText = translate('Please enter your password.');
	} else if ($('cmd').value == 'register' && $('syncpassword').value != $('syncconfirm').value) {
		$('sync-info').innerText = translate('Both password fields must match.');
	} else if ($('cmd').value == 'register' && !$('syncterms').checked) {
		$('sync-info').innerText = translate('You must agree to the Terms of Service to continue.');
	} else {

		sync.email = $('syncemail').value;
		sync.password = true;

		widget.setPreferenceForKey(sync.email,'syncemail');
		if (DeliveryStatus) DeliveryStatus.setPassword('junecloud.com',sync.email,$('syncpassword').value);

		var syncData = 'cmd='+$('cmd').value+'&type=widget&version='+syncVersion+'&osversion='+macOSVersion()+
			'&client='+encodeURIComponent(sync.client)+
			'&updated='+encodeURIComponent(sync.updated)+
			'&now='+encodeURIComponent(getUnixTime())+
			'&email='+encodeURIComponent($('syncemail').value);

		if ($('cmd').value == 'register') {

			sync.first = 1;
			syncData += '&newpassword='+encodeURIComponent($('syncpassword').value)+
				'&confirmpass='+encodeURIComponent($('syncconfirm').value)+
				'&name='+encodeURIComponent($('syncname').value);
			if ($('syncterms').checked) syncData += '&terms=1';

		} else {

			sync.first = 2;
			syncData += '&password='+encodeURIComponent($('syncpassword').value);

		}

		showMessage(translate('Syncing with Junecloud…'));
		$('sync-info').innerHTML = translate('Syncing with Junecloud…');
		sync.loadPage('https://junecloud.com/sync/deliveries/xml.php',getSyncResult,syncData,false);

	}

}

function syncEnabled () {
	return (sync.email && sync.password) ? true : false;
}

function passwordOrCode () {
	return (sync.code) ? 'code='+encodeURIComponent(sync.code) : 
		'password='+encodeURIComponent(getPassword('junecloud.com',sync.email));
}

function timeForSync () {
	var result = false;
	if (syncEnabled()) {
		if (sync.force) {
			result = true;
			sync.force = false;
		} else {
			var now = getUnixTime() - sync.offset;
			var inuse = activeUse();
			if ((inuse && now > sync.updated + 300) || (!inuse && now > sync.updated + 1800)) {
				result = true;
			}
		}
	}
	return result;
}

function syncDelivery (id,cmd,date) {
	if (syncEnabled()) {

		var modified = date;
		if (!modified && widget.preferenceForKey(id+'-modified')) modified = 
			parseFloat(widget.preferenceForKey(id+'-modified')) - sync.offset;

		var syncData = 'cmd='+cmd+'&type=widget&version='+syncVersion+'&osversion='+macOSVersion()+'&defs='+defsVersion+
			'&client='+encodeURIComponent(sync.client)+
			'&updated='+encodeURIComponent(sync.updated)+
			'&now='+encodeURIComponent(getUnixTime())+
			'&email='+encodeURIComponent(sync.email)+
			'&'+passwordOrCode()+
			'&uuid='+encodeURIComponent(id);
		if (modified) syncData += '&modified='+modified;

		if (cmd == 'add') {
			syncData += '&from='+encodeURIComponent(widget.preferenceForKey(id+'-store'))+
				'&name='+encodeURIComponent(widget.preferenceForKey(id+'-itemname'))+
				'&no='+encodeURIComponent(widget.preferenceForKey(id+'-orderno'))+
				'&extra='+encodeURIComponent(widget.preferenceForKey(id+'-email'));
			if (widget.preferenceForKey(id+'-date'))
				syncData += '&date='+encodeURIComponent(widget.preferenceForKey(id+'-date'));
		}

		showMessage(translate('Syncing with Junecloud…'));
		$('sync-info').innerHTML = translate('Syncing with Junecloud…');

		var args = {method:'syncDelivery',cmd:cmd,id:id,date:modified};
		sync.loadPage('https://junecloud.com/sync/deliveries/xml.php',getSyncResult,syncData,args);

	}
}

function queueDelivery (id,cmd,date) {
	var modified = date;
	if (!modified && widget.preferenceForKey(id+'-modified')) modified = 
		parseFloat(widget.preferenceForKey(id+'-modified')) - sync.offset;
	var item = {method:'syncDelivery',cmd:cmd,id:id,date:modified};
	syncQueue.push(item);
}

function addBackToQueue (item) {
	if (item) {
		for (i in syncQueue) {
			if (syncQueue[i].method == item.method && 
				syncQueue[i].id == item.id) {
				syncQueue.splice(i,1);
				break;	
			}
		}
		syncQueue.push(item);
	}
}

function removeFromQueue (id,olderThan) {
	for (var i in syncQueue) {
		if (syncQueue[i].id == id) {
			if (syncQueue[i].date < olderThan) {
				syncQueue.splice(i,1);
				return true;
			} else return false;
		}
	}
	return true;
}

function startSync () {

	var syncNow = false;
	var loggedIn = false;
	
	if (syncEnabled()) {
		if (syncQueue.length || timeForSync()) syncNow = true;
		loggedIn = true;
	} else {
		var currentTime = getUnixTime();		
		// If syncing is disabled, update once a week,
		// or once a day if there are errors
		if (currentTime >= defsUpdate + 604800) {
			syncNow = true;
		} else if (currentTime >= defsUpdate + 86400) {
			for (var i in deliveries) {
				if (deliveries[i].success < 2) {
					syncNow = true;
					break;
				}
			}
		}
	}

	sync.updateAfter = true;
	if (syncNow) {
		if (!continueSync()) {
			var syncData = 'type=widget&version='+syncVersion+'&osversion='+macOSVersion()+'&defs='+defsVersion;
			if (loggedIn) {
				syncData += '&cmd=get&client='+encodeURIComponent(sync.client)+
					'&updated='+encodeURIComponent(sync.updated)+
					'&now='+encodeURIComponent(getUnixTime())+
					'&email='+encodeURIComponent(sync.email)+
					'&'+passwordOrCode();
				showMessage(translate('Syncing with Junecloud…'));
				$('sync-info').innerHTML = translate('Syncing with Junecloud…');
			} else showMessage(translate('Updating service definitions…'));
			sync.loadPage('https://junecloud.com/sync/deliveries/xml.php',getSyncResult,syncData,false);
		}
	} else syncFinish();

}

function shouldContinue () {
	return (sync.success && syncQueue.length) ? true : false;
}

function continueSync () {
	var didContinue = false;
	if (shouldContinue()) {
		var item = syncQueue.shift();
		if (item.method == 'syncDelivery') {
			syncDelivery(item.id,item.cmd,item.date);
		} else if (item.method == 'pushNotification') {
			pushNotification(item.cmd,item.data,item.id);
		}
		didContinue = true;
	}
	return didContinue;
}

function searchArray (needle,haystack) {
	result = false;
	for (var i in haystack) {
		if (needle == haystack[i]) {
			result = true;
			break;
		}
	}
	return result;
}

function getSyncResult () {

	var success = false;
	var retry = false;
	var updateData;
	var updateVersion;

	if (this.status == 200 && this.responseXML) {
		for (var child = this.responseXML.firstChild; child != null; child = child.nextSibling) {
			if (child.nodeName == 'result') {
				var items = child;
				for (var item = items.firstChild; item != null; item = item.nextSibling) {

					if (item.nodeName == 'client') {

						sync.client = item.getAttribute('value');
						if (window.widget) widget.setPreferenceForKey(sync.client,widget.identifier+'-syncclient');

					} else if (item.nodeName == 'code') {

						sync.code = item.getAttribute('value');
						// if (DeliveryStatus) DeliveryStatus.setPassword('junecloud.com',appId,sync.code);

					} else if (item.nodeName == 'message') {

						var message = translate(item.getAttribute('value'));
						if (message) showMessage(message);
						$('sync-info').innerHTML = message.replace(/…$/,'.').replace(/・・・$/,'');

					} else if (item.nodeName == 'success') {

						if (item.getAttribute('value') == 'true') {
							success = true;
							if (sync.first == 2) {
								for (var i in deliveries) queueDelivery(deliveries[i].id,'add',0);
							}
						} else {
							if (this.args) addBackToQueue(this.args);
							if (item.getAttribute('retry') == 'true') {
								retry = true;
							} else if (!sync.code) {
								showInfo('sync signin');
								setSync('login');
							}
						}

					} else if (item.nodeName == 'updated') {

						sync.updated = parseInt(item.getAttribute('value'),10);
						if (window.widget) widget.setPreferenceForKey(sync.updated,'syncupdated');

					} else if (item.nodeName == 'offset') {

						sync.offset = parseFloat(item.getAttribute('value'));
						if (window.widget) widget.setPreferenceForKey(sync.offset,'syncoffset');

					} else if (item.nodeName == 'delivery') {

						var id = (item.getAttribute('uuid')) ? item.getAttribute('uuid') : getUUID();
						var updated = (item.getAttribute('updated')) ? item.getAttribute('updated') : 0;

						if (removeFromQueue(id,updated)) {

							var from = item.getAttribute('from');
							var name = item.getAttribute('name');
							var no = item.getAttribute('no');
							var extra = item.getAttribute('extra');
							var date = item.getAttribute('date');
							var deleted = (item.getAttribute('deleted') > 0) ? true : false;
							var service = false;

							if (deleted) {
								prepareDelivery(id,true);
							} else if (service = setService(false,from,no)) {
								if (window.widget) {
									var now = getUnixTime();
									widget.setPreferenceForKey(service.from,id+'-store');
									widget.setPreferenceForKey(name,id+'-itemname');	
									widget.setPreferenceForKey(no,id+'-orderno');
									widget.setPreferenceForKey(extra,id+'-email');
									widget.setPreferenceForKey(now,id+'-modified');
									if (from == 'other') widget.setPreferenceForKey(date,id+'-date');
								}
								updateHistory(id);
								prepareDelivery(id,false);
								sync.updateAfter = true;
							}

						}

					} else if (item.nodeName == 'updatedata') {

						updateData = item.textContent;
				
					} else if (item.nodeName == 'updateversion') {
				
						updateVersion = parseInt(item.getAttribute('value'),10);
				
					} else if (item.nodeName == 'updateavail') {

						if (item.getAttribute('value') == 'false') markDefsUpdated();

					}
				}
				break;
			}
		}
	}

	sync.success = success;
	sync.retry = retry;
	if (currentSide == 'front') animateQueues();

	var willContinue = false;
	if (sync.success) {
		if (currentSide == 'back' && currentView.split(' ')[0] == 'sync') setSync('login');
		sync.first = (sync.first == 1) ? 2 : 0;
	}
	if (updateData) {
		verifyUpdateData(updateData,updateVersion);
	} else syncFinish();

}

function syncFail (item) {
	addBackToQueue(item);
	sync.success = false;
	syncFinish();
}

function syncFinish () {
	if (shouldContinue()) {
		continueSync();
	} else if (!sync.success && sync.retry) {
		// if (DeliveryStatus) DeliveryStatus.deletePassword('junecloud.com',appId);
		sync.code = '';
		startSyncNow();
	} else {
		if (sync.updateAfter) {
			updateDeliveries(false,true);
			sync.updateAfter = false;
		} else showTime(false);

		if (window.widget && typeof JSON.stringify == 'function') {
			if (syncQueue.length) {
				widget.setPreferenceForKey(JSON.stringify(syncQueue),'syncqueue');
			} else widget.setPreferenceForKey(null,'syncqueue');
		}
	}
}

function logOut () {

	// TODO: the sync client is actually added back when the server responds to the logout request.
	// Not sure that's really a problem though?

	syncDelivery('','logout',0);
	// if (DeliveryStatus) DeliveryStatus.deletePassword('junecloud.com',appId);
	if (window.widget) {
		widget.setPreferenceForKey(null,'syncemail');
		widget.setPreferenceForKey(null,widget.identifier+'-syncclient');
		widget.setPreferenceForKey(null,'syncupdated');
	}
	sync.email = '';
	sync.password = false;
	sync.client = '';
	sync.code = '';
	sync.updated = 0;
	sync.success = false;
	$('syncemail').value = '';
	$('syncpassword').value = '';
	setSync('login');
}

function verifyUpdateData ( updateData, updateVersion ) {

	sync.loadPage('http://verify.junecloud.com/'+updateVersion,function(){

			if (DeliveryStatus && DeliveryStatus.getMD5(updateData) == this.responseText) {
				var defsPath = DeliveryStatus.saveDefinitions(updateData);
				if (defsPath) {
					markDefsUpdated();
					defsVersion = updateVersion;
					if (window.widget) {
						widget.setPreferenceForKey(defsVersion,'defs');
						widget.setPreferenceForKey(defsPath,'defspath');
					}
					if (document.getElementsByTagName('head')[0].removeChild($('definitions'))) {
						loadDefinitions('file://'+encodeURI(defsPath),false);
					}
				}
			} else alert('Update MD5 does not match!');
			syncFinish();
	
		},false,false);

}

function markDefsUpdated () {
	defsUpdate = getUnixTime();
	if (window.widget) widget.setPreferenceForKey(defsUpdate,'defsupdate');
}

function loadDefinitions (src,firstLoad) {

	element = document.createElement('script'); 
	element.src = src + '?' + defsVersion;
	element.type = 'text/javascript';
	element.charset = 'utf-8';
	element.id = 'definitions';

	var loadAction;
	if (firstLoad) {
		loadAction = function(){ loadDeliveries(); };
	} else {
		loadAction = function(){
			for (var i in deliveries) deliveries[i].setUpdatableFunctions();
			updateDeliveries(true,true);
		};
	}
	element.onload = loadAction;

	document.getElementsByTagName('head')[0].appendChild(element);

}

function resetDefinitions () {
	if (DeliveryStatus) DeliveryStatus.resetDefinitions();
	defsVersion = defsLocal;
	defsUpdate = 0;
	if (window.widget) {
		widget.setPreferenceForKey(null,'defs');
		widget.setPreferenceForKey(null,'defsupdate');
	}
}

function NSLog (text) { alert(text); }

// WebKit Version Detection
// http://trac.webkit.org/projects/webkit/wiki/DetectingWebKit

function webKitVersion () {
    var webKitFields = RegExp("( AppleWebKit/)([^ ]+)").exec(navigator.userAgent);
    if (!webKitFields || webKitFields.length < 3) return null;
    var versionString = webKitFields[2];
    var isNightlyBuild = versionString.indexOf("+") != -1;
    var invalidCharacter = RegExp("[^\\.0-9]").exec(versionString);
    if (invalidCharacter) versionString = versionString.slice(0,invalidCharacter.index);
	// This will drop some numbers, but it's close enough. 530.19.2 becomes 530.19
    return parseFloat(versionString);
}

function macOSVersion () {
    var osXFields = RegExp("Mac OS X ([0-9_]+)").exec(navigator.userAgent);
    if (!osXFields || osXFields.length < 2) return '';
    return osXFields[1].split('_').join('.');
}

// https://github.com/douglascrockford/JSON-js
// 2011-02-23
// Needed for 10.5.x when Safari 5 is not installed

var JSON;
if (!JSON) {
    JSON = {};
}

(function () {

    "use strict";

    function f(n) {
        return n < 10 ? '0' + n : n;
    }

    if (typeof Date.prototype.toJSON !== 'function') {
        Date.prototype.toJSON = function (key) {
            return isFinite(this.valueOf()) ?
                this.getUTCFullYear()     + '-' +
                f(this.getUTCMonth() + 1) + '-' +
                f(this.getUTCDate())      + 'T' +
                f(this.getUTCHours())     + ':' +
                f(this.getUTCMinutes())   + ':' +
                f(this.getUTCSeconds())   + 'Z' : null;
        };
        String.prototype.toJSON      =
            Number.prototype.toJSON  =
            Boolean.prototype.toJSON = function (key) {
                return this.valueOf();
            };
    }

    var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        gap,
        indent,
        meta = {    // table of character substitutions
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        },
        rep;

    function quote(string) {
        escapable.lastIndex = 0;
        return escapable.test(string) ? '"' + string.replace(escapable, function (a) {
            var c = meta[a];
            return typeof c === 'string' ? c :
                '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
        }) + '"' : '"' + string + '"';
    }

    function str(key, holder) {

        var i,          // The loop counter.
            k,          // The member key.
            v,          // The member value.
            length,
            mind = gap,
            partial,
            value = holder[key];

        if (value && typeof value === 'object' &&
                typeof value.toJSON === 'function') {
            value = value.toJSON(key);
        }

        if (typeof rep === 'function') {
            value = rep.call(holder, key, value);
        }

        switch (typeof value) {
        case 'string':
            return quote(value);
        case 'number':
            return isFinite(value) ? String(value) : 'null';
        case 'boolean':
        case 'null':
            return String(value);
        case 'object':
            if (!value) {
                return 'null';
            }

            gap += indent;
            partial = [];

            if (Object.prototype.toString.apply(value) === '[object Array]') {
                length = value.length;
                for (i = 0; i < length; i += 1) {
                    partial[i] = str(i, value) || 'null';
                }

                v = partial.length === 0 ? '[]' : gap ?
                    '[\n' + gap + partial.join(',\n' + gap) + '\n' + mind + ']' :
                    '[' + partial.join(',') + ']';
                gap = mind;
                return v;
            }

            if (rep && typeof rep === 'object') {
                length = rep.length;
                for (i = 0; i < length; i += 1) {
                    if (typeof rep[i] === 'string') {
                        k = rep[i];
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            } else {
                for (k in value) {
                    if (Object.prototype.hasOwnProperty.call(value, k)) {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            }

            v = partial.length === 0 ? '{}' : gap ?
                '{\n' + gap + partial.join(',\n' + gap) + '\n' + mind + '}' :
                '{' + partial.join(',') + '}';
            gap = mind;
            return v;
        }
    }

    if (typeof JSON.stringify !== 'function') {
        JSON.stringify = function (value, replacer, space) {

            var i;
            gap = '';
            indent = '';

            if (typeof space === 'number') {
                for (i = 0; i < space; i += 1) {
                    indent += ' ';
                }
            } else if (typeof space === 'string') {
                indent = space;
            }

            rep = replacer;
            if (replacer && typeof replacer !== 'function' &&
                    (typeof replacer !== 'object' ||
                    typeof replacer.length !== 'number')) {
                throw new Error('JSON.stringify');
            }

            return str('', {'': value});
        };
    }

    if (typeof JSON.parse !== 'function') {
        JSON.parse = function (text, reviver) {

            var j;

            function walk(holder, key) {
                var k, v, value = holder[key];
                if (value && typeof value === 'object') {
                    for (k in value) {
                        if (Object.prototype.hasOwnProperty.call(value, k)) {
                            v = walk(value, k);
                            if (v !== undefined) {
                                value[k] = v;
                            } else {
                                delete value[k];
                            }
                        }
                    }
                }
                return reviver.call(holder, key, value);
            }

            text = String(text);
            cx.lastIndex = 0;
            if (cx.test(text)) {
                text = text.replace(cx, function (a) {
                    return '\\u' +
                        ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
                });
            }

            if (/^[\],:{}\s]*$/
                    .test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, '@')
                    .replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']')
                	.replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                j = eval('(' + text + ')');
                return typeof reviver === 'function' ?
                    walk({'': j}, '') : j;
            }

            throw new SyntaxError('JSON.parse');

        };
    }

}());